var cameraFacade = function () {
    // this.pictureSource;   // picture source
    // this.destinationType; // sets the format of returned value

    this.initialize = function() {
        // document.addEventListener("deviceready",onDeviceReady,false);
        console.log("cameraTest initialized");
    }


    this.onPhotoDataSuccess = function (imageData) {
        var obj = $('.smallImage');
        smallImage.style.display = 'block';

        // Show the captured photo
        // The inline CSS rules are used to resize the image
        //
        smallImage.src = "data:image/jpeg;base64," + imageData;
    }

    // Called when a photo is successfully retrieved
    //
    this.onPhotoURISuccess = function(imageURI) {
        // Uncomment to view the image file URI
        // console.log(imageURI);

        // Get image handle
        //
        var largeImage = document.getElementById('largeImage');


        var obj = $('.largeImage');
        obj.attr('src', "data:image/jpeg;base64,"+imgData);
        obj.attr('style', 'display: block;');

    }

    // A button will call this function
    //
    this.capturePhoto = function() {
        // Take picture using device camera and retrieve image as base64-encoded string
        this.getPhotoFromDevice(this.onPhotoDataSuccess, { destinationType: Camera.DestinationType.DATA_URL, quality: 50 });
    }

    // A button will call this function
    //
    this.capturePhotoEdit = function() {
        // Take picture using device camera, allow edit, and retrieve image as base64-encoded string
        this.getPhotoFromDevice(this.onPhotoDataSuccess, { destinationType: Camera.DestinationType.DATA_URL, quality: 20, allowEdit: true });
    }

    this.getPhotoFromPhotoLibrary = function() {
        this.getPhoto(0); // cf.pictureSource.PHOTOLIBRARY
    }

    this.getPhotoFromSavedPhotoAlbum = function() {
        this.getPhoto(2); // cf.pictureSource.SAVEDPHOTOALBUM
    }

    // A button will call this function
    //
    this.getPhoto = function (source) {
        var options =  {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: source
        };
        this.getPhotoFromDevice(this.onPhotoURISuccess, options);
    }

    this.getPhotoFromDevice = function(callback, options) {
        console.log("getPhotoFromDevice", options);
        if (!navigator.camera) {
            console.log("Camera API not supported");
            alert("Camera API not supported", "Error");
            return;
        }

        console.log("will try to obtain picture using getPicture method")

        // Retrieve image file location from specified source
        navigator.camera.getPicture(callback, this.onFail, options);

    }

    // Called if something bad happens.
    //
    this.onFail = function(message) {
        console.log("onFail", message);
        alert('Failed because: ' + message);
    }

    this.initialize();
};