/**
 * function to emulate Java String.format function (params inside string must be {0}, {1},... not %d and %s)
 */
String.format = function ( )
{
	var s = arguments[ 0 ];
	if ( $.isArray( arguments[ 1 ] ) ) {
		for ( var i = 0, len = arguments[ 1 ].length; i < len; i++ ) {
			var reg = new RegExp("\\{" + i + "\\}", "gm");
			s = s.replace(reg, arguments[ 1 ][ i ]);
		}
	} else {
		for ( var i = 0, len = arguments.length - 1; i < len; i++ ) {
			var reg = new RegExp( "\\{" + i + "\\}", "gm" );
			s = s.replace(reg, arguments[ i+1 ]);
		}
	}
	return s;
};

/**
* function to get a date in specific format
*/
function getDateFormatted( daystamp )
{
    if(!/^(\d){8}$/.test(daystamp))
    	return daystamp;
    var date = parseDateFromYYYYMMDD("" + daystamp);
    return date.getDate() +" "+ gjson_lang["month_" +date.getMonth()].substring(0,3) +" "+ date.getFullYear();
}

function getDateFormatted2( daystamp )
{
    var date = parseDateFromYYYYMMDD("" + daystamp);
    return date.getDate() +" "+ gjson_lang["month_" +date.getMonth()].substring(0,3);
}

function getDateFormatted3( daystamp )
{
    var date = parseDateFromYYYYMMDD("" + daystamp);
    return date.getDate() +" "+ gjson_lang["month_" +date.getMonth()];
}

function getDateFormatted4( daystamp )
{
    var date = parseDateFromYYYYMMDD("" + daystamp);
    return date.getDate() +"</br>"+ gjson_lang["month_short_" +date.getMonth()];
}

function parseDateFromYYYYMMDD(str) {
    return new Date(str.substr(0,4),
    				str.substr(4,2) - 1,
    				str.substr(6,2));
}

function getDayFormated( time_seconds )
{
	var str_date = null;

	if (time_seconds) {
		var date = new Date(time_seconds*1000);
		str_date = date.getDate() + gjson_lang["week_day_" +date.getDay()];
	}

	return str_date;
}

function getDayFormatedv2( vdate )
{

	var str_date = null;

	if (vdate) {
		//var date = new Date(date);
		var date = new Date(String(vdate).substring(0, 4), String(vdate).substring(4, 6)-1, String(vdate).substring(6, 8));
		str_date = date.getDate() + gjson_lang["week_day_" +date.getDay()];
	}

	return str_date;
}

function yyyymmdd(date) {
	var yyyy = date.getFullYear().toString();
	var mm = (date.getMonth()+1).toString();
	var dd = date.getDate().toString();
	return yyyy + (mm[1]?mm:"0"+mm) + (dd[1]?dd:"0" + dd);
}

function precise_round(num, decimals) {
    var t=Math.pow(10, decimals);   
    return (Math.round((num * t) + (decimals>0?1:0)*((10 / Math.pow(100, decimals)))) / t).toFixed(decimals).replace(".00","");
}

/**** funcion para pasar de formato 1.000 a 1K ******/
function abbrNum(number, decPlaces) {
    // 2 decimal places => 100, 3 => 1000, etc
    decPlaces = Math.pow(10,decPlaces);

    // Enumerate number abbreviations
    var abbrev = [ "k", "m", "b", "t" ];

    // Go through the array backwards, so we do the largest first
    for (var i=abbrev.length-1; i>=0; i--) {

        // Convert array index to "1000", "1000000", etc
        var size = Math.pow(10,(i+1)*3);

        // If the number is bigger or equal do the abbreviation
        if(size <= number) {
             // Here, we multiply by decPlaces, round, and then divide by decPlaces.
             // This gives us nice rounding to a particular decimal place.
             number = Math.round(number*decPlaces/size)/decPlaces;

             // Handle special case where we round up to the next abbreviation
             if((number == 1000) && (i < abbrev.length - 1)) {
                 number = 1;
                 i++;
             }

             // Add the letter for the abbreviation
             number += abbrev[i];

             // We are done... stop
             break;
        }
    }

    return number;
}
