// Para no contaminar el global namespace creamos un namespace nire.
var Nire = {};

var PAGE_LOGIN = "login2.html";

// valores limites de los datos de la biografia
var VALUES_LIMITS = {
    weight: {max: 300, min: 30},
    height: {max: 220, min: 60},
    age: {max: 105, min: 15}
}

//
// Secciones que componen la aplicación y pueden ser activadas o desactivadas dependiendo
// de la integración y del servidor. (Lo utiliza Nire.Connection.configureEnabledSections y flia)
//
KNOWN_SECTIONS = ["PHYSICAL", "NUTRITION", "HEALTH", "TREATMENT", "CLINIC", "COACH", "SHOPPINGLIST", "KNOWLEDGE", "WEARABLES", "NEWS"];

//
// Las siguientes secciones estarán deshabilitadas, a menos que el servidor
// informe lo contrario
//
DISABLED_SECTIONS = KNOWN_SECTIONS; //["*"]; //CLINIC", "COACH", "SHOPPINGLIST", "TREATMENT", "HEALTH", "KNOWLEDGE"];

//
// En Login2, EMAIL y BOTH son sinónimos. (No se soprota email sin password)
//
var LOGIN_METHOD = "BOTH" //Login method, avalaible "PASSWORD", "EMAIL" or "BOTH"

//
//Apps de google play para abrir PDFs
//
var DEFAULT_APP_PDF = "com.adobe.reader";
var APPS_PDF_LIST = [
                'com.adobe.reader', 
                'com.google.android.apps.pdfviewer',
                'com.infraware.office.link',
                'pdf.reader',
                'com.foobnix.pdf.reader',
                'com.mobisystems.office',
                'com.seeke.pdfreader',
                'com.kdanmobile.android.pdfreader.google.pad',
                'com.foxit.mobile.pdf.lite',
                ];

// Cada cuanto tiempo se hace una consulta al servidor para chequear el estado.
//
// Este valor tiene que ser menor al valor de Timeout del servidor para que funcione siempre, de lo contrario el servidor
// desloguea al usuario por falta de actividad y las siguientes notificaciones dan error.
var MONITOR_POOL_INTERVAL = moment.duration(4, "minutes").asMilliseconds();

//
// Tiempo default de timeout para las conexiones ajax.
//
var CONNECTION_TIMEOUT = moment.duration(3, "seconds").asMilliseconds();

//
// Tracking ID para Google Analytics
//
var GOOGLE_ANALYTICS_TRACKING_ID = "UA-56411801-1";

//
// SenderID de la aplicación de Android para recibir notificaciones PUSH
//
var GOOGLE_SENDER_ID = "606551403580";

//
// Cuando se utiliza Nire.AsyncQueue para encolar peticiones ajax concurrentes.
// Esto se utiliza por ejemplo, a acceder al Home para pedir anticipadamente los detalles de todas las actividades
//
var ASYNC_QUEUE_SIZE = 3;

//
// Si esta variable es TRUE al acceder al home y otras páginas se cargarán en caché otras
// paginas relacionadas que el usuario podría visitar a continuación
//
var PREFETCH = true;

//
// Configuaciones de Nuance Dragon Dictate
//
var NUANCE_LANG = "es_ES";
// var NUANCE_SERVER = ""; // DEFAULT SANDBOX (sandbox.nmdp.nuancemobility.net)
var NUANCE_APPID = "NMDPTRIAL_aitor_nire20150323124808";
var NUANCE_SECRET = "501912aeb4ee6f43ce1bf3215d796e5b042337f0f527b6a6c3205f84c283f4139c06c150f53093c34b86e4a8ff520404753bf46a62aa1025ca6faa8cf29e9f8f";

var JSON_TYPE = "json";
var SHARE_APP_URL = "";
var SERVER_VERSION="1.1"
var CALIF_MAXIMA = 4;
var CACHE_HOURS = 5;
var CREDENTIALS_HASH = "app_credentials_hash";
var CREDENTIALS_USERNAME = "app_credentials_username";
var CREDENTIALS_DOCUMENT_TYPE = "app_credentials_doctype";
var APP_DATE_STATE = "app_date_state";
var TERMS_OF_USE = "app_terms_of_use";
var URL_MENU_HOME = URL_JSON_READER +"home/menuHome.json";
var URL_PAGE_HOME = URL_JSON_READER +"home/{0}/pageHome.json";
var URL_PAGE_TIMELINE = URL_JSON_READER +"timeline/{0}";
var URL_USER_PROFILE = URL_JSON_READER + "home/userProfile.json";
var URL_HEALTH_INDICATOR = URL_JSON_READER +"health/healthIndicator.json";
var URL_HEALTH_TREATMENT = URL_JSON_READER +"health/healthTreatment.json";
var URL_HEALTH_TREATMENT_DETAIL = URL_JSON_READER +"health/treatmentDetail/{0}/healthTreatmentDetail.json";
var URL_HEALTH_HELP = URL_JSON_READER +"health/healthHelp.json";
var URL_INDICATOR_DETAIL = URL_JSON_READER +"health/indicatorDetail/{0}/indicatorDetail.json";
var URL_NUTRITION_HOME = URL_JSON_READER +"nutrition/nutritionHome.json";
var URL_NUTRITION_DETAIL = URL_JSON_READER +"nutrition/nutritionDetail/{0}/nutritionDetail.json";
var URL_NUTRITION_DETAIL_RATE = URL_JSON_READER +"nutrition/nutritionDetail/{0}/nutritionDetailRate.json";
var URL_NUTRITION_HELP = URL_JSON_READER +"nutrition/nutritionHelp.json";
var URL_NUTRITION_WEEKLY = URL_JSON_READER +"nutrition/{0}/nutritionWeekly.json";
var URL_NUTRITION_RATE = URL_JSON_WRITER + "nutrition/ratePlate"
var URL_PHYSICAL_ACTIVITY_WEEKLY = URL_JSON_READER +"physical_activity/{0}/physicalActivityWeekly.json";
var URL_PHYSICAL_ACTIVITY_HOME = URL_JSON_READER +"physical_activity/physicalActivityHome.json";
var URL_PHYSICAL_ACTIVITY_DETAIL = URL_JSON_READER +"physical_activity/physicalActivityDetail/{0}/physicalActivityDetail.json";
var URL_PHYSICAL_ACTIVITY_STEPS = URL_JSON_READER +"physical_activity/physicalActivityDetail/{0}/physicalActivitySteps.json";
var URL_PHYSICAL_ACTIVITY_HELP = URL_JSON_READER +"physical_activity/physicalActivityHelp.json";
var URL_DEVICE_WEARABLES = URL_JSON_WRITER +"newTrack/wearables/wearables.json";
var URL_APP_REFRESH = URL_JSON_READER + "validic/syncApp"
var URL_NEW_TRACK_NUTRITION = URL_JSON_READER +"newTrack/nutrition/{0}/newTrackNutrition.json";
var URL_NEW_TRACK_NUTRITION_FOOD = URL_JSON_READER +"newTrack/nutrition/foodlist/{0}/newTrackNutritionFood.json";
var URL_NEW_TRACK_HEALTH= URL_JSON_READER +"newTrack/health/{0}/newTrackHealth.json";
var URL_NEW_TRACK_PHYSICAL_ACTIVITY = URL_JSON_READER +"newTrack/physicalActivity/{0}/newTrackPhysicalActivity.json";
var URL_PREGUNTAS_PENDIENTES = URL_JSON_READER + "formulario/pendientes.json";
var URL_PREGUNTAS_RESPONDIDAS = URL_JSON_READER + "formulario/respondidas.json";
var URL_PREGUNTAS = URL_JSON_READER + "formulario/preguntas.json";
var URL_PREGUNTA_NUEVA = URL_JSON_READER + "formulario/pregunta/{0}.json";
var URL_GENERAR_DIETA = URL_JSON_WRITER + "assign/generateDiet";
var URL_REGENERAR_DIETA = URL_JSON_WRITER + "assign/regenerateDietPetiton";
var URL_NOTIFICATIONS = URL_JSON_READER + "notification/pending/{0}";
var URL_NOTIFICATIONS_COUNT = URL_JSON_READER + "notification/check/{0}";
var URL_REPLY_NOTIFICATION = URL_JSON_WRITER + "notification/reply";
var URL_LOGIN = URL_JSON_WRITER + "login/login";
var URL_TRY_LOGIN = URL_JSON_WRITER + "login/tryLogin";
var URL_TOKEN_LOGIN = URL_JSON_WRITER + "login/tokenLogin";
var URL_ENABLED_SECTIONS = URL_JSON_WRITER + "session/configuration";
var URL_SEND_EMAIL = URL_JSON_WRITER + "login/sendEmailLogin";
var URL_PASSWORD_RECOVER = URL_JSON_READER + "login/recoverPassword";
var URL_GET_TREATMENT = URL_JSON_READER + "treatment/detail/{0}";
var URL_GET_TREATMENT_LIST = URL_JSON_READER + "treatment/list";
var URL_USER_CHECK_UPDATE = URL_JSON_READER + "session/userUpdated";
var URL_REGISTRY_DEVICE = URL_JSON_WRITER + "registry/device";

var URL_RESPUESTA = URL_JSON_WRITER + "formulario/respuesta";
var URL_UPDATE_TRACK = URL_JSON_WRITER +"home/updateTrack.json";
var URL_PHYSICAL_ACTIVITY_NEW = URL_JSON_WRITER + "newTrack/physicalActivity/new";
var URL_HEALTH_NEW = URL_JSON_WRITER + "newTrack/health/new";
var URL_MEDICINE_NEW = URL_JSON_WRITER + "newTrack/medicine/new";
var URL_REGISTRY_BIOGRAPHY = URL_JSON_WRITER + "registry/biography";
var URL_OBTAIN_BIOGRAPHY = URL_JSON_WRITER + "registry/obtainBiography";


//
// Legacy. Agregar un plato customizado al timeline
// Utilizar en lugar de esta llamada URL_NUTRITION_ADD de ser posible
//
var URL_NUTRITION_NEW = URL_JSON_WRITER + "newTrack/nutrition/new";

//
// Agrega un plato al timeline del usuario.
//
// A diferecia de URL_NUTRITION_NEW se puede agregar cualquier plato
// de acuerdo a su id, no es necesario utilizar las categorias hardcodeadas
//
var URL_NUTRITION_ADD = URL_JSON_WRITER + "track/nutrition/add";

//
// Borra un plato agregado por el usuario
//
var URL_NUTRITION_DELETE = URL_JSON_WRITER + "track/nutrition/delete";


var URL_APP_HELP = URL_JSON_READER +"home/helpImages";
var URL_PILLBOX = URL_JSON_READER +"treatment/{0}/pillbox";

var URL_PAGE_TIMELINE = URL_JSON_READER +"timeline/{0}";
var URL_PAGE_TIMESLOTS = URL_JSON_READER +"timeslots/timeslots.json";

var URL_SAVE_MEDWHAT_LOG = URL_JSON_WRITER + "registry/medwhatLog";

var URL_CLINIC_HISTORY = URL_JSON_READER + "health/clinicHistory/{0}/clinicHistory.json";
var URL_CLINIC_HISTORY_EXPLORER = URL_JSON_READER + "health/clinicHistory/{0}/clinicExplorer.json";
var URL_CLINIC_HISTORY_EXPLORER_DETAIL = URL_JSON_READER + "health/clinicHistory/{0}/{1}/clinicExplorerDetail.json";

var URL_PERSONAL_ASSISTANT = URL_JSON_READER + "coach/cards";

//
// Urls y datos para poder consultar a medwhat
//
var URL_MEDWHAT_SESSION = "http://medwhat.com:8080/mwapi/services/session/get"
var URL_MEDWHAT_QUESTION = "http://medwhat.com:8080/mwapi/services/qa/search"
var MEDWHAT_EMAIL = "support@nire.co"
var MEDWHAT_PASSWORD = "mwnire2015@"
var MEDWHAT_PASSCODE = "mwnirepc2015#"

//
// Esta URL es la que se invoca cuando se hace click sobre un botón en una notificación PUSH.
// Aquellos botones que tienen un token, no abren la aplicación, pero en su lugar es llamada
// esta URL para que procese el comando relacionado.
//
// Como el comando puede ser cualquier cosa, por ejemplo el informar que se tomó una medicina.
// es que utilizamos la url del WRITER
//
var URL_PROCESS_COMMAND = URL_JSON_WRITER +"process/processCommand";

var APP_VERSION = "1.0"; // Will be overwritten when started

// This value will be overwritten by the build system
var BUILD_VERSION_CODE = "not-automatically-generated";

// Added by jenkins

var BUILD_VERSION_CODE = "nire-nih-es-prod-13x_b271_r2339";
