/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/contentMedWhatConsultor.css"/>');

/* VARIABLES */
var contentMedWhatConsultor = {
				
	$str_consult: null,
    $template_consult: Handlebars.compile($('#template-medwhat_consultor').html()),
	
	createHeader: function()
    {
		var template = Handlebars.compile($("#template-medwhat_consultor_header").html());
        
		contentMedWhatConsultor.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template() ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },
    
    createFooter: function()
    {
        var template = Handlebars.compile($("#template-medwhat_consultor_footer").html());

        $( "#footer_app_direct_communicator" ).html( template({
            search_placeholder: this.getStandarSearchPlaceholder(),
            search_txt: this.getStandarSearchTxt()
        }) );
        
        $( "#footer_app_direct_communicator" ).toolbar( "refresh" ).show();

        $.mobile.resetActivePageHeight();
    },

    reloadData: function()
    {
        lscache.setBucket(Nire.connection.currentUsername + "medwhat");
        var storedData = lscache.get("datos_consult");
        lscache.setBucket("");

        if(storedData) {
            var dateLimit = moment().subtract(2, 'days');
            $.each(storedData, function(idx, item) {
                if(moment(item.date).isAfter(dateLimit)) {
                    contentMedWhatConsultor.printQuestionAndAnswer(item.query_txt, item.answer_txt)
                }
            })
        }
    },

    printConsult: function(json, str_query)
    {
        var datos_consult = { query_txt: str_query, date: moment() };
        datos_consult.answer_txt = json.source ? json.answer : i18n("medwhat_empty_answer");

        lscache.setBucket(Nire.connection.currentUsername + "medwhat");
        var storedData = lscache.get("datos_consult");
        if(!storedData) storedData = [];
        storedData.push(datos_consult);
        lscache.set("datos_consult", storedData);
        lscache.setBucket("");

        this.printQuestionAndAnswer(datos_consult.query_txt, datos_consult.answer_txt);
        
        Nire.connection.saveMedWhatLog(datos_consult.query_txt, datos_consult.answer_txt);
    },

    /**
     * Mostrar un texto de respuesta de MedWhat
     */
    printAnswer: function(answer) {
        this.printQuestionAndAnswer(null, answer);
    },

    /**
     * Mostrar una pregunta y su respuesta de MedWhat
     * Si question o Answer es falsy value no se mostrará la sección correspondiente.
     */
    printQuestionAndAnswer: function(question, answer) {
        var datos_consult = { query_txt: question, answer_txt: answer };

        // Generamos los elementos del DOM y le asociamos al información de este elemento
        // para despues poder recuperar toda la información del servidor
        var consult = $( this.$template_consult(datos_consult) );

        // Agregamos el las consulstas al contenedor
        $("#content_app_direct_communicator").append( consult ).trigger( "updatelayout" );

        var $last_element_offset = $("#content_app_direct_communicator .consult_wrapper:last").offset();
        if ($last_element_offset)
            $.mobile.silentScroll($last_element_offset.top - 50);
    },

    getInfo: function(q) {
        var _this = this
        this.disableQueryInput().val(q);

    	showLoading();
        $str_consult = q;

        Nire.connection.getMedWhatSession().done(function(sessionData) {
            Nire.connection.medWhatConsultor(sessionData.sessionId, q)
                .done(function(json_response) { contentMedWhatConsultor.printConsult(json_response, $str_consult); })
                .fail(function(obj) { 
                    var ans = {answer: i18n("medwhat_consultor_error"), source: true}
                    contentMedWhatConsultor.printConsult(ans, $str_consult); 
                })
                .always(function() { 
                    hideLoading(); 
                    _this.enableQueryInput().val("");
                });
        }).fail(function(obj) { 
            var ans = {answer: i18n("medwhat_consultor_error"), source: true}
            contentMedWhatConsultor.printConsult(ans, $str_consult); 
            hideLoading(); 
            _this.enableQueryInput().val("");
        })

        /*
        url = serv + port +"/engine4_release/search_engine.jsp?q=" + q + "&passcode=mwt!";

        Nire.connection.medWhatConsultor(url)
            .done(function(json_response) { contentMedWhatConsultor.printConsult(json_response, $str_consult); })
            .fail(function(obj) { 
                var ans = {answer: i18n("medwhat_consultor_error"), source: true}
                contentMedWhatConsultor.printConsult(ans, $str_consult); 
            })
            .always(function() { 
                hideLoading(); 
                _this.enableQueryInput().val("");
            });
        */
    },

    /**
     * Deshabilitar el área de consulta de Nuance.
     *
     * Cuando se esta en proceso de reconocimiento de voz o búsqueda en Nuance llamar a este método para
     * indicar que se está realizando un proceso y temporalmente no estará disponible.
     *
     * @returns el input para que se pueda seguir modificando, por ejemplo agregarle un valor.
     */
    disableQueryInput: function() {
        $(document).off("click.app_direct_communicator", "#medwhat_consultor_speech");
        return $(".ui-block-a .filterBasic-input").prop('disabled', true);

    },

    /**
     * Habilitar el área de consulta de Nuance.
     *
     * @returns el input para que se pueda seguir modificando, por ejemplo agregarle un valor.
     */
    enableQueryInput: function() {
        $(document).on("click.app_direct_communicator", "#medwhat_consultor_speech", function() {
            contentMedWhatConsultor.startSpeechRecognition();
        });

        this._updateInput("RecoComplete")        
        return $(".ui-block-a .filterBasic-input")
            .prop('disabled', false);
    },

    _logCallback: function(name)
    { 
        return function() { console.log("MedWhatHelp", name, arguments[0]); };
    },

    getStandarSearchPlaceholder: function()
    {
    	return i18n("medwhat_consultor_placeholder");
    },
    
    getStandarSearchTxt: function()
    {
    	return i18n("medwhat_consultor_text");
    },

    /**
     * Iniciar e proceso de reconocimiento de voz
     */
    startSpeechRecognition: function() {
        // Si no tenemos el plugin de Nuance lo informamos y salimos sin hacer nada.
        if(!window.NuancePlugin) {
            showToast("Automatic speech recognition plugin not installed.");
            return;
        };

        this._initNuance();
        this._startDictation();
    },

    /**
     * Inicializar nuance.
     */
    _initNuance: function() {
        var serverName = "sandbox.nmdp.nuancemobility.net";
        if(typeof NUANCE_SERVER !== "undefined") serverName = NUANCE_SERVER;
            
        var port = 443;
        var sslEnabled = false;
        NuancePlugin.initialize(serverName, port, sslEnabled, NUANCE_APPID, NUANCE_SECRET, this._logCallback("Init Success"), this._logCallback("Failure"));
    },

    /**
     * Pedirle a Nuance que comience a escuchar y procesar
     */
    _startDictation: function() {
        this.disableQueryInput().val("");

        var recognitionType = "dictation";
        var recognitionLanguage = NUANCE_LANG;

        NuancePlugin.startRecognition(
            recognitionType, 
            recognitionLanguage, 
            this._speechProgress.bind(this),

            // en caso de error
            function(errorObject) {
                console.log(errorObject);
                this._informError( i18n('medwhat_recognition_failed') )
            }.bind(this)
        );
    },

    /**
     * Callback de NUANCE cada vez que cambia de estado o progresa el reconocimiento
     * Es un callback ! Cuidado con el uso de this !
     */
    _speechProgress: function(params) {
        console.log("speechProgress Success", params);
        var eventName = params.event;

        // Ignoramos los eventos de VolumeUpdate
        if(eventName == "RecoVolumeUpdate") return;

        this._updateInput(eventName);

        if(eventName === "RecoComplete") {
            if(params.returnCode === 0) contentMedWhatConsultor.getInfo( params.result );
            else this._informError( i18n("medwhat_recognition_failed"), params );
        }

        if(eventName === "RecoError") {
            this._informError( i18n("medwhat_consultor_error"), params );
        }
    },

    // Nuance no retorno resulatdos o hubo otro error.
    _informError: function(text, params) {
        this.enableQueryInput();
        this.printAnswer(text);
    },  

    _updateInput: function(eventName) {
        var placeholders = {
            RecoStarted: i18n("medwhat_asr_init"),
            RecoProcessing: i18n("medwhat_asr_analyzing"),
            RecoComplete: this.getStandarSearchPlaceholder()
        };

        $(".ui-block-a .filterBasic-input").removeClass("RecoStarted RecoProcessing RecoComplete");
        $(".ui-block-a .filterBasic-input").addClass(eventName);

        $(".ui-block-a .filterBasic-input")
            .val("")
            .attr("placeholder", placeholders[eventName]);
    }
};