/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/contentNotifications.css"/>');

/* VARIABLES */
var contentNotifications = {
		
	$page: null,
	lastNotificationDate: null,
    question: null,
    notificationId: null,
    log: getLogger("Notifications"),
		
    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-notifications_header").html());
    	
    	contentNotifications.$page.find( "#app_header" ).remove();
    	
    	try {
    		$( "#app_header" ).html( template() ).toolbar("refresh").show();
    	} catch (e) {
    		$( "#app_header" ).toolbar().show();
    	}
        
        $.mobile.resetActivePageHeight();
                   
        showNotificationUpdate();
    },
    
    removeFooter: function()
    {
        $( "#footer_app_direct_communicator" ).empty();
        $( "#footer_app_direct_communicator" ).toolbar( "refresh" );
        $( "#footer_app_direct_communicator" ).hide();
        $.mobile.resetActivePageHeight();
    },
    
    getData: function()
    {
    	showLoading();
        return Nire.notification.get().done( function(json) {
            // TODO: descomentar para reactivar la doble pantalla de notificaciones y medwhat
        	if ( /*$("#notifications_content_btn_active")[0] &&*/ contentNotifications )
        		contentNotifications.addContent(json, true);
        });
    },
    
    getNewData: function()
    {
    	return Nire.notification.getNewNotifications().done( function(json) {
            // TODO: descomentar para reactivar la doble pantalla de notificaciones y medwhat
    		//if ($("#notifications_content_btn_active")[0])
    			setTimeout(function(){
    				if (contentNotifications) {
    					contentNotifications.addContent(json);
                        $.each(json.responses, function(index, value) {
                            contentNotifications.printUserAnswer({reply: value.message}, index)
                        }) 
                    }
    			}, 2000);
         });
    },
    
	addContent: function(data, is_first_time)
   	{
		if (is_first_time)
			$("#content_app_direct_communicator").css("visibility", "hidden");
		
        // Es mejor compilar los templates de Handlebars fuera de cualquier iteración
        // Ya que es una operación costosa que necesita ser hecha una única vez.
		var template_date = Handlebars.compile($("#template-notifications_date").html());
        var template_notification = Handlebars.compile($("#template-notification").html());

		var previous_date = contentNotifications.lastNotificationDate || moment(0);
		$.each(data.data, function(i, item)
		{
            // TODO: Se podría quitar, porque el servidor GARANTIZA que todas las notificaciones tienen fecha
			if(!item.date) return;

            var new_date = moment(item.date);
            if (new_date.isAfter(previous_date, "day")) {
                previous_date = new_date;
                $("#content_app_direct_communicator").append(template_date({ date: getDateFormatted3(new_date.format("YYYYMMDD")) }));
            }

            //var action_text = null;
            //var str_path = null;
            //var buttonClass = null;
            var button_type = "";
            var buttons = [];
            var options = [];
            if(!data.responses[String(item.id)]) {
                if(item.button) {
                    if(item.action) {
                        var buttonsData = item.button.split(",");
                        buttonsData.forEach(function(element){
                            var buttonData = element.split("#");
                            options.push({
                                action_url: "#",
                                action_params: "value=" + buttonData[1] + "&notification=" + item.id,
                                action_text: buttonData[0],
                                buttonClass: "replyNotification"
                            });
                        })

                    }else {
                        var buttonData = item.button.split("#");
                        buttons.push({
                            action_url: "#",
                            action_params: "id=" + buttonData[1] + "&date=" + buttonData[2] + "&notification=" + item.id,
                            action_text: buttonData[0],
                            buttonClass: "confirmTreatment"
                        });
                    }
                } else if(item.answer_json){
                    button_type = "2";
                    var buttonData = JSON.parse(item.answer_json.replace(/'/g, "\""));
                    var link = buttonData.link? buttonData.link : buttonData.appLink;
                    var itemButton = {
                        action_url: link,
                        action_text: buttonData.text,
                        action_params: ""
                    }
                    if(buttonData.link) itemButton.external = true;
                    buttons.push(itemButton)
                } else {
                    str_path = (item.action && item.value !== null ) ? contentNotifications.getNotificationActionPath(item.action, item.value, item.id) : null;
                    if(str_path)
                        buttons.push({
                            action_url: str_path.url,
                            action_params: str_path.params,
                            action_text: gjson_lang.notification_message_response
                        });
                }
            }
            var item_notification = {
            		id: item.id,
            		notification_class: (buttons.length  > 0) ? "notification_wrapper_with_action"+button_type : "notification_wrapper",
            		message: item.message,
            		hour: "( "+ new_date.format("HH:mm") +" )",
            		buttons: buttons,
            		options: options,
            		response: (data.responses[String(item.id)]) ? data.responses[String(item.id)].message : null,
                    button_type: ( button_type == "2" ) ? button_type : null
            };

            if ($('#content_app_direct_communicator #'+item.id).length == 0) {
                var $domElement = $(template_notification(item_notification));
            	$("#content_app_direct_communicator .notifications_date_wrapper:last-child").append($domElement);
            	var item_notification_answered = {
	            		id: item_notification.id,
	            		notification_class: "notification_wrapper",
	            		message: item_notification.message,
	            		hour: item_notification.hour,
	            		action_url: null,
	            		action_params: null,
	            		action_text: null,
	            		response: null
            		};
            	$('#content_app_direct_communicator #'+item.id).jqmData("info", item_notification_answered);
                
                // Interceptamos los clicks sobre los links a de las notificaciones
                // para poder reportarlos a Analytics
                //
                // TODO: en lugar de crear un evento por notificacion podría controlar
                // todas las notificaciones en un elemento raiz?
                $domElement.on("click", "a", function() {
                    Nire.analytics.event("click", "notification " + this.href);
                });
            }
            
            contentNotifications.lastNotificationDate = new_date;
            
		});
		
		$("#content_app_direct_communicator").trigger( "updatelayout" );

		if ( is_first_time )
		{
			setTimeout(function(){
				$("#content_app_direct_communicator").css("visibility", "visible");
			}, 100);
		}
		
		showNotificationUpdate();
                     
		hideLoading();
    }, 
	
	getNotificationActionPath: function(action, value, id)
	{
		var str_path = null;
		
		switch(action.toLowerCase()) {
		    case "nutrition":
		        str_path = {
		    		url: "newTrackNutrition2.html"
		    	};
		    break;
		    case "physicalactivity":
		    	str_path = {
		    		url: "newTrackPhysicalActivity.html"
		    	};
		    break;
		    case "health":
		    	str_path = {
		    		url: "newTrackHealth.html"
		    	};
		    break;
		    case "measure":
		    	str_path = {
		    		url: "newTrackHealth.html",
                    params: "?notificationId=" + id
		    	};
		    break;
		    case "question":
		    	str_path = {
		    		url: "#",
		    		params: "?action="+action.toLowerCase() + "&notificationId=" + id
		    	};
		    break;
		    default:
		    	str_path = {
		    		url: action
		    	};
		}
		if (str_path)
			str_path.params = (!str_path.params) ? "?value="+ value : str_path.params +"&value="+ value;
		
		return str_path;
	},

    confirmTrack: function(data, responseText)
    {
        var trackData = data.split("&");
        var trackId = trackData[0].split("=")[1];
        var date = trackData[1].split("=")[1];
        var notification = trackData[2].split("=")[1];

        Nire.connection.updateTrack(date, trackId, "treatment").done(function(response) {
            if(response.data.status = "confirmed")
                contentNotifications.printUserAnswer({reply: responseText}, notification);
        })
    },

    /**
     * Se llama cuando el usuario responde una pregunta. 
     */
    replyNotification: function(data, responseText)
    {
        var self = this;

        var notificationData = data.split("&");
        var value = notificationData[0].split("=")[1];
        var notification = notificationData[1].split("=")[1];

        Nire.connection.replyNotification(value, responseText, notification).done(function() {
            contentNotifications.printUserAnswer({reply: responseText}, notification);
            Nire.notification.deleteRepeatedQuestions(notification);

            //$("#content_app_direct_communicator").empty();
            contentNotifications.lastNotificationDate = moment(0)
            self.getNewData();
        }).fail(function(e){console.log(e)})
    },

	getNewQuestion: function(id, notificationId)
	{
		showLoading();
        Nire.connection.getPreguntaNueva(id)
        	.done(function(data) {
                contentNotifications.question = data;
                contentNotifications.notificationId = notificationId;
        		contentNotifications.createQuestionPopup(data);
            })
            .always(function(){
            	hideLoading();
            });
	},
	
	createQuestionPopup: function(json_question)
	{
		var response_options = Handlebars.compile($("#template-notifications_question_popup_" + json_question.type).html());
		var popup = Handlebars.compile($("#template-notifications_question_popup").html());

		var datos_popup = {
				title: json_question.label,
				response_html: response_options(json_question),
				send_btn_text: gjson_lang.medwhat_consultor_text
			};
		
		contentNotifications.$page.find(".ui-content").append(popup(datos_popup));
		
		$("#notifications_question_popup").find("div:jqmData(role=footer)").toolbar();
		$("#notifications_question_popup").find("fieldset:jqmData(role=controlgroup)").controlgroup();
		$("#notifications_question_popup").find("input[type=text]").textinput();
		$("#notifications_question_popup").popup().popup("open");
	},

    questionResponse: function()
    {
        var respuesta = $("#notifications_question_popup_response").serialize();

        var valor = getQuestionResponseValue(respuesta, this.question)
        if(valor == null) return;

        if( validarRespuesta(this.question.validator, valor)) {
            Nire.connection.respuesta(this.question.id, valor, this.notificationId)
            	.done(function(json_response){
            		contentNotifications.printUserAnswer(json_response.data, contentNotifications.notificationId);
            	})
            	.always(function(){
            		$("#notifications_question_popup").popup("close");
            		Nire.connection.regenerateDietPetiton();
            	});

            Nire.analytics.event( "click", "NotificationQuestion answered", "Question: " + this.question.id );
        }
    },

    scrollToEnd: function() {
        var $last_element_offset = $("#content_app_direct_communicator .notifications_date_wrapper:last-child div[class^='notification_wrapper']:last-child").offset();
        if ($last_element_offset)
            $.mobile.silentScroll($last_element_offset.top);
    },
    
    printUserAnswer: function(data, notificationId)
    {        
    	var item_notification_answered = $("#content_app_direct_communicator #"+ notificationId).jqmData("info");
    	if ( typeof item_notification_answered == "undefined" ) return false;
    	
    	Nire.notification.addAnswer(notificationId, data.reply);
    	
    	item_notification_answered.response = data.reply;
        item_notification_answered.buttons = [];
        item_notification_answered.options = [];
        var nth_child = null;
        var $notification_wrapper = $("#content_app_direct_communicator #"+ notificationId).parent();
        $notification_wrapper.children(":not(.notification_message)").each(function(i)
        {
        	if ( $(this).text().toLowerCase() == data.reply.toLowerCase() )
        	{
        		nth_child = i+2;
        		return false;
        	}
        });
        if ( nth_child != null )
    	{
        	var template_notification = Handlebars.compile($("#template-notification").html());
        
	        $notification_wrapper.children(":not(.notification_message):not(:nth-child("+ nth_child +"))").stop().fadeTo(700, 0, function()
	        {
	        	$(this).remove();
	        	setTimeout(function(){
	        		$new_notification = $(template_notification(item_notification_answered));
	        		$new_notification.children().css("opacity", 0);
	        		$notification_wrapper.replaceWith($new_notification);
	        		$new_notification.children().stop().fadeTo(700, 1);
	        	}, 400);
	        });
    	}else {
            var template_notification = Handlebars.compile($("#template-notification").html());
            $("#"+ notificationId).parent().replaceWith(template_notification(item_notification_answered));
        }
    }
};