/* CORDOVA */

document.addEventListener('deviceready', onDeviceReady, false);

/* COMMON TO ALL PAGES */

$( document ).on( "pagebeforecreate", "div:jqmData(role=page)", function()
{
	$(this).find("div:jqmData(role=footer)").data("visible-on-page-show", true);
});

$( document ).on( "pagecreate", "div:jqmData(role=page)", function()
{
	translatePage($(this));
});

//
//Hook para enviar un evento de analytics cuando se cambia de página
//
$( document ).on("pagecontainerchange", function(event, ui)
{
	Nire.analytics.page( ui.absUrl ); 

	// Guardamos la pagina anterior para poder acceder facilmente a esta informacion
	$.mobile.activePage.data('ui.prevPage', ui.prevPage);

	/* CONTROL PARA LOS ESTADOS ACTIVOS DEL MENÚ LATERAL. SI NAVEGAMOS A SALUD, SE ACTIVA EL MENÚ LATERAL DE SALUD. SI DENTRO DE LA 
	PANTALLA DE SALUD, NAVEGAMOS A LA PANTALLA DE NUTRICIÓN, DEBEMOS ACTIVAR LA SECCIÓN DE NUTRICIÓN DEL MENÚ LATERAL */
	updateActiveSection($( "body" ).pagecontainer( "getActivePage" ));
});

$( document ).on("click", "a", function(event)
{
	//console.log("href: "+ $(this).attr( "href" ) + "data-url:"+ $(this).attr( "data-url" ));
	if ( ($(this).attr( "rel" ) === "external" &&  $(this).attr("target") !== "_blank") || $(this).attr( "href" )[0] === "#" || $(this).attr( "href" ).match( /^(tel|mailto)\:/g ) )
	{
		return true;
	}
	else if ( $.mobile.activePage.attr( "data-url" ).indexOf( $(this).attr( "href" ) + $(this).attr( "data-url" ) ) !== -1 )
	{
		event.preventDefault();
		return false;
	}
	else if ( $(this).attr("target") == "_blank") 
  	{
	    event.preventDefault();
	    window.open($(this).attr( "href" ) + $(this).attr( "data-url" ), '_blank');
	    return false;
  	}

  	//
  	// Si queremos abrir el link en inappbrowser lo debemos marcar con este target.
  	// Aquí se ignorará la llamada totalmente
  	//
  	else if ( $(this).attr("target") == "inappbrowser" ) {
  		event.preventDefault();
  		
  		var url = $(this).attr("href");
  		var title = $(this).attr("data-title");
  		openBrowser(url, title)
  		return false;
  	}
	event.preventDefault();
	
	var str_url_params = $(this).attr( "data-url" ) || "";
	var str_anchor_href = $(this).attr( "href" );

	$( "body" ).pagecontainer( "change", str_anchor_href + str_url_params );

	return false;
});

$( window ).on("navigate", function(event, data)
{
//	debugger;
	var $active_page = $( "body" ).pagecontainer( "getActivePage" );
	
	if( data.state.direction == "back" && $(".ui-popup-active")[0] )
	{
		event.preventDefault();
		
		$(".ui-popup").popup("close");
		
		$.mobile.navigate( $active_page.jqmData("url") );
		
		return false;
	}
	else if( data.state.direction == "back" && $active_page.is( ".exit_app" ) && !isCordovaEnvironment() )
	{
		event.preventDefault();
		$.mobile.navigate( $active_page.jqmData("url") );
		
		return false;
	}
	else if ( data.state.direction == "back" && data.state.pageUrl && $active_page.is( ".no_back" ) )
	{
		event.preventDefault();
				
		if ( $active_page.find("#app_header")[0] ) {
			$active_page.find("a[id^='back_']").click();
		} else if ( $("#app_header").find("a[id^='back_']")[0] ) {
			$("#app_header").find("a[id^='back_']").click();
		} else {
			$.mobile.navigate( $active_page.jqmData("url") );
		}
		
		return false;
	}
	else if ( data.state.direction == "back" && data.state.pageUrl == $.mobile.path.parseUrl($active_page.jqmData("url")).hrefNoSearch )
	{
		event.preventDefault();
		window.history.back();
		return false;
	}
	else if ( $(".ui-popup-active")[0] )
	{
		event.preventDefault();
		$(".ui-popup").popup("close");
		$.mobile.navigate( $active_page.jqmData("url") );
		return false;
	}
	console.log( data.state.direction )
	console.log( data.state.hash )
});

$( document ).on( "touchmove", ".ui-popup-screen", function(event)
{
	event.preventDefault();
	event.stopPropagation();
	return false;
});