var FormularioPage = function(preguntas) {
	this._preguntas = preguntas;
	this._actual = -1;

	$("#btn_siguiente").click( this.enviarRespuesta.bind(this) );
	this.siguientePregunta();
};

FormularioPage.prototype.siguientePregunta = function() {
	this._actual = this._actual + 1;
	var pregunta = this._preguntas[this._actual];

	// Dependiendo el tipo de pregunta utilizamos un template de handlebars diferente
	// Cuidado: Este codigo no es performante, no solo porque compila siempre el html
	// sino tambien porque renderiza dos veces. La primera cuando se inserta el template
	// en el DOM y la segunda cuando se le pide a jQuery-Mobile que de estilos.
	var compiled = Handlebars.compile($("#template-" + pregunta.type).html());
	$("#formulario_placeholder").html( compiled(pregunta) );
	$("#formulario_placeholder").trigger("create");
}

FormularioPage.prototype.enviarRespuesta = function() {
	var respuesta = $("#formulario").serialize(); // Aqui tenemos input-idPregunta=valorElegido

	var idPregunta = this._preguntas[this._actual].id;
	var regexp = new RegExp("input-" + idPregunta + "=", 'g');
	var valor = respuesta.replace(regexp, "").replace(/&/g, ",");
	Nire.connection.respuesta(idPregunta, valor);

	// si hay siguiente pregunta la mostramos, si no quedan preguntas, vamos al home.
	// No estoy seguro si esto deberia estar en el metodo siguientePregunta o en algun otro.
	if(this._actual < this._preguntas.length - 1) {
		this.siguientePregunta();
	}
	else {
		$( "body" ).pagecontainer( "change", "timeline.html" );
	}
}

$(document).one("pagebeforecreate", function ()
{
	Nire.connection.getPreguntasPendientes().done(function(data) {
		new FormularioPage(data)
	});
});