/* CORDOVA */

//
//Cordova is loaded and it is now safe to call Cordova methods
//
function onDeviceReady()
{
	if (window.device.platform == "iOS" && window.device.version>="7.0") {
		StatusBar.overlaysWebView(false);
	}

    // Register the event listener
    document.addEventListener("backbutton", onBackKeyDown, false);

	cordova.getAppVersion(function (version) {
    	APP_VERSION = version;
	});

    gb_isCordovaLoaded = true;

    if (gb_isPageIndexShowed) {
        console.log("PAGE_LOGIN", PAGE_LOGIN);
        $( "body" ).pagecontainer( "change", PAGE_LOGIN );
    }

    initiatePushPlugin();
    if(!Nire.analytics) Nire.analytics = new Nire.Analytics();
    Nire.analytics.init();

    document.addEventListener("resume", onResume, false);
}

function onResume() {
    if(Nire.connection) {
        getLogger("onResumen")("retornando del background, comprobando si se debe invalidar el cache");

        Nire.connection.serverMonitor.executeOnDemand();
    }
}

/**
* Función para salir de la app en Android
*/
function onConfirm( index )
{
	if ( index === 1 ){
		navigator.app.exitApp();
	}
}

/**
* Función para que al pustar atras en Android pregunte si queremos salir de la app
*/
function onBackKeyDown()
{
	var $active_page = $( "body" ).pagecontainer( "getActivePage" );

	if ( $(".ui-popup-active")[0] )
	{
		$(".ui-popup").popup("close");
		return false;
	}
	else if ($( "body" ).pagecontainer( "getActivePage" ).find("div").hasClass( "ui-popup-screen" ))
	{
		$( "body" ).pagecontainer( "getActivePage" ).find(".plus-ex").click();
		return false;		
	}
		
    else if( $active_page.is("#page_login2") ) pageLogin2.onBackKeyDown();
    else if( $active_page.is("#page_registry_biography") ) pageRegistryBiography.onBackKeyDown();
	else if( $active_page.is( ".page_clinicHistory" ) )
	{
		$( "body" ).pagecontainer("change", "clinicHistoryExplorer.html");
		return false;
	}
	else if( $active_page.is( ".page_clinicHistoryExplorer" ) )
	{
		if ( $("#clinic_explorer_detail_div").hasClass("detail_div_pdf") || $("#clinic_explorer_detail_div").hasClass("detail_div_image") || $("#clinic_explorer_detail_div").hasClass("detail_div_text") )
		{
			console.log("flip");
			pageClinicHistoryExplorer.$page.find("#btn_detail_close").click();	
		}
		else if ( $("#clinic_explorer_detail_div").css("display") == "block")
		{
			pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper").click();	
			return false;
		}	

		else
			navigator.notification.confirm(
					gjson_lang.exit_msg, // message
					onConfirm, // callback to invoke with index of button pressed
					gjson_lang.exit_title, // title
					[gjson_lang.exit_ok, gjson_lang.exit_cancel]          // buttonLabels
				);
	}
	else if( $active_page.is( ".page_new_track_nutrition2" ) )
	{
		if ( $("#new_track_nutrition2_meal_options_container").css("display") == "none" )
        {
            pageNewTrackNutrition2.backPlate();
            return false;           
        }
        navigator.app.backHistory();
	}
	else if( $active_page.is( ".exit_app" ) )
	{
		navigator.notification.confirm(
			gjson_lang.exit_msg, // message
			onConfirm, // callback to invoke with index of button pressed
			gjson_lang.exit_title, // title
			[gjson_lang.exit_ok, gjson_lang.exit_cancel]          // buttonLabels
		);
	}
	else
	{
		navigator.app.backHistory();
	}
	return false;
}

/* FUNCTIONS */

function handleOpenURL(url) {
    var urlData = url.split("?")[1].split("&");
    if(urlData.length == 1){
        showToast(gjson_lang.login_token_expired)
    } else {
        Nire.analytics.event("Login", "Desde email (o similar url con schema)")
        var user = urlData[0].split("=")[1];
        var token = urlData[1].split("=")[1];
        console.log(user, token,urlData)
        Nire.connection.initialize(token, user);

        var redirect = urlData[2].split("=")[1];
        
        Nire.connection.configureSections().done(function(result) {
            if(redirect == "biography") 
                $( "body" ).pagecontainer( "change", "registryBiography.html");
            else if(redirect == "form")
                $( "body" ).pagecontainer( "change", "profileQuestion.html" );
            else
                $( "body" ).pagecontainer( "change", "timeline.html" );
        }); 
    }   
}

function showAlert( message, callback, title, buttonName )
{
	title = title || null;
	buttonName = buttonName || gjson_lang.accept;

	if(navigator.notification && navigator.notification.alert){
		navigator.notification.alert(
			message,    // message
			callback,   // callback
			title,      // title
			buttonName  // buttonName
		);

	} else{
		alert(message);
		if (callback)
			callback();
	}
}

/**
 * Mostra un Toast
 * Si no disponemos del plugin de Toast, se utiliza un Alert
 */
function showToast(message, duration, position) {
	if(window.plugins && window.plugins.toast) {
		if(!duration) duration = "long";
		if(!position) position = "center";

		window.plugins.toast.show(message, duration, position);
	}
	else {
		alert(message);
	}
}

/**
 * Si en un intervalo de 10 segundos se pulsa 5 veces
 * se mostrará la información de versión de la app instalada
 */
var easterEggCounter = 0;
function showAppInfo() {
	if (easterEggCounter == 0)
		setTimeout("easterEggCounter = 0", 10000);

	easterEggCounter = easterEggCounter + 1;
	if (easterEggCounter >= 5) {
		easterEggCounter = 0;
		if ( typeof cordova != "undefined" && cordova ) {
			cordova.getAppVersion(function (version) {
    			showToast("Version: " + version + " - Env: " + ENTORNO + " - Build: " + BUILD_VERSION_CODE);
			});
		} else {
			showToast("Version: Unknown - Env: " + ENTORNO);
		}
	}
}

/* Function to check if user is logged */
function isUserLogged()
{
	var str_hash = Nire.localStorage.getItem(CREDENTIALS_HASH);
	var str_username = Nire.localStorage.getItem(CREDENTIALS_USERNAME);
	if (str_hash && str_username) {
		return true;
	} else {
		return false;
	}
}

function openBrowser(url, title) {
    if(typeof cordova != 'undefined' && cordova.ThemeableBrowser) {
        var backgroundColor = rgb2hex(getHeaderStyle("backgroundColor"));
        var titleColor = rgb2hex(getHeaderStyle("color"));

        // Intentamos internacionalizar el titulo. Si no existe traduccion
        // lo utilizamos tal cual
        var staticText = i18n(title);
        if(!staticText) staticText = title;

        var browser = cordova.ThemeableBrowser.open(url, '_blank', {
            statusbar: {
                color: '#ffffffff'
            },
            toolbar: {
                height: 44,
                color: backgroundColor
            },
            title: {
                color: titleColor,
                staticText: staticText
            },closeButton: {
                image: 'arrow_left',
                imagePressed: 'arrow_left',
                align: 'left',
                event: 'closePressed'
            }
        }).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function(e) {
            console.error(e.message);
        }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function(e) {
            console.log(e.message);
        });
        var detectAndCloseBrowser = function(event) {
            if(event.url.indexOf("/cerrar") > 0) 
                browser.close()
        }

        var closeBrowser = function() {
            browser.removeEventListener('loadstart', detectAndCloseInAppBrowser);
            browser.removeEventListener('exit', closeInAppBrowser);
        }

        browser.addEventListener('loadstart', detectAndCloseBrowser);
        browser.addEventListener('exit', closeBrowser);
    } else {
        window.open(url, '_system', 'location=yes');
    }
}

function openBrowserPDF(url, title) {
    if(typeof cordova != 'undefined' && cordova.ThemeableBrowser) {
        var backgroundColor = rgb2hex(getHeaderStyle("backgroundColor"));
        var titleColor = rgb2hex(getHeaderStyle("color"));

        // Intentamos internacionalizar el titulo. Si no existe traduccion
        // lo utilizamos tal cual
        var staticText = i18n(title);
        if(!staticText) staticText = title;

        var browser = cordova.ThemeableBrowser.showWebPage(url, '_blank', {
            statusbar: {
                color: '#ffffffff'
            },
            toolbar: {
                height: 44,
                color: backgroundColor
            },
            title: {
                color: titleColor,
                staticText: staticText
            },closeButton: {
                image: 'arrow_left',
                imagePressed: 'arrow_left',
                align: 'left',
                event: 'closePressed'
            }
        }).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function(e) {
            console.error(e.message);
        }).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function(e) {
            console.log(e.message);
        });
        var detectAndCloseBrowser = function(event) {
            if(event.url.indexOf("/cerrar") > 0) 
                browser.close()
        }

        var closeBrowser = function() {
            browser.removeEventListener('loadstart', detectAndCloseInAppBrowser);
            browser.removeEventListener('exit', closeInAppBrowser);
        }

        browser.addEventListener('loadstart', detectAndCloseBrowser);
        browser.addEventListener('exit', closeBrowser);
    } else {
        window.open(url, '_system', 'location=yes');
    }
}

function getHeaderStyle(style) {
    // Si existe un tag con el id solicitado obtenemos los valores de ese tag.
    var tag = $("#app_header");
    if(tag.length > 0) return tag.css(style);

    // Si no existe el tag, creamos uno y lo agregamos al dom oculto.
    // leemos los valores que le asignaría e inmediatamente lo quitamos
    tag = $("<div id='app_header' style='display: none'></div>");
    $("body").append(tag);
    var result = tag.css(style);
    tag.remove()

    return result;
}

/**
 * function to load main strings based on default language
 */
function loadJSONMainLanguage()
{
	$.ajax({
		url: "lang/" + LANG + "/mobile/estructura.json",
		dataType: "json",
		async: false
	}).done(function(json) {
		gjson_lang = (CJSON_LANG) ? $.extend(json, CJSON_LANG) : json;
	});
}

/**
 * Given a i18n key, return the translated value.
 */
function i18n(key) {
    if( typeof(gjson_lang) == 'undefined' || gjson_lang == null) {
        console.log("i18n not loaded.")
        return "";
    }

	// precondition: loadJSONMainLanguage already called.
	var result = gjson_lang[key];
	if(!result) console.log("i18n key does not exists.", key, LANG, CJSON_LANG);

	return result;
}

/**
 * Mostrar un velo sobre la pantalla para impedir que el usuario pueda manipular la pantalla
 * @param message texto a mostrar bajo el indicador de cargando.
 */
function showCover(message) {
    // TODO: Si ya se esta mostrando no deberíamos ocultarlo totalmente
    // sólo deberíamos refrescar el mensaje.
    hideCover();

    var html = "<div id='__FULL_PAGE_COVER__'></div>";
    var style = "<style type='text/css' id='__FULL_PAGE_COVER_CSS__'>#__FULL_PAGE_COVER__ { width: 100%; height: 100%; position: absolute; z-index: 999; background-color: black; opacity: 0.7; }</style>";

    $("body").append(html).append(style);
    showLoading(message, !!message);
}

/**
 * Si se esta mostrando un cover, lo oculta. En caso contrario no tiene efecto.
 */
function hideCover() {
    $("#__FULL_PAGE_COVER_CSS__").remove();
    $("#__FULL_PAGE_COVER__").remove();
    $.mobile.loading("hide");
}

/* COMMON */
function translatePage($page)
{
	$page.find(":jqmData(t)").each(function() {
		var txt = $(this).attr("data-t");
		var params = $(this).attr("data-t-params");
		var translation = gjson_lang[txt];
		if(params){
			translation = String.format(translation,params);
		}

        // Si el tag tiene placeholder se traduce. En caso contrario
        // se traduce el innerHTML
        if("placeholder" in this) $(this).attr("placeholder", translation)
        else $(this).html(translation);
	});
}

function getURLParameter(name) {
	var value = (RegExp(name + '=' + '(.+?)(&|$)').exec(location.search)||[,null])[1];
	if(value) return decodeURI(value)
	return null;
}

function getDataURLParameter($obj, name) {
	var obj_pathUrl = $.mobile.path.parseUrl($obj.jqmData("url"));
	var value = (RegExp(name + '=' + '(.+?)(&|$)').exec(obj_pathUrl.search)||[,null])[1];
	if(value) return decodeURI(value)
	return null;
}

function getRandomInt(min, max) {
	// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

/**
 * Dependiendo el group de la comida elije una imagen u otra.
 */
function foodGroupImage(group) {
    var number = getRandomInt(1, 5)
    var img = "img/foodtypes/"+ group.replace(/ /g,"_") +"/"+ number +".png";
    return img;
}

/**
 * Dependiendo el tipo de ejercicio se elije una imagen u otra.
 */
function exerciseGroupImage(type) {
    var number = getRandomInt(1, 4)
    var img = "img/exercisetypes/"+ type.toLowerCase() +"/"+ number +".jpg";
    return img;
}

function getQuestionResponseValue(response, question) {
    var idPregunta = question.id;
    var regexp = new RegExp("input-" + idPregunta + "=", 'g');
    var valor = response.replace(regexp, "").replace(/&/g, ",");

    if(valor.indexOf("if-select=no") >= 0){
        valor = "no"
    } else {
        if(valor.indexOf("if-select=") >= 0)
            valor = valor.slice(valor.indexOf(",") + 1)

        // Validamos la obligatoriedad de la pregunta.
        if(question.mandatory && question.type != "checkbox") {
            if(!valor) return null; // Si no hay respuesta, no seguir
            if(valor == "if-select=si") return null; // si la repuesta es si hay que especificar QUE
        }
    }
    return valor;
}

function validarRespuesta(regularE, response)
{
    if(regularE) {
        var regex = new RegExp(regularE)
        return regex.test(response);
    }
    return true;
}

/***************************************************************/
/* MODIFICACION PARA OBTENER MAS GRID-COLUMN EN JQUERY MOBILE */
/*************************************************************/
(function( $, undefined ) {
	$.fn.grid = function( options ) {
	    return this.each(function() {

	        var $this = $( this ),
	            o = $.extend({
	                grid: null
	            }, options ),
	            $kids = $this.children(),
	            gridCols = { solo:1, a:2, b:3, c:4, d:5, e:6, f:7 },
	            grid = o.grid,
	            iterator;

	            if ( !grid ) {
	                if ( $kids.length <= 7 ) {
	                    for ( var letter in gridCols ) {
	                        if ( gridCols[ letter ] === $kids.length ) {
	                            grid = letter;
	                        }
	                    }
	                } else {
	                    grid = "a";
	                    $this.addClass( "ui-grid-duo" );
	                }
	            }
	            iterator = gridCols[grid];

	        $this.addClass( "ui-grid-" + grid );

	        $kids.filter( ":nth-child(" + iterator + "n+1)" ).addClass( "ui-block-a" );

	        if ( iterator > 1 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+2)" ).addClass( "ui-block-b" );
	        }
	        if ( iterator > 2 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+3)" ).addClass( "ui-block-c" );
	        }
	        if ( iterator > 3 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+4)" ).addClass( "ui-block-d" );
	        }
	        if ( iterator > 4 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+5)" ).addClass( "ui-block-e" );
	        }
	        if ( iterator > 5 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+6)" ).addClass( "ui-block-f" );
	        }
	        if ( iterator > 6 ) {
	            $kids.filter( ":nth-child(" + iterator + "n+7)" ).addClass( "ui-block-g" );
	        }
	    });
	};
	})( jQuery );

jQuery.fn.mousehold = function(timeout, f) {
	if (timeout && typeof timeout == 'function') {
		f = timeout;
		timeout = 100;
	}
	if (f && typeof f == 'function') {
		var timer = 0;
		var fireStep = 0;
		return this.each(function() {
			jQuery(this).mousedown(function() {
				fireStep = 1;
				var ctr = 0;
				var t = this;
				timer = setInterval(function() {
					ctr++;
					f.call(t, ctr);
					fireStep = 2;
				}, timeout);
			})

			clearMousehold = function() {
				clearInterval(timer);
				if (fireStep == 1) f.call(this, 1);
				fireStep = 0;
			}

			jQuery(this).mouseout(clearMousehold);
			jQuery(this).mouseup(clearMousehold);
		})
	}
}

$.fn.filterByNireData = function(prop, val)
{
    return this.filter(
        function()
        { 
        	var data = $(this).jqmData("nire");
        	return data[prop]==val;
        }
    );
}

function indicatorsImageErrorControl(type)
{
	$( ".default_indicator_icon" ).each(function(){
		$(this).error(function(){
			if (typeof type == "undefined")
				$(this).attr("src", "img/others/ic_default.png");
			else
				$(this).attr("src", "img/others/ic_default_"+ type +".png");
		});
	});
}

function tracksImageErrorControl()
{
	$( ".default_track_image" ).each(function(){
		$(this).load(function(){
			$(this).parent().css("background-image", "url('"+ $(this).attr("src") +"')");
       		$(this).remove();
		})
		.error(function(){
			$(this).parent().css("background-image", "url('img/others/img_default.jpg')");
       		$(this).remove();
		});
	});

	$( ".default_track_icon" ).each(function(){
		$(this).error(function(){
			if ($(this).attr("src").match("_sel."))
				$(this).attr("src", "img/others/ic_default_sel.png");
			else
				$(this).attr("src", "img/others/ic_default.png");
		});
	});
}

function tracks2ImageErrorControl()
{
	$( ".default_track2_image" ).each(function(){
		$(this).error(function(){
			$(this).css("visibility", "hidden");
		});
	});
}

function adjustSizeOfGridFooterActions($page)
{
    $page.find("div[class^='ui-grid-']:not(.ui-grid-solo)").each(function()
    {
    	var int_min_height = 0;
        var int_max_height = 0;
        
        $(this).find("div[class^='ui-block-'].footer_action .ui-btn").css({ "height": "auto", "line-height": "18px"});
        
        $(this).find("div[class^='ui-block-'].footer_action .ui-btn").each(function()
        {
        	var int_height = $(this).height();
            if ( int_height > int_max_height ) {
                int_max_height = int_height;
            }
        });
        
    	$(this).find("div[class^='ui-block-'].footer_action .ui-btn").each(function()
        {
    		var int_min_height = parseInt($(this).css("line-height"));
    		var int_height = parseInt($(this).height());
    		$(this).css({ "height": int_max_height +"px", "line-height": (int_max_height / (int_height/int_min_height)) +"px"});
        });
    });
}

/**
 * Detectar si estamos accediendo desde una aplicación phonegap o desde un entorno web.
 * @return true si estoy dentro de phonegap, false si estoy en web o local
 *
 * Código basado en
 * http://stackoverflow.com/questions/10347539/detect-between-a-mobile-browser-or-a-phonegap-application
 */
function isCordovaEnvironment() {
	var app = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
	return app;
}

function networkFailureAlert() {
	showToast(gjson_lang["connection_problems"]);
}

function warnUserAppUpdateRequired() {
	showToast(gjson_lang["update_required"])
}

/**
 * Actualizar, mostrar u ocultar el contador de notificaciones pendientes.
 * @param count cantidad de notificaciones pendientes.
 */
function showNotificationUpdate() {
	var count = Nire.notification.getPendingCount();

	// Únicamente actualizamos el DOM si hay un espacio en el DOM para
	// mostrar las notificaciones.
	var element = $("#pending_notifications");
	if(element.length == 0) return;

	// Si estamos en modo Debug simulamos que siempre hay notificaciones
	// TODO: Eliminar este codigo luego de haber sido maquetado
	if(ENTORNO == "DESARROLLO") count = 4;

    if(count > 0) {
    	element.html( count );
    	element.show();
    	element.trigger( "change" );
    }
    else {
    	element.hide();
    }
}

function cloneAppHeader($page)
{
	$header = $( "#app_header" ).clone().removeAttr("data-id");
	$( "#app_header" ).empty();
	try {
		$( "#app_header" ).toolbar( "destroy" );
	} catch (e) {
		$( "#app_header" ).toolbar().toolbar( "destroy" );
	}
	$page.find( "#app_header" ).remove();
	$page.find( ".ui-content" ).before($header);
	$header.toolbar();
	$.mobile.resetActivePageHeight();
}

function getContentHeightToFillScreen($header, $content_current, $footer)
{
	var screen = $.mobile.getScreenHeight();
	var header = 0, footer = 0;
	if ($header)
		header = $header.hasClass("ui-header-fixed") ? $header.outerHeight() - 1 : $header.outerHeight();
	if ($footer)
		footer = ($footer.hasClass("ui-footer-fixed") || $footer.parent().hasClass("ui-footer-fixed")) ? $footer.outerHeight() - 1 : $footer.outerHeight();
    var contentCurrent = $content_current.outerHeight() - $content_current.height();
    var content = screen - header - footer - contentCurrent;
    return content;
}

/**
 * Hacer vibrar al dispositivo (lo evitamos en iOS porque no se puede controlar el tiempo)
 * Si el plugin no esta soportado no hace nada.
 *
 * @param duration duración de la vibrasión. Default 75
 */
function vibrate( duration /* = 75 */) {
	if(navigator && navigator.vibrate && window.device && window.device.platform != "iOS") {
		if(!duration || duration <= 0) duration = 75;
		navigator.vibrate(duration);
	}
}

function getLogger(service) {
    if(typeof Logger === 'object')    
        return Logger.getLogger(service);
    else
        return $.noop;
}

/**
 * Función generica a invocar cuando se produce un error.
 *
 * La responsabilidad de esta funcion es reportar el error a Analytics y
 * y de ser posible al usuario también.
 */
function ajaxErrorHandler() {
    if(Nire.analytics) {
        var description = this.type + " " + this.url;
        Nire.analytics.error(description);
    }

    if(typeof alertServerFailure === 'function')
        alertServerFailure();
}

function calculateDPI()
{

	var dpi=0;

	if (window.matchMedia('only screen and (max-resolution: 120dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 0.75)').matches)
	{
		dpi = 120;
	}
	if (window.matchMedia('only screen and (max-resolution: 160dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 1)').matches)
	{
		dpi = 160;
	}
	if (window.matchMedia('only screen and (max-resolution: 240dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 1.5)').matches)
	{
		dpi = 240;
	}
	if (window.matchMedia('only screen and (max-resolution: 320dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 2)').matches)
	{
		dpi = 320;;
	}
	if (window.matchMedia('only screen and (max-resolution: 480dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 3)').matches)
	{
		dpi = 480;
	}
	if (window.matchMedia('only screen and (max-resolution: 640dpi)').matches && window.matchMedia('(-webkit-min-device-pixel-ratio: 4)').matches)
	{
		dpi = 640;
	}

	if (dpi == 0)
	{
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 0.75)').matches)
    	{
    		dpi = 120;
    	}
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 1)').matches)
    	{
    		dpi = 160;
    	}
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 1.5)').matches)
    	{
    		dpi = 240;
    	}
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 2)').matches)
    	{
    		dpi = 320;
    	}
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 3)').matches)
    	{
    		dpi = 480;
    	}
    	if (window.matchMedia('(-webkit-min-device-pixel-ratio: 4)').matches)
    	{
    		dpi = 640;
    	}
	}
	return dpi;

}

String.prototype.capitalize = function()
{
    return this.charAt(0).toUpperCase() + this.slice(1);
}

function alphabeticalSort(attr, to_first)
{
	return function (first, second) {
		
		var a = first[attr] || null;
		var b = second[attr] || null;
		
		if (a == null && !to_first)
			return 1;
		else if (to_first)
			return -1;
		if (b == null && !to_first)
			return 1;
		else if (to_first)
			return -1;
	    
		return a.localeCompare(b);
	}
}


function formatHeaderDate(date, today) {
	var yesterday = today.clone().add(-1, 'days');
	var tomorrow = today.clone().add(1, 'days');
	if (date.isSame(today))
		text = gjson_lang.today;
	else if (date.isSame(yesterday))
		text = gjson_lang.yesterday;
	else if (date.isSame(tomorrow))
		text = gjson_lang.tomorrow;
	else
		text = getDateFormatted(date.format("YYYYMMDD"));

	return text;
}

//transforms a color from rgb to hex
function rgb2hex(rgb) {
    if (/^#[0-9A-F]{6}$/i.test(rgb)) return rgb;

    rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
    function hex(x) {
        return ("0" + parseInt(x).toString(16)).slice(-2);
    }
    return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
}

function checkAppPDF(pdf_url) {
	if(!WEB_APP)
	{
		var platform = device.platform;
		var appInstalled = false;
		switch(platform.toLowerCase()) 
		{
        	case "android":
                for (var i=0, len=APPS_PDF_LIST.length && appInstalled != true; i < len; i++)
                {
                    cordova.plugins.fileOpener2.appIsInstalled(APPS_PDF_LIST[i], {
                            success : function(res) {    
                            console.log(res.status);                       
                                if (res.status != 0) {
                                    window.open(pdf_url, '_system');
                                    appInstalled = true;
                                }
                                else
                                {
                                    appInstalled = false;
                                    if (confirm("Do you want to install the free PDF Viewer App Adobe Acrobat Reader"))
                                        window.open('https://play.google.com/store/apps/details?id='+DEFAULT_APP_PDF, '_system');
                                } 
                            }
                    });
                        
                }
            break;
        	case "ios":
                window.open(pdf_url, "_system");
            break;
		}
	}else window.open(pdf_url, '_system');

}

function updateActiveSection(active_page) {
	
	/* SECCIONES DE HOME (PERFIL) */
	if ( active_page.hasClass("section_home") )
	{
		$("#panel_app").find("a").removeClass("current_panel_selected");
		$("#a_panel_app_section_home").addClass("current_panel_selected");
	}
		
	/* SECCIONES DE TIMELINE */
	if ( active_page.hasClass("section_today") )
	{
		$("#panel_app").find("a").removeClass("current_panel_selected");
		$("#a_panel_app_section_today").addClass("current_panel_selected");
	}
		
	/* SECCIONES DE NUTRICIÓN */
	if (active_page.hasClass("section_nutrition") )
	{
		$("#panel_app").find("a").removeClass("current_panel_selected");
		$("#a_panel_app_section_nutrition").addClass("current_panel_selected");
	}
		
	/* SECCIONES DE ACTIVIDAD FÍSICA */
	if (active_page.hasClass("section_physical_activity") )
	{
		$("#panel_app").find("a").removeClass("current_panel_selected");
		$("#a_panel_app_section_physical_activity").addClass("current_panel_selected");
	}
		
	/* SECCIONES DE SALUD */
	if (active_page.hasClass("section_health") )
	{
		$("#panel_app").find("a").removeClass("current_panel_selected");
		$("#a_panel_app_section_health").addClass("current_panel_selected");
	}
}


/* VARIABLES */

var gb_isCordovaLoaded = false;
var gb_isPageIndexShowed = false;

var gjson_lang = null;

loadJSONMainLanguage();

if(typeof Nire != 'undefined') {
    Nire.connection = new Nire.Connection(showLogin, networkFailureAlert, warnUserAppUpdateRequired);
    Nire.notification = new Nire.Notification(Nire.connection);
    Nire.search = new Nire.Search(LANG, ajaxErrorHandler);
}
