var menuHome = {

    getData: function()
    {
		return Nire.connection.menu().done( menuHome.showData );
    },

    showData: function(json_response)
    {
		if (json_response.error.code == 0) {
			menuHome.addContent(json_response.data);
		} else {
			showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
		}
    },

	addContent: function(json)
	{
		if (json.profile_assistant.percentage > 100) json.profile_assistant.percentage = 100;
		$( "#div_panel_app_profile_percentage .progress-inner").css( "width", json.profile_assistant.percentage +"%");

		$( "#div_panel_app_profile_percentage .progress_text" ).html(  json.profile_assistant.percentage +"%");

		// Si el perfil está completo no mostramos barra de %
		if(json.profile_assistant.percentage != 100)
			$("#div_panel_app_profile_percentage").show();
		//var username = localStorage.getItem(CREDENTIALS_USERNAME) ? localStorage.getItem(CREDENTIALS_USERNAME) : json.profile.name +" "+ json.profile.firstname
		//$( "#h2_panel_app_profile_complete_name" ).text( username );
	},

	initializeComponents: function()
	{
		menuHome.addSponsor();
		menuHome.addOptions();
    	translatePage($("#panel_app"));
	},

	addSponsor: function()
	{
		if (APP_DOMAIN == "vivebien") {
			
			$("#div_panel_app_options").after('<div id="div_panel_app_sponsor">'
											+ '<div class="ui-grid-a">'
												+ '<div class="ui-block-a"><p id="p_panel_app_sponsor_text" data-t="menu_home_sponsor_text"></p></div>'
												+ '<div class="ui-block-b"><img src="img/others/ic_logo_locatel.png"/></div>'
											+ '</div>'
											+'<div class = "div_panel_app_sponsor_colors"></div>'
										+ '</div>');
		}
	},
	
	addOptions: function()
	{
		var line_separator = '<div class="line_menu_separator"></div>';
		var sharing = '<a href="#share_app" data-rel="dialog" data-transition="pop" data-t="menu_home_share_app"></a>';
		var logout = '<a id="a_panel_app_logout" href="#" class="ui-btn ui-btn-icon-left ui-icon_panel_logout" data-t="menu_home_logout"></a>';
		var group_1 = "";
		if( SHARE_APP_URL != "" )
			group_1 += sharing +"<br />";

		if(Nire.connection.isEnabledSection("CLINIC"))
			$("#a_panel_app_registry_health").show();
			//group_1 += clinic_history +"<br />";

		//if ( group_1 != "" )
		//	group_1 = line_separator + group_1;

		var group_2 = line_separator + logout;

		//var result = group_1 + group_2;

		//$("#div_panel_app_options_mutable_area").html(result);
		$("#div_panel_app_options_mutable_area").html(group_2).trigger('updatelayout');
		translatePage($("#div_panel_app_options_mutable_area"));
	},

	addAssistantPopup: function()
	{
		Nire.connection.personalAssistant()
    	.done(function(json_response) 
    	{
			if (json_response.error.code == 0)
			{
			  	setTimeout(function()
			  	{
					console.log(json_response);
					var template_treatment_popup = Handlebars.compile($("#template-personal_assistant_popup").html());

					// SELECCIONAMOS EL ÚLTIMO ELEMENTO DEL SERVICIO
					var item = json_response.data.cards[0];

			        var str_url_params = "";
			        var str_card_link_class = null;
			        var str_card_link_url = null;
			        var str_card_link_text = null;
			        str_card_link_border = "";

			        if ( item.card_link )
			        {
			            str_card_link_class = "color_txt_"+ item.card_section;
			            str_card_link_url = item.card_link.url;
			            str_card_link_text = item.card_link.text;
			            str_card_link_border = "card_link_border";
			        }
			        // Estos son los datos que requiere el template de Handlebars
			            var datos_popup =  
			            {
			                card_section_class: "bg_"+ item.card_section,
			                section_title: item.section_title,
			                card_title: item.card_title,
			                html_content: item.html_content,
			                card_link_class: str_card_link_class,
			                card_link_url: str_card_link_url,
			                card_link_text: str_card_link_text,
			                card_link_class_border: str_card_link_border
			            };

			            $("#personal_assistant_popup").html(template_treatment_popup(datos_popup)).trigger("updatelayout");

			            var $current_content = $(this).find(".ui-content");
						var int_content_height = getContentHeightToFillScreen(
									$("#app_header"),
									$current_content,
									null
								);

						var popup_heading = $("#personal_assistant_popup .card_header").outerHeight();
						var popup_link = $("#personal_assistant_popup .card_link").outerHeight();
						var popup_content_height = int_content_height - popup_heading - popup_link
						
						$("#personal_assistant_popup .card_content").css("max-height", popup_content_height);

				    	var options = $( "#personal_assistant_popup" ).popup({
						  positionTo: ".ui-content",
						  transition: "pop"
						});

						$( "#personal_assistant_popup" ).popup( "open", options );

						console.log("Abro POPUP");
				}, 2000);
			}
    	})
    	.always(function() {
    		hideLoading();
    	});
	}
};

$( document).off( ".menu_home" )

	.on("panelcreate.menu_home", "#panel_app", function ()
	{
		menuHome.initializeComponents();
		Nire.connection.onSectionChange(menuHome.addOptions);
	})
	
	.on("click.menu_home", "#a_panel_app_section_today", function()
	{
		Nire.localStorage.removeItem(APP_DATE_STATE);
		if ( $( "body" ).pagecontainer("getActivePage").attr("id") == "page_timeline" )
			$("#timeline_track_days_actual .dateselector").dateselector( "date", currentDate().hour(0).minute(0).seconds(0).milliseconds(0) );
		return true;
	})
	
	.on("click.menu_home", "#a_panel_app_section_nutrition", function()
	{
		Nire.localStorage.removeItem(APP_DATE_STATE);
		if ( $( "body" ).pagecontainer("getActivePage").attr("id") == "page_nutrition_weekly" )
			$("#nutrition_weekly_track_days_actual .dateselector").dateselector( "date", currentDate().hour(0).minute(0).seconds(0).milliseconds(0) );
		return false;
	})
	
	.on("click.menu_home", "#a_panel_app_section_physical_activity", function()
	{
		Nire.localStorage.removeItem(APP_DATE_STATE);
		if ( $( "body" ).pagecontainer("getActivePage").attr("id") == "page_physical_activity_weekly" )
			$("#physical_activity_weekly_track_days_actual .dateselector").dateselector( "date", currentDate().hour(0).minute(0).seconds(0).milliseconds(0) );
	})
	
	.on("click.menu_home", "#a_panel_app_section_health", function()
	{
		Nire.localStorage.removeItem(APP_DATE_STATE);
		if ( $( "body" ).pagecontainer("getActivePage").attr("id") == "page_pillbox" )
			$("#pillbox_days_actual .dateselector").dateselector( "date", currentDate().hour(0).minute(0).seconds(0).milliseconds(0) );
	})

	.on("click.menu_home", "#a_panel_app_logout", function() {
		Nire.analytics.event("Logout", "Desde menu lateral");
		Nire.connection.logout();
		window.location.replace("index.html");
	})

	.on("click.menu_home", "a[id^='a_panel_app_']", function()
	{	
		if($( this ).attr("href") != "#")
		{
			$("#panel_app").find("a").removeClass("current_panel_selected");
			$( this ).addClass("current_panel_selected");
		}	
	})

	// Comentamos la apertura del popup de Assitant
	// .on("click.menu_home", "#a_panel_app_section_today", function()
	// {
	// 	/menuHome.addAssistantPopup();
	// })

	/* BLOQUEAR CONTENIDO Y HACER SCROLL SOLO EN EL MENÚ LATERAL */

	.on("panelbeforeopen.menu_home", "#panel_app", function ()
	{
		Nire.analytics.event( "click", "Menu home click" ); 
		$( "body" ).pagecontainer( "getActivePage" ).css("position", "fixed");
	    //var height = $( "body" ).pagecontainer( "getActivePage" ).outerHeight();
	    //$("#panel_app").css("min-height", height + 1);
	})

	.on("panelbeforeclose.menu_home", "#panel_app ", function()
	{
		$( "body" ).pagecontainer( "getActivePage" ).css("position", "absolute");
		$.mobile.silentScroll(0);
	});

