// Selector de fecha
//
// Este widget esta pensado para ser utilizado dentro de nire por lo que
// hace algunas supociones sobre el entorno en que se ejecuta.
//
// Se le envía una serie de items, con la respuesta json del servicio y
// se dibuja un selector con id más texto pasado por el fichero de lenguaje.
//
$.widget("nire.optionselector", {
	options: {
		
		// Funcion a llamar al cambiar el selector
		fn_item_clicked: undefined
	},


	// Asignación de carga
	//
	_create: function() {
		var items = this.options.item;
		var wrapper_title = this.options.wrapper_title;
		var default_option = this.options.default_option;
		this._select(items, wrapper_title, default_option);
	},

	// Cuando cambiamos de opción en el selector
	_change: function(item) {
		var itemElements = this.element.find(".options_container div");

		itemElements.each(function(i)
		{
			if(item == i)
				$(this).removeClass("blocked_item").addClass("selected_item");
			else 
				$(this).removeClass("selected_item").addClass("blocked_item");;
		});

		//this._limits();
	},

	_limits: function() {


		/*
		if(currentItem == lastItem)
			this.element.find(".right_arrow").hide();
		else
			this.element.find(".right_arrow").show();

		if(currentItem == 0)
			this.element.find(".left_arrow").hide();
		else
			this.element.find(".left_arrow").show();
		*/

	},
	//
	// Seleccionar una fecha específica
	//
	_select: function(aItems, wrapper_title, default_option) {
		var _this = this;

		firstItem = aItems[0];
		lastItem = aItems.length-1;
		
		var element = this.element;
		var ul = $("<div/>",{
  			class : "options_container"
		})

		var left_arrow = $("<div/>",{
  			class : "left_arrow"
		})

		var right_arrow = $("<div/>",{
  			class : "right_arrow"
		})

		element.append(left_arrow);
		element.append(right_arrow);

		element.append(ul);

		for (var i=0, len=aItems.length-1; i<=len; i++)
		{		
			title = aItems[i].type;
			
			str_title = gjson_lang[wrapper_title + title.toLowerCase()];


			if(default_option == aItems[i].type && default_option != null)
			{
				currentItem = i;
				element.find(".options_container").append('<div data-option_item='+aItems[i].id+' class="selected_item">'+str_title+'</div>');
			}
			else if( (default_option == null || default_option == undefined) && i == 0)	
			{
				currentItem = 0;
				element.find(".options_container").append('<div data-option_item='+aItems[i].id+' class="selected_item">'+str_title+'</div>');
			}	
			else
				element.find(".options_container").append('<div data-option_item='+aItems[i].id+' class="blocked_item">'+str_title+'</div>');

		}


		$( document ).off(".optionselector")

	    .on("click.optionselector", ".left_arrow", function()
	    { 	
			currentItem--;

			if(currentItem > lastItem)
				currentItem = 0;
			else if(currentItem < 0)
					currentItem = lastItem;
	

	    	_this._change(currentItem);
	    })

	    .on("click.optionselector", ".right_arrow", function()
	    {
	    	currentItem++;

	    	if(currentItem > lastItem)
				currentItem = 0;
			else if(currentItem < 0)
					currentItem = lastItem;

	    	_this._change(currentItem);
	    })
	}
});