/* CSS */


/* VARIABLES */

var pageAppDirectCommunicator = {
    $page: null,
    log: getLogger("pageAppDirectCommunicator"),

    loadNotifications : function($page) {
        this.log("Recargando notificaciones.");
        return contentNotifications.getNewData();
    },

    loadOldNotifications : function($page) {
        return contentNotifications.getData();
    }
}

/* EVENTS */
$( document ).off(".app_direct_communicator")
	
	.on("pagecreate.app_direct_communicator", "#page_app_direct_communicator", function()
	{
		pageAppDirectCommunicator.$page = $(this);
		
		$( "#footer_app_direct_communicator" ).toolbar();
		
		contentNotifications.$page = $(this);
		contentMedWhatConsultor.$page = $(this);
		
		// Creamos solo lo necesario para efectuar la transicion
		contentNotifications.createHeader();
		cloneAppHeader($(this));
	})

	.on("pagecontainershow.app_direct_communicator", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_app_direct_communicator") {
			
	    	if(!sessionStorage.getItem("app_notifications_state"))
			{
		    	var selected_state = {
		   	    	 prev_page: $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length - 2].pageUrl
		       	 };
		       	 
		       	 sessionStorage.setItem("app_notifications_state", JSON.stringify(selected_state));   		
			}
		}
	})
	
	.on( "pagecontainerchange.app_direct_communicator", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_app_direct_communicator")
		{
            pageAppDirectCommunicator.loadOldNotifications();
			pageAppDirectCommunicator.loadNotifications().done(function() {
                pageAppDirectCommunicator.log("Se debe hacer scroll al final");
                contentNotifications.scrollToEnd();
            });
            Nire.notification.setPendingCount(0)

            showNotificationUpdate()
		}
	})
	
	.on("pageremove.app_direct_communicator", "#page_app_direct_communicator", function()
	{
		$( document ).off( ".app_direct_communicator" );
		$( 'link[href="css/pageAppDirectCommunicator.css"]' ).remove();
		$( 'link[href="css/contentNotifications.css"]' ).remove();
		$( 'link[href="css/contentMedWhatConsultor.css"]' ).remove();
		contentNotifications = null;
		contentMedWhatConsultor = null;
	})
	
	.on("change.app_direct_communicator", "#pending_notifications", function(event)
	{
		pageAppDirectCommunicator.loadNotifications();
	})
	
	.on("click.app_direct_communicator", "#notifications_content_btn", function()
	{        
        $("#content_app_direct_communicator").empty();
        contentNotifications.createHeader();
        cloneAppHeader(contentNotifications.$page);
		contentNotifications.removeFooter();
        pageAppDirectCommunicator.loadOldNotifications();
		pageAppDirectCommunicator.loadNotifications();
	})

    .on("click.app_direct_communicator", ".confirmTreatment", function()
    {
        contentNotifications.confirmTrack($(this).attr("data-url"), $(this).text())
    })

    .on("click.app_direct_communicator", ".replyNotification", function()
    {
        contentNotifications.replyNotification($(this).attr("data-url"), $(this).text())
    })
	
	.on("click.app_direct_communicator", ".notification_action a", function()
	{
		var action = getDataURLParameter($(this), "action");
		if ( $(this).attr("href") == "#" && action === "question") {
			showLoading();
			var id = getDataURLParameter($(this), "value");
            var notificationId = getDataURLParameter($(this), "notificationId");
			contentNotifications.getNewQuestion(id, notificationId);
		}
    })
    
    .on("click.app_direct_communicator", "#notifications_question_popup_send_btn", function()
	{
		contentNotifications.questionResponse();
    })
    
    .on( "popupbeforeposition.app_direct_communicator", "#notifications_question_popup", function()
    {
    	$("body").css("overflow", "hidden");
        var maxWidth = $( window ).width() - 50 + "px";
		var maxHeight = $( window ).height() - 100 + "px";
        $( this ).css({ "max-height": maxHeight, "max-width": maxWidth });
    })
    
    .on( "popupafterclose.app_direct_communicator", "#notifications_question_popup", function()
    {
    	$("body").css("overflow", "auto");
        $( this ).remove();
    })
    	
	.on("click.app_direct_communicator", "#medwhat_consultor_content_btn", function()
	{        
        $("#content_app_direct_communicator").empty();
        contentNotifications.lastNotificationDate = null;
        
        contentMedWhatConsultor.createHeader();
        cloneAppHeader(contentMedWhatConsultor.$page);
        contentMedWhatConsultor.createFooter();
        contentMedWhatConsultor.reloadData();
	})
	
	.on("submit.app_direct_communicator", "#medwhat_consultor_search_form", function(event)
	{
		event.preventDefault();
	    $('#medwhat_consultor_send_btn').click();
	    return false;
	})


    .on("click.app_direct_communicator", "#medwhat_consultor_speech", function() {
        contentMedWhatConsultor.startSpeechRecognition();
    })

	.on("click.app_direct_communicator", "#medwhat_consultor_send_btn", function()
	{
        var q = $('.filterBasic-input').val();
        $('.filterBasic-input').val("");
        $("#medwhat_consultor_send_btn").hide();
        $("#medwhat_consultor_speech").show();
        contentMedWhatConsultor.getInfo(q);
	})
    .on("keyup.app_direct_communicator", "#input_search", function()
    {
        if($("#input_search").val())
        {
            $("#medwhat_consultor_send_btn").show();
            $("#medwhat_consultor_speech").hide();
        } else
        {
            $("#medwhat_consultor_send_btn").hide();
            $("#medwhat_consultor_speech").show();
        }
    });