/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageAppHelp.css"/>');

/* VARIABLES */

            	        
var pageAppHelp = {
		
	$page : null,
	pendingGetData: null,
	step: 0,
	totalSteps : 0,
	resW : 0,
	resH: 0,
	dppx: 0,
	dpi: 0,
	slideIndex: 0,
	
    getData: function()
    {
    	showLoading();
        Nire.connection.appHelp(pageAppHelp.resW, pageAppHelp.resH, pageAppHelp.dpi)
	        .done(function(json_response) {
	          pageAppHelp.addContent(json_response.data);
	        })
	        .always(function(){
	        	hideLoading();
	        });
    },
    
    createHeader: function()
    {
        $( "#app_header" ).empty();
        try {
        	$( "#app_header" ).toolbar( "destroy" );
        } catch (e) {
        	$( "#app_header" ).toolbar().toolbar( "destroy" );
		}
    },

    addContent: function(json)
    {
    	// Si se nos paso el parámetro onlynew, de la lista de imagenes
    	// nos quedamos únicamente con aquellas que no han sido vistas.
    	if(getURLParameter("onlynew") == "true" ) {
	    	var viewed = this.getViewedImages();
	    	json = json.filter(function(item) { return viewed.indexOf(item.id) === -1; })
	    }

    	pageAppHelp.totalSteps = json.length;
        pageAppHelp.showImages(json);

        // Almacenamos los ids de las iamgenes que fueron mostradas
        pageAppHelp.setViewedImages( json.map(function(item) { return item.id }) );
	},

	getViewedImages: function()
	{
		var strJson = Nire.localStorage.getItem("viewed_app_help");
		var result = strJson ? JSON.parse(strJson) : [];

		return result;
	},

	setViewedImages: function( idImagesList )
	{
		var previous = this.getViewedImages();
		previous.push.apply(previous, idImagesList);
		
		// Eliminamos los ids repetidos
		previous = previous.sort().filter(function(element, index, array) {
  			return element !== array[index - 1]
		});

		Nire.localStorage.setItem("viewed_app_help", JSON.stringify(previous));
	},

	showImages: function(json)
	{
		console.log(json);
		console.log(json.length);
		
		var html = "";
		var html_bullets = "";
		$.each( json, function( i, item )
		{
			html += '<div id="div_img'+i+'"><img style = "width: 100%; height: 100%;" src="'+item.url+'"/></div>';
			if( i == 0) html_bullets +='<div id = "bullet_'+i+'" data-bullet = "'+i+'" class = "normal_bullet active_bullet"></div>';
			else html_bullets +='<div id = "bullet_'+i+'" data-bullet = "'+i+'" class = "normal_bullet"></div>';
			
		});	
		
		$("#slide2").html(html);
		$("#div_bullets").html(html_bullets);
		
        pageAppHelp.ScaleSlider(0);
        
        pageAppHelp.$page.trigger("updatelayout");
	},
  
	ScaleSlider: function(index)
	{
		var initial_bullet;
		var _SlideshowTransitions = [
		    //Fade
			{ 
				$Duration: 800, 
				$Opacity: 2 
			}
		];
		
		var options = 
		{
			$AutoPlay: false,                                    //[Optional] Whether to auto play, to enable slideshow, this option must be set to true, default value is false
			$AutoPlaySteps: 1,                                  //[Optional] Steps to go for each navigation request (this options applys only when slideshow disabled), the default value is 1
			$AutoPlayInterval: 3000,                            //[Optional] Interval (in milliseconds) to go for next slide since the previous stopped if the slider is auto playing, default value is 3000
			$PauseOnHover: 1,                               //[Optional] Whether to pause when mouse over if a slider is auto playing, 0 no pause, 1 pause for desktop, 2 pause for touch device, 3 pause for desktop and touch device, default value is 1
			$Loop: 0,
			$ArrowKeyNavigation: true,   			            //[Optional] Allows keyboard (arrow key) navigation or not, default value is false
			$SlideDuration: 400,                                //[Optional] Specifies default duration (swipe) for slide in milliseconds, default value is 500
			$MinDragOffsetToSlide: 20,                          //[Optional] Minimum drag offset to trigger slide , default value is 20
			$SlideSpacing: 0, 					                //[Optional] Space between each slide in pixels, default value is 0
			$DisplayPieces: 1,                                  //[Optional] Number of pieces to display (the slideshow would be disabled if the value is set to greater than 1), the default value is 1
			$ParkingPosition: 0,                                //[Optional] The offset position to park slide (this options applys only when slideshow disabled), default value is 0.
			$UISearchMode: 1,                                   //[Optional] The way (0 parellel, 1 recursive, default value is 1) to search UI components (slides container, loading screen, navigator container, arrow navigator container, thumbnail navigator container etc).
			$PlayOrientation: 1,                                //[Optional] Orientation to play slide (for auto play, navigation), 1 horizental, 2 vertical, default value is 1
			$DragOrientation: 1,                                //[Optional] Orientation to drag slide, 0 no drag, 1 horizental, 2 vertical, 3 either, default value is 1 (Note that the $DragOrientation should be the same as $PlayOrientation when $DisplayPieces is greater than 1, or parking position is not 0)

			$SlideshowOptions: 
			{                                //[Optional] Options to specify and enable slideshow or not
				$Class: $JssorSlideshowRunner$,                 //[Required] Class to create instance of slideshow
				$Transitions: _SlideshowTransitions,            //[Required] An array of slideshow transitions to play slideshow
				$TransitionsOrder: 1,                           //[Optional] The way to choose transition to play slide, 1 Sequence, 0 Random
				$ShowLink: true                                    //[Optional] Whether to bring slide link on top of the slider when slideshow is running, default value is false
			},

			$BulletNavigatorOptions: 
			{                                //[Optional] Options to specify and enable navigator or not
				$Class: $JssorBulletNavigator$,                       //[Required] Class to create navigator instance
				$ChanceToShow: 0,                               //[Required] 0 Never, 1 Mouse Over, 2 Always
				$AutoCenter: 0,                                 //[Optional] Auto center navigator in parent container, 0 None, 1 Horizontal, 2 Vertical, 3 Both, default value is 0
				$Steps: 1,                                      //[Optional] Steps to go for each navigation request, default value is 1
				$Lanes: 1,                                      //[Optional] Specify lanes to arrange items, default value is 1
				$SpacingX: 10,                                   //[Optional] Horizontal space between each item in pixel, default value is 0
				$SpacingY: 10,                                   //[Optional] Vertical space between each item in pixel, default value is 0
				$Orientation: 1                                 //[Optional] The orientation of the navigator, 1 horizontal, 2 vertical, default value is 1
			},

			$ArrowNavigatorOptions: 
			{
				$Class: $JssorArrowNavigator$,              //[Requried] Class to create arrow navigator instance
				$ChanceToShow: 0,                               //[Required] 0 Never, 1 Mouse Over, 2 Always
				$Steps: 1                                       //[Optional] Steps to go for each navigation request, default value is 1
			}
		};
		
		var jssor_slider1 = new $JssorSlider$("slider1_container", options);

		var parentWidth = jssor_slider1.$Elmt.parentNode.clientWidth;

		jssor_slider1.$SetScaleWidth(Math.min(parentWidth, $( window ).width()));

 		$("#slider1_container").height( $( window ).height() );
 		
	    jssor_slider1.$On($JssorSlider$.$EVT_SWIPE_START, function(position, virtualPosition){ 
	    	initial_bullet = position;
	    	$("#bullet_"+position).removeClass("active_bullet");
	    });
	    
	    jssor_slider1.$On($JssorSlider$.$EVT_SWIPE_END, function(position, virtualPosition){   	
	    	//pageAppHelp.totalSteps
	    	$("#bullet_"+position).addClass("active_bullet");

	    	
	    });
	    
//	    function PlayToClickEventHandler() {
//            //jssor_slider1.$PlayTo(jssor_slider1.$PlayTo(index));
//	    	console.log("playto");
//	    	console.log(pageAppHelp.slideIndex);
//            jssor_slider1.$PlayTo(pageAppHelp.slideIndex);
//        }
	    
	    $(".normal_bullet").bind("click", function(){
	    	console.log("playto");
	    	console.log($(this).attr("data-bullet"));
            jssor_slider1.$PlayTo($(this).attr("data-bullet"));
	  });

    },
	
    
    calculateScreen: function()
    {
    	pageAppHelp.dppx = window.devicePixelRatio;
    	pageAppHelp.resW = (window.screen.width * pageAppHelp.dppx);
    	pageAppHelp.resH = (window.screen.height * pageAppHelp.dppx);
    	pageAppHelp.dpi = calculateDPI();   
    	
    	pageAppHelp.getData(Nire.localStorage.getItem("lastHelpLoaded") );
	}  
};

/* EVENTS */

$( window ).off( ".appHelp" )
    .on("resize.appHelp", function()
    {
    	if(pageAppHelp) {
    		pageAppHelp.ScaleSlider(0);
    	}
    });

$( document ).off( ".appHelp" )
	
	.on("pagecreate.appHelp", "#page_appHelp", function()
    {
		pageAppHelp.$page = $(this);
    })

    .on("pagecontainershow.appHelp", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_appHelp")
    	{
    		pageAppHelp.createHeader();
        	pageAppHelp.calculateScreen();
    	}
    })
    
    .on("pageremove.appHelp", "#page_appHelp", function()
	{
    	$( window ).off( ".appHelp" );
    	$( document ).off( ".appHelp" );
		$( 'link[href="css/pageAppHelp.css"]' ).remove();
		pageAppHelp = null;
	});