/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageClinicHistory.css"/>');

/* VARIABLES */

var pageClinicHistory = {
	
	$page: null,

    getData: function( date)
    {
    	showLoading();
        var offset = new Date().getTimezoneOffset();
    	Nire.connection.clinicHistory(date, offset)
    		.done(function(json_response) {
                //debugger
				hideLoading();
				if (json_response.error.code == 0)
				{
					pageClinicHistory.createBody(json_response.data, date);
				}
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
    		});
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_clinic_history").html())
        
        pageClinicHistory.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["clinic_history_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },


	createBody: function(ajson_body, date)
	{
		var _this = this;
		console.log(ajson_body);
		var template_type_wrapper_item = Handlebars.compile($("#template-body_clinic_history").html());
		var tracks = [];
		var actual_year = 0;
		
        $.each(ajson_body.body.history, function(i, item) {

        	var icon = "img/others/ic_"+item.type+".png";

        	    var date = parseDateFromYYYYMMDD("" + item.date);
        	    var yyyy = date.getFullYear();
        	    if (yyyy != actual_year)
        	    	var year = yyyy;
        	    else
        	    	var year = null;
        	    
        	    actual_year = yyyy;

        	
        	
        	datos_item =  {
        		date: getDateFormatted4(item.date), 
        		icon: icon,      
                title: item.title,
                content: item.content,
                place: item.place,
                year: year
            };
        	
        	var type_wrapper_item = $(template_type_wrapper_item(datos_item)).jqmData("nire", item);
        	tracks.push( type_wrapper_item );	
        });
        
        // Borramos los tracks anteriores y agregamos los nuevos
        if ( tracks.length > 0 )
        {
            pageClinicHistory.$page.find(".clinic_history_content").prepend('<div class = "linea_blanca_sup"></div>');
            $("#clinic_history_wrapper").html(tracks).trigger("updatelayout");
        }
        else
        {
            pageClinicHistory.setEmptyContent();
        }
		setTimeout(function(){
	    	$( "#page_clinicHistory" ).css({
				   'background' : 'url(img/backgrounds/bg_degraded.jpg)',
				   'background-size' : 'cover',
				   'background-repeat':'no-repeat',
				   'background-position':'center top'
				}).show().trigger("updatelayout");
		}, 500);
        
	},

    resetEmptyContent: function()
    {
        $("#clinic_history_timeline_empty_content").css("display", "none");
        $("#clinic_history_timeline_content").show();
    },
   
    setEmptyContent: function()
    {
        $("#clinic_history_timeline_content").hide();
        $("#clinic_history_timeline_empty_content").show().trigger( "updatelayout" );
        
        var $current_content = pageClinicHistory.$page.find(".ui-content");
        var int_content_height = getContentHeightToFillScreen(
                                    $("#app_header"),
                                    $current_content,
                                    null
                                );
                
        $("#clinic_history_timeline_empty_content img")
            .one("load", function(){
                
                $("#clinic_history_timeline_empty_content .centered_in_empty_content")
                .css("margin-top", Math.round( (int_content_height - $("#clinic_history_timeline_navbar").outerHeight() - $("#clinic_history_timeline_empty_content .centered_in_empty_content").outerHeight())/2) +"px");
            })
            .each(function(){
                if(this.complete)
                    $(this).trigger("load");
            });
    },  
};

/* EVENTS */

$( window ).off(".clinicHistory")
    .on("resize.clinicHistory", function()
    {
        if(pageClinicHistory) {
            if ($("#clinic_history_timeline_empty_content").is(":visible"))
                pageClinicHistory.setEmptyContent();
        }
    });

$(document).off( ".clinicHistory" )
    
    .on("pagecreate.clinicHistory", "#page_clinicHistory", function()
	{
    	pageClinicHistory.$page = $(this);
    	
    	var date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : moment().hour(0).minute(0).second(0);
    	$( "#page_clinicHistory" ).css({
			   'background' : 'url(img/backgrounds/bg_degraded.jpg)',
			   'background-size' : 'cover',
			   'background-repeat':'no-repeat',
			   'background-position':'center top'
			}).show().trigger("updatelayout");
	})

    .on("pagecontainershow.clinicHistory", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_clinicHistory") {
    		pageClinicHistory.createHeader();
    	}
    })
    
    .on( "pagecontainerchange.clinicHistory", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_clinicHistory") {
    		
    		date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : null;
	    			
    		pageClinicHistory.getData(date);
    		
    	} else if ( ui.prevPage.attr("id") == "page_clinicHistory" && ui.toPage.attr("id") != "page_clinicHistory" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {
    		
			$("#page_clinicHistory").trigger( "pageremove" );
			$("#page_clinicHistory").remove();
		}
	})

    .on("pageremove.clinicHistory", "#page_clinicHistory", function()
	{
    	$(window).off( ".clinicHistory" );
    	$(document).off( ".clinicHistory" );
		$( 'link[href="css/pageClinicHistory.css"]' ).remove();
		pageClinicHistory = null;
	})
	
	
    .on("click.clinicHistory", "#btn_pending_notifications:visible", function()
	{		
		cloneAppHeader(pageClinicHistory.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});
