/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageClinicHistoryExplorer.css"/>');

/* VARIABLES */

var pageClinicHistoryExplorer = {
	
	$page: null,
	$total_items: false,
	$swipeA: false,
	animationsDuration: 600,

    getData: function( date)
    {
    	showLoading();
		
    	//pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper").click();	
    	
        var offset = new Date().getTimezoneOffset();
    	Nire.connection.clinicHistoryExplorer(date, offset)
    		.done(function(json_response) {
				if (json_response.error.code == 0)
				{
					pageClinicHistoryExplorer.createBody(json_response.data, date);
				}
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
    		})
    		.always(function(){
    			hideLoading();
    		});
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_clinic_history_explorer").html())
        
        pageClinicHistoryExplorer.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["clinic_history_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },


	createBody: function(ajson_body, date)
	{
		var _this = this;
		var template_type_wrapper_item = Handlebars.compile($("#template-body_clinic_history_explorer").html());
		var tracks = [];
		var actual_year = 0;
		
		pageClinicHistoryExplorer.$total_items = ajson_body.body.history.length;
		
        $.each(ajson_body.body.history, function(i, item) {
        	
        	if (item.last_date == "")
        		var last_date = gjson_lang.no_activity;
        	else
        		var last_date  = item.last_date;
        	
        	datos_item =  {
        		type: item.type,
        		items: item.content.length + " "+gjson_lang.items,
        		last_date: gjson_lang.more_recent+": "+last_date,
        		position: i,
        		content: item.content,
            };
        	
        	var type_wrapper_item = $(template_type_wrapper_item(datos_item)).jqmData("nire", datos_item);
        	tracks.push( type_wrapper_item );	
        });
        
     	// Borramos los tracks anteriores y agregamos los nuevos
     	if ( tracks.length > 0 )
        	pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper").html(tracks).trigger("updatelayout");
        else
        	pageClinicHistoryExplorer.setEmptyContent();        
	},
	
	showServiceDetail: function(json)
	{
		pageClinicHistoryExplorer.writeDetails(json[0], true);
	},
	
	showDetails: function(item)
	{
		pageClinicHistoryExplorer.$page.find(".card").flip(true);
		pageClinicHistoryExplorer.$page.find(".container_detail").children().css("display", "none");
		pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div").addClass("detail_div_"+item.attr("data-type"));
		pageClinicHistoryExplorer.$page.find(".container_"+item.attr("data-type")).css("display", "block");
		pageClinicHistoryExplorer.$page.find("#obj_"+item.attr("data-type")).css("display", "block");
		
	
		if( item.attr("data-type") == "pdf")	
		{
			pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper").css("display", "none");
		}	
		else
			pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper").css("display", "block");
	},
	
	restoreDetailClass: function()
	{
		pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div").removeClass("detail_div_pdf");
		pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div").removeClass("detail_div_image");
		pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div").removeClass("detail_div_text");		
	},

	writeDetails: function(item, detail)
	{
	  if (item.text != null)
	  {
		  pageClinicHistoryExplorer.$page.find("#obj_text").text(item.text);
		  pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type", "text");	
		  pageClinicHistoryExplorer.$page.find("#btn_full_screen").css("display", "none");		  
	  }  
	  else 	if (item.image != null)
	  {
		  pageClinicHistoryExplorer.$page.find("#obj_image img").attr("src", item.image);
		  pageClinicHistoryExplorer.$page.find("#obj_image").attr("href", item.image);  
		  pageClinicHistoryExplorer.$page.find("#btn_full_screen").attr("href", item.image);  
		  pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type", "image");	
		  pageClinicHistoryExplorer.$page.find("#btn_full_screen").css("display", "block");
	  }
		  
	  else 	if (item.pdf != null)
	  {
		  //pageClinicHistoryExplorer.$page.find("#obj_pdf").attr("src","http://docs.google.com/viewer?url="+item.pdf+'&a=v&pid=explorer&chrome=false&api=true&embedded=true');
		  //pageClinicHistoryExplorer.$page.find("#obj_pdf").attr("href","http://docs.google.com/viewer?url="+item.pdf+"&a=v&pid=explorer&chrome=false&api=true&embedded=true");
		  pageClinicHistoryExplorer.$page.find("#obj_pdf").jqmData("pdf", item.pdf);
		  pageClinicHistoryExplorer.$page.find("#obj_pdf").attr("href",item.pdf);
		  pageClinicHistoryExplorer.$page.find("#obj_pdf img").attr("src","http://core0.staticworld.net/images/article/2013/02/pdf-logo-100025338-gallery.png");
		  //pageClinicHistoryExplorer.$page.find("#btn_full_screen").attr("href","http://docs.google.com/viewer?url="+item.pdf+"&embedded=true");
		  pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type", "pdf");	
		  pageClinicHistoryExplorer.$page.find("#btn_full_screen").css("display", "block");
	  }

      else  if (item.json != null)
      {
        var template_detail = Handlebars.compile($("#template-clinic_history_details").html());
        var item = {item:item.json}
        var templateText = template_detail(item)
          pageClinicHistoryExplorer.$page.find("#obj_text").html(templateText);
          pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type", "text");   
          pageClinicHistoryExplorer.$page.find("#btn_full_screen").css("display", "none");
      }
	  
	  if(detail)
		  pageClinicHistoryExplorer.showDetails(pageClinicHistoryExplorer.$page.find("#btn_details"));
	},

	resetEmptyContent: function()
	{
		$("#clinic_history_explorer_empty_content").css("display", "none");
		$("#clinic_history_explorer_content").show();
	},
	
	setEmptyContent: function()
	{
		$("#clinic_history_explorer_content").hide();
		$("#clinic_history_explorer_empty_content").show().trigger( "updatelayout" );
		
		var $current_content = pageClinicHistoryExplorer.$page.find(".ui-content");
		var int_content_height = getContentHeightToFillScreen(
									$("#app_header"),
									$current_content,
									null
								);

		var int_content_margins = $current_content.outerHeight() - $current_content.height();

		$("#clinic_history_explorer_empty_content img")
			.one("load", function(){
				
				$("#clinic_history_explorer_empty_content .centered_in_empty_content")
				.css("margin-top", Math.round( (int_content_height - int_content_margins - $("#clinic_history_explorer_navbar").outerHeight() - $("#clinic_history_explorer_empty_content .centered_in_empty_content").outerHeight())/2) +"px");
			})
			.each(function(){
				if(this.complete)
					$(this).trigger("load");
			});
	}

};

/* EVENTS */

$( window ).off(".clinicHistoryExplorer")

    .on("resize.clinicHistoryExplorer", function()
    {
    	if(pageClinicHistoryExplorer) {
    		if ($("#clinic_history_explorer_empty_content").is(":visible"))
    			pageClinicHistoryExplorer.setEmptyContent();
    	}
    });

$( document ).off( ".clinicHistoryExplorer" )
    
    .on("pagecreate.clinicHistoryExplorer", "#page_clinicHistoryExplorer", function()
	{
		pageClinicHistoryExplorer.$page = $(this);
		$( "#clinicHistoryExplorer_img_background" ).css("background", "url(img/backgrounds/bg_degraded.jpg)");
		
		var date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : moment().hour(0).minute(0).second(0);

		pageClinicHistoryExplorer.$page.find( "#clinic_explorer_detail_div" ).swipe(
		{
			swipeDown: function( )
			{
				if( pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper").hasClass("clinic_history_explorer_wrapper_bottom") )
					pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper")[0].click();	
			}
		});
      
		pageClinicHistoryExplorer.$page.find( "#clinic_history_explorer_wrapper" ).swipe(
		{
			swipeUp: function( event, phase, direction, distance, duration, fingers )
			{
                if ( pageClinicHistoryExplorer.$page.find( "#clinic_history_explorer_wrapper" ).hasClass("clinic_history_explorer_wrapper_bottom") )
					pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper")[0].click();
			}
		});
    	      
		pageClinicHistoryExplorer.$page.find( "#clinic_history_explorer_wrapper" ).swipe("disable");
		pageClinicHistoryExplorer.$swipeA = false;
	})

    .on("pagecontainershow.clinicHistoryExplorer", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_clinicHistoryExplorer") {
    		pageClinicHistoryExplorer.createHeader();    	
        	pageClinicHistoryExplorer.$page.find(".card").flip({
          		trigger: 'manual'
        	});
    	}
    })
    
    .on( "pagecontainerchange.clinicHistoryExplorer", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_clinicHistoryExplorer") 
    	{
    		date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : null;
        	pageClinicHistoryExplorer.getData(date);
    	}
    	else if ( ui.prevPage.attr("id") == "page_clinicHistoryExplorer" && ui.toPage.attr("id") != "page_clinicHistoryExplorer" 
    		&& ui.toPage.attr("id") != "page_app_direct_communicator" ) 
    	{
    		$("#page_clinicHistoryExplorer").trigger( "pageremove" );
    		$("#page_clinicHistoryExplorer").remove();
    	}
	})

    .on("pageremove.clinicHistoryExplorer", "#page_clinicHistoryExplorer", function()
	{
    	$( window ).off( ".clinicHistoryExplorer" );
    	$( document ).off( ".clinicHistoryExplorer" );
		$( 'link[href="css/pageClinicHistoryExplorer.css"]' ).remove();
		pageClinicHistoryExplorer = null;
	})

	.on("click.clinicHistoryExplorer", "#btn_details", function(e)
	{		
    	e.preventDefault();

    	if ($(this).attr("data-service") == "true")
    	{
    		showLoading();
    		var offset = new Date().getTimezoneOffset();
        	Nire.connection.clinicHistoryExplorerDetail(date, offset, $(this).attr("data-id"))
        		.done(function(json_response) {
    				if (json_response.error.code == 0)
    				{
    					pageClinicHistoryExplorer.showServiceDetail(json_response.data.body);
    					hideLoading();
    				}
    				else
    					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
        		})
        	  .always(function()
        	  {
        		hideLoading();
        	  });
    	}
    	else
    	{
    		pageClinicHistoryExplorer.showDetails($(this));
    	}
		return false;
	})

	.on("click.clinicHistoryExplorer", "#btn_detail_close", function(event)
	{
		pageClinicHistoryExplorer.$page.find(".card").flip(false);
		pageClinicHistoryExplorer.restoreDetailClass();
		pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper").show();
	})
	
	.on("click.clinicHistoryExplorer", "#btn_full_screen, #obj_pdf", function()
	{
		if (pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type") ==  "pdf")
		{
			event.preventDefault();
			checkAppPDF($(this).jqmData("pdf"));
			
			return false;			
		}

	})

	.on("click.clinicHistoryExplorer", "#btn_pdf_share", function()
	{		
		event.preventDefault();
		//hideLoading();
		showLoading();
		if (pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type") == "text")
			window.plugins.socialsharing.share(null, null, pageClinicHistoryExplorer.$page.find("#obj_text").text(), null, hideLoading);
		
		else if (pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type") == "image")
			window.plugins.socialsharing.share(null, null, pageClinicHistoryExplorer.$page.find("#obj_image").attr("href"), null, hideLoading);
		
		else if (pageClinicHistoryExplorer.$page.find("#btn_details").attr("data-type") == "pdf")
			window.plugins.socialsharing.share(null, null, pageClinicHistoryExplorer.$page.find("#obj_pdf").attr("href"), null, hideLoading)

		return false;
	})
	
	.on("click.clinicHistoryExplorer", "#btn_pending_notifications:visible", function()
	{		
		cloneAppHeader(pageClinicHistoryExplorer.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	})
	;

	$("#clinic_history_explorer_wrapper").off(".clinicHistoryExplorer").on("click.clinicHistoryExplorer", ".clinic_history_explorer_wrapper", function(e)
	{
	    e.preventDefault();
	    e.stopImmediatePropagation();

	    var _this = $(this);
	      
	    var y = e.pageY;
	    pageClinicHistoryExplorer.restoreDetailClass();

	    $("#obj_pdf").css("display", "none");
	    $("#obj_pdf").jqmData("pdf", null);
	    $("#obj_pdf img").attr("src", "");
	    $("#obj_image img").attr("src", "");
	    
	    if (pageClinicHistoryExplorer.$swipeA == true)
	    {
	      	pageClinicHistoryExplorer.$page.find( "#clinic_history_explorer_wrapper" ).swipe("disable");
	      	pageClinicHistoryExplorer.$swipeA = false;
	    }
	      	
	    if( pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div").css("display") == "none")
	    {

	    	pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_content_wrapper").hide().trigger("updatelayout");
	      
	      	if ( $(this).jqmData("action-hide") == null)
	      	{
	      		pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper").jqmData("action-hide", null);
	      				
	      		if ($(this).data("nire").position > 1)
	      		{
	      			content_height = _this.find(".clinic_history_explorer_content_wrapper").height();
		      		$("#page_clinicHistoryExplorer").animate({
		      			scrollTop: content_height
		      		}, 250);
	      		}
	      		_this.find(".clinic_history_explorer_content_wrapper").show().trigger("updatelayout");
	      		_this.jqmData("action-hide", true);
	      	}
	      	else
	      	{
	      		_this.jqmData("action-hide", null);	
	      		pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_content")
	      		.stop()
	      		.animate(
	      				{ "margin-top": 0 }, 
                        { duration: 250, queue: false, done: function(){
                        		_this.find(".clinic_history_explorer_content_wrapper").hide().trigger("updatelayout");
                            	_this.jqmData("action-hide", null);
                        }}
                );
	      	}
		}
		else
		{
	    	pageClinicHistoryExplorer.$page.find(".card").flip(false);
			var $clinic_history_explorer_wrapper = pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper");
			
			var top = $(".clinic_history_explorer_wrapper.selected_bottom").offset().top;
			var margin_top = parseInt($("#clinic_explorer_detail_div").css("margin-top"));
			
			pageClinicHistoryExplorer.$page.find(".clinic_explorer_detail_div")
				.stop()
				.animate(
					{ top: top+margin_top, opacity: 0.25 },
					{
						duration: pageClinicHistoryExplorer.animationsDuration,
						queue: false,
						done: function(){
							$("#clinic_explorer_detail_div").hide();
							$("#clinic_explorer_detail_div").removeAttr('style');
							$clinic_history_explorer_wrapper.css({"opacity": "1", "width": "auto"});
						},
						complete: function(){
							//debugger;
							$clinic_history_explorer_wrapper.show().trigger("updatelayout");
							$clinic_history_explorer_wrapper
								.stop()
								.animate(
									{top:"-=70%"},
									{
										duration: pageClinicHistoryExplorer.animationsDuration,
										queue: false,
										done: function(){
											//debugger;
											$("#page_title").text(gjson_lang.clinic_history_title);
											$clinic_history_explorer_wrapper.children().removeClass("selected_bottom");
											$clinic_history_explorer_wrapper.children().css("height", "auto");
											// pageClinicHistoryExplorer.$page.find(".type_title").show(); 
											// pageClinicHistoryExplorer.$page.find(".type_detail").show(); 
											pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper").children().removeClass("selected_bottom");   	   
											$clinic_history_explorer_wrapper.children().css("opacity", "1"); 
											$clinic_history_explorer_wrapper.removeClass("clinic_history_explorer_wrapper_bottom");  
											pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_content").css("margin-top", "0"); 
											$clinic_history_explorer_wrapper.css("top", "auto");

										}
									}
								);
						}
					}
				);
	    	  
			pageClinicHistoryExplorer.$page.find(".ui-navbar").fadeTo( "slow" , 1);
		}
		return false;
	})

	.on("click.clinicHistoryExplorer", ".clinic_history_explorer_subcontent", function(e)
	{
		e.preventDefault();
		e.stopImmediatePropagation();

		$this_ = $(this);
		var item = $(this).parent().parent().data("nire");
		var item_position =$(this).attr("data-item");
		$(this).parent().parent().jqmData("action-hide", null);
		var $clinic_history_explorer_wrapper = pageClinicHistoryExplorer.$page.find("#clinic_history_explorer_wrapper");
		var children = $clinic_history_explorer_wrapper.children();
		var selected_child_zindex = null;
		var $clinic_explorer_detail_div = pageClinicHistoryExplorer.$page.find("#clinic_explorer_detail_div");

		if (pageClinicHistoryExplorer.$swipeA == false)
		{
			pageClinicHistoryExplorer.$page.find( "#clinic_history_explorer_wrapper" ).swipe("enable");
			pageClinicHistoryExplorer.$swipeA = true;
		}
		  pageClinicHistoryExplorer.$page.find(".ui-navbar").fadeTo( "slow" , 0);
		  pageClinicHistoryExplorer.$page.find(".ui-navbar").css( "display" , "none");
		  $clinic_history_explorer_wrapper.stop()
	        .animate(
	        	{ top: "80%" },
	        	pageClinicHistoryExplorer.animationsDuration,
	        	function (){
					pageClinicHistoryExplorer.$page.find(".clinic_history_explorer_wrapper").children(".clinic_history_explorer_content_wrapper").hide(); 
					$clinic_history_explorer_wrapper.addClass("clinic_history_explorer_wrapper_bottom");
					$this_.parent().parent().addClass("selected_bottom");
					var incremento_entre_elementos = 0.8/children.length;
					var opacidad_inicial = 0.1;
					children.each(function(idx, val){
						if ( !$(this).hasClass("selected_bottom") )
							$(this).css('opacity', opacidad_inicial + (idx*incremento_entre_elementos));
						else
							selected_child_zindex = idx*2;
						$(this).css("height", 100/(children.length)+"%");
					});
	        	}
	        );
		  
		  console.log(item.content[item_position]);
		  $("#page_title").text(item.type);
		  $clinic_explorer_detail_div.find(".content_title").text(item.content[item_position].title);
		  $clinic_explorer_detail_div.find(".items_detail").text(item.content[item_position].place);
		  $clinic_explorer_detail_div.find(".last_date_detail").text(item.content[item_position].date);
		  
		  if (item.content[item_position].details == "")
		  {
			  // No tiene detalle
			  $("#btn_details").hide();
		  }
		  else if (item.content[item_position].details[0].text == null && item.content[item_position].details[0].image == null && item.content[item_position].details[0].pdf == null && item.content[item_position].details[0].json == null)
		  {
			  //llamo a un servicio
			  $("#btn_details").attr("data-service", "true");	
			  $("#btn_details").attr("data-id", item.content[item_position].id);	
			  $("#btn_details").show();				  
		  }
		  else
		  {
			  $("#btn_details").attr("data-service", "false");	
			  $("#btn_details").show();	
			  pageClinicHistoryExplorer.writeDetails(item.content[item_position].details[0]);
		  }
		  
		pageClinicHistoryExplorer.$page.find(".clinic_explorer_detail_div").fadeIn();
		pageClinicHistoryExplorer.$page.find(".clinic_explorer_detail_div").animate({marginTop:"-=49em"},1000);		

		return false;
	});