/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageHealthHelp.css"/>');

/* VARIABLES */
var pageHealthHelp = {

    getData : function()
    {
    	showLoading();

        $("#searchBtn").text("Buscar");
    },

    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header").html());

        $( "#app_header" ).html( template({ title: gjson_lang["help_title"] }) );
        $( "#app_header" ).toolbar( "refresh" );
        $( "#app_header" ).show();
        $( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();
    },

    createPage : function(ajson)
    {
        // Borramos los indicadores anteriores y agregamos los nuevos
        $("#div_health_faq_list").empty().append(json.answer).trigger( "updatelayout" );
    },

    getInfo : function(q)
    {
        var  port = 8080;
        var serv = "http://serverb.medwhat.com:";

        $.ajax({
            type: "GET",
            url: serv + port +"/engine4_release/search_engine.jsp?q=" + q + "&passcode=mwt!",
            cache: false,
            crossDomain: true,
            success: function(json_response){
                pageHealthHelp.createPage(json_response);
            }
        });
    }

};

/* EVENTS */

$( document ).off( ".health_help" )

    .on( "pagecreate.health_help", "#page_health_help", function()
    {
	   $( "#app_header" ).toolbar();
    })

    .on("pageshow.health_help", "#page_health_help", function()
    {
    	pageHealthHelp.createHeader();
        pageHealthHelp.getData();
    })

    .on("pageremove.health_help", "#page_health_help", function()
    {
        $( document ).off( ".health_help" );
        $( 'link[href="css/pageHealthHelp.css"]' ).remove();
        pageHealthHelp = null;
    })
    
    .on("click.health_help", "#searchBtn", function()
    {        
        var q = $('#filterBasic-input').val();
        pageHealthHelp.getInfo(q);
    });