/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageHealthHome.css"/>');

/* VARIABLES */

var pageHealthHome = {

	$page : null,

    getData : function($page)
    {
    	showLoading();

    	pageHealthHome.$page = $page;

    	Nire.connection.health()
    		.done(function(json_response) {
				hideLoading();
				if (json_response.error.code == 0)
                {
					pageHealthHome.addContent(json_response.data);
                }
				else{
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
                }
    		});
    },

    createHeader : function()
    {
    	var template = Handlebars.compile($("#template-header_health_home").html());
        
    	pageHealthHome.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["health_home_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },


    addContent : function(json)
    {
    	pageHealthHome.createIndicators(json.body.indicators);
	},

    createIndicators : function(ajson_indicators)
    {
        var _this = this;
        var template_health_indicator = Handlebars.compile($('#template-indicators_health_home').html());

        var indicators = [];

        var gridPositions = ["ui-block-a", "ui-block-b"];

        $.each(ajson_indicators, function(i, item){
        	
        	var b_disabled = false;
        	var img_icon = ajson_indicators[i].type;
            var str_quantity = ajson_indicators[i].quantity;
            var str_quantity_class = "track";
        	
        	if (ajson_indicators[i].active == 1 && ajson_indicators[i].alert == 1)
        	{
        		img_icon = ajson_indicators[i].type +'_alert';
                str_quantity_class = "track_alert";
        	}
        	else if (ajson_indicators[i].active == 0)
            {
        		str_quantity = gjson_lang["no_data"];
            	b_disabled = true;
            }

            var datos_indicators = {
                block_class: gridPositions[i % 2],
                disabled_class: (b_disabled) ? "ui-state-disabled" : null,
                img_icon: img_icon,
                quantity_class: str_quantity_class,
                quantity: str_quantity,
                title: gjson_lang[ajson_indicators[i].type],
                subtitle: ajson_indicators[i].subtitle
            }

            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var indicator = $(template_health_indicator(datos_indicators)).data("info", this);
            indicator.find(".track_body").data( "nire", this );
            // Agregamos el indicador a la lista de indicadores que se mostraran
            indicators.push( indicator );

        });

        // Borramos los indicadores anteriores y agregamos los nuevos
        $("#health_home_track").empty().append(indicators).trigger( "updatelayout" );

        indicatorsImageErrorControl();
        
        pageHealthHome.adjustSizesOfIndicators();
	},

	adjustSizesOfIndicators: function()
	{
		var width = pageHealthHome.$page.find(".track_body").width();
		if (width)
			pageHealthHome.$page.find(".track_body").css("height", width );
	},

    /**
     * Ver el detalle de un track
     */
    viewDetail: function($element)
    {
        var data = $element.data("nire");

        var url = "indicatorDetail.html?content=#id#";
        url = url.replace("#id#", data.type);

        $( "body" ).pagecontainer( "change", url );
    }

};

/* EVENTS */

$( window ).off( ".health_home" )
    .on("resize.health_home", function()
    {
    	if(pageHealthHome) {
    		pageHealthHome.adjustSizesOfIndicators();
    		adjustSizeOfGridFooterActions($("#page_health_home"));
    	}
    });

$( document ).off( ".health_home" )

    .on( "pagecreate.health_home", "#page_health_home", function()
    {
	   //$( "#panel_app" ).panel();
    	pageHealthHome.$page = $(this);
    })

    .on("pagecontainershow.health_home", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_health_home") {
	    	pageHealthHome.createHeader();
	    	adjustSizeOfGridFooterActions($("#page_health_home"));
    	}
    })
    
    .on( "pagecontainerchange.health_home", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_health_home") {
    		
    		menuHome.getData();
    		pageHealthHome.getData(pageHealthHome.$page);
    		pageHealthHome.adjustSizesOfIndicators();
    	} else if ( ui.prevPage.attr("id") == "page_health_home" && ui.toPage.attr("id") != "page_health_home" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {
    		
			$("#page_health_home").trigger( "pageremove" );
			$("#page_health_home").remove();
		}
	})

    .on("pageremove.health_home", "#page_health_home", function()
    {
        $( window ).off( ".health_home" );
        $( document ).off( ".health_home" );
    	$( 'link[href="css/pageHealthHome.css"]' ).remove();
    	pageHealthHome = null;
    })
    
    .on("click.health_home", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pageHealthHome.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	})
	
	.on("click.health_home", ".enter_detail", function()
	{		
		pageHealthHome.viewDetail($(this));
	})
	
	.on("click.health_home", "#a_panel_app_section_health", function()
	{		
		Nire.localStorage.removeItem(APP_DATE_STATE);
	});