/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageHome.css"/>');
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageCoverHome.css"/>');

/* VARIABLES */
var pageHome = {

	$page: null,
	pendingGetData: null,
    newUser: false,
    animationDuration: 500,
    dateselectorNumItems: 3,

	cancelGetData: function()
	{
    	// Si habia un getData calendarizado lo cancelamos
    	clearTimeout( pageHome.pendingGetData );
    	pageHome.pendingGetData = null;
	},

	timedGetData: function(timeout, date)
	{
		pageHome.cancelGetData();
		pageHome.pendingGetData = setTimeout( function() {
			pageHome.getData(date);
		}, timeout);

	},

    getData : function(date)
    {
    	showLoading();
    	
    	pageHome.cancelGetData();
    	
    	var screenWidth = (window.screen.width * window.devicePixelRatio);
        var screenhHeight = (window.screen.height * window.devicePixelRatio);
        
        var offset = new Date().getTimezoneOffset();
        
    	Nire.connection.home(date, offset)
    		.done(function(data) {
    			pageHome.showData(data, date);
    			if($("#cover")[0]){
    				pageHome.emptyCover();
                }
    		})
    		.fail(function() {
    			pageHome.timedGetData(5000, date);
	        })
	        .always(function() {
	        	Nire.connection.appHelp(screenWidth, screenhHeight, calculateDPI())
		    		.done(function(json_response) {
		                pageHome.checkHelp(json_response.data);
		            })
		            .always(function(){
		            	hideLoading();
		            });
	        });        
    },
    
    checkHelp : function(data)
    {
    	if (data)
    	{
            // Si todos los id de las imagenes ya fueron vistos, no mostramos la ayuda.
            // Si falta ver alguno, mostramos la ayuda
            var viewed = this.getViewedImages();
            var current = data.map(function(item) { return item.id })

            var allViewed = current.every(function(id) { return viewed.indexOf(id) !== -1})
            if(!allViewed) {
            	pageHome.cancelGetData();
                $( "body" ).pagecontainer( "change", "appHelp.html?onlynew=true" );
            }
    	}

    },

    getViewedImages: function()
    {
        var strJson = Nire.localStorage.getItem("viewed_app_help");
        var result = strJson ? JSON.parse(strJson) : [];

        return result;
    },

    showData : function(json_response, date)
    {
		if (json_response.error.code == 0 && json_response.data.body.tracks.length > 0) {
		  	pageHome.addContent(json_response.data, date);
		} else {
			showLoading();
			pageHome.timedGetData(5000, date);
		}
    },

    /**
     * Marcar un Track como realizado
     */
    updateTrack : function($element)
    {
    	var data = $element.data("nire");

    	var date = $("#home_track_days_actual .dateselector").dateselector("date");
        if(data.section == "treatment")
            date = data.fullTime

        Nire.analytics.event( "click", "Home track update" ); 

    	Nire.connection.updateTrack(date, data.id, data.section, data.type)
    		.done(function(result){pageHome.markTrackCompleted(result, $element);});
    },

    /**
     * Ver el detalle de un track
     */
    viewDetail: function($element)
    {
    	var sectionToPage = {
    		nutrition: "nutritionDetail.html?content=#id#&date=#date#&type=#type#",
    		physicalActivity: "physicalActivityDetail.html?content=#id#&date=#date#"
    	};

    	var data = $element.data("nire");

		var url = sectionToPage[data.section];
		url = url.replace("#id#", data.id);
		url = url.replace("#type#", data.type);
		url = url.replace("#date#", $("#home_track_days_actual .dateselector").dateselector("date").format("YYYYMMDD"));

    	$( "body" ).pagecontainer( "change", url );
    },

    createHeader: function()
    {
        var template = Handlebars.compile($("#template-header_home").html());
        
        pageHome.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template() ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },

    addContent: function(json, date)
    {
    	pageHome.$page.find("#page_home_div_completed").css( "width", json.body.completed_percen +"%");
    	pageHome.$page.find("#home_message").html(json.body.message);

    	pageHome.createTracks(json.body.tracks);
    	
    	if (!pageHome.prepareTracksForAnimation()) {
    		pageHome.resetNavbarsAndTracksPosition(0);
    	} else {
    		pageHome.resetNavbarsAndTracksPosition(null, 2, function(){
    			$.mobile.silentScroll(0);
    			setTimeout(function(){	
    				//$( "#home_img_background" ).attr("src", "img/backgrounds/" + date.isoWeekday() + ".jpg").show();
    				$( "#page_home" ).css({
    					   'background' : 'url(img/backgrounds/'+date.isoWeekday()+'.jpg)'
    					}).show().trigger("updatelayout");
    			}, 500);
    		});
    	}
	},

    selectTrackImage: function(type)
    {
    	return type ? type.toLowerCase() : "fuerza";
    },

    createTracks : function(ajson_tracks)
    {
    	var gridPositions = ["ui-block-a", "ui-block-b", "ui-block-c"];
    	var track_icon_src = null;

		var container = pageHome.$page.find("#home_track");
    	container.empty();

		var template_normal = Handlebars.compile($("#template-item-normal_home").html());
		var template_new = Handlebars.compile($("#template-item-new_home").html());

		// Transformamos el estilo que nos llega de la base de datos
		// al estilo que espera la vista para ser mostrado en el home cuando se completa
		// una tarea
		var transformCompletedStyle = function(style) {
			if(style == "physicalActivity") return "track_physical_activity_completed";
			else if(style == "nutrition") return "track_nutrition_completed";
			else return "track_health_completed";
		};

		var transformStyle = function(style) {
			if(style == "physicalActivity") return "track_body_physical_activity";
			else if(style == "nutrition") return "track_body_nutrition";
			else return "track_body_health";
		};

    	$.each(ajson_tracks, function(i) {

            var enterDetail = "enter_detail";
        	if (this.title) {
	            if(this.id.toLowerCase().indexOf("p") >= 0)
	                enterDetail = "";

	            if(this.completed)
	            	track_icon_src = "img/tracks/ic_"+ this.section +"_type_"+ pageHome.selectTrackImage(this.type) +"_sel.png";
	            else
	            	track_icon_src = "img/tracks/ic_"+ this.section +"_type_"+ pageHome.selectTrackImage(this.type) + pageHome.getCustomizedImageName() +".png";

	            if(this.section == "health_medicament" || this.section == "treatment"){
	                track_icon_src = "img/tracks/ic_health_medicament_sel.png";//"img/tracks/ic_" + this.section + "_sel.png";
	                enterDetail = "";
	                this.title = this.title.slice(0,20) + "...";
	            }

				var datos_item =  {
	                enterDetail: enterDetail,
					block_class: gridPositions[i % 3],
					normal_style: transformStyle(this.section),
					completed_style: transformCompletedStyle(this.section),
					completed: this.completed,
					section: this.section,
					type: pageHome.selectTrackImage(this.type),
					track_icon_src: track_icon_src,
					quantity: this.quantity,
					title: this.title,
	                time: this.time
				};

	            var elements = $(this.type == "new"? template_new(datos_item) : template_normal(datos_item));
	            elements.disableSelection();
	            elements.find(".track_body").data( "nire", this );
        	}
			container.append(elements);
    	});
    	
    	container.trigger( "updatelayout" );

    	pageHome.adjustSizesOfTracks();    	
	},

	adjustSizesOfTracks: function()
	{
		// Si no hay Tracks no hay nada que hacer.
		if(pageHome.$page.find(".track_body").length == 0) return;
		console.log("adjust size of tracks");

		var width = pageHome.$page.find(".track_body").width();
		if (width)
			pageHome.$page.find(".track_body").height( width );
				
		var width2 = pageHome.$page.find(".track_question").width();
		if (width2)
			pageHome.$page.find(".track_question").height( width2 );
		
		//pageHome.adjustSizeOfTracksText();
	},

	/*
	adjustSizeOfTracksText: function()
	{
		var int_text_font_size = parseInt(pageHome.$page.find(".track_title").css("font-size"));
		var int_text_num_lines = 6;
		do {
			int_text_num_lines--;
			var int_total_height = pageHome.$page.find(".track_body").height();
			var int_icon_height = pageHome.$page.find(".track_icon").height();
			var int_quantity_height = pageHome.$page.find(".track_quantity").height();
			var int_base_line_height = Math.ceil((int_total_height - int_icon_height - int_quantity_height)/int_text_num_lines);
			console.log(int_base_line_height,int_text_font_size);
		}
		while ( int_base_line_height < int_text_font_size+4 );
		
		pageHome.$page.find(".track_title").css("line-height", int_base_line_height +"px");
	},
*/
    addCover: function()
    {
        //Attaching the code of the cover to de code of the home
        $('#cover').load("cover_home.html", function(){
            $("body").css({ overflow: 'hidden' });
            $("body").addClass('ui-disabled');
            $("#cover_home").css("height", $(window).height() );
            $('#cover p.cover_wait_generating').text(gjson_lang["cover_wait_generating"]);
            $('#cover p.cover_wait_last').text(gjson_lang["cover_wait_last"]);
        });
    },

    emptyCover: function()
	{
        $('#cover').empty();
        $("body").css( "overflow", 'initial');
        $("body").removeClass('ui-disabled');
	},

	markTrackCompleted: function(result, $element)
	{
		var sectionToClass = {
			'physicalActivity' : 'track_physical_activity_completed',
			'nutrition' : 'track_nutrition_completed',
            'treatment': 'track_health_completed'
		}
		var track_icon_src;

		var data = $element.data("nire");
		
		$element.removeClass("track_active");
        if(result && result.data && result.data.status == "confirmed") {
		    $element.addClass(sectionToClass[data.section]);
		    track_icon_src = 'img/tracks/ic_'+ data.section +'_type_'+ pageHome.selectTrackImage(data.type) +'_sel.png';
        } else {
            $element.removeClass(sectionToClass[data.section]);
            track_icon_src = 'img/tracks/ic_'+ data.section +'_type_'+ pageHome.selectTrackImage(data.type) + pageHome.getCustomizedImageName() +'.png';
            if (result && result.error && result.error.message == "DATE_AFTER_TODAY") {
            	showToast(gjson_lang.error_home_updatetrack_date_after_today);
            }
        }
        if(data.section == "treatment"){
            track_icon_src = "img/tracks/ic_health_medicament_sel.png";
        }
        $element.find(".track_icon").attr("src", track_icon_src);

		vibrate();
	},
	
	initializeNavbarsOverflow: function()
    {
		// Seteamos las fechas de los otros navbar
		var actual_date = $("#home_track_days_actual .dateselector").dateselector("date");
		var actual_minDate = $("#home_track_days_actual .dateselector").dateselector("minDate");
		var actual_maxDate = $("#home_track_days_actual .dateselector").dateselector("maxDate");
    	var int_start = Math.ceil(pageHome.dateselectorNumItems/2);
    	
        for (var i=int_start, len=int_start+(int_start-1); i<=len; i++)
    	{
    		var date_ant = actual_date.clone().subtract(i, "day");
    		
    		var str_date_ant_formatted = getDateFormatted(date_ant.format("YYYYMMDD"));
    		
    		$("#home_track_days_ant .dateselector li:nth-child("+ (pageHome.dateselectorNumItems - i) +") a").html(str_date_ant_formatted);
    		
    		if ( date_ant.isBefore(actual_minDate) )
    			$("#home_track_days_ant .dateselector li:nth-child("+ (pageHome.dateselectorNumItems - i) +") a").addClass("ui-state-disabled");
    		else
    			$("#home_track_days_ant .dateselector li:nth-child("+ (pageHome.dateselectorNumItems - i) +") a").removeClass("ui-state-disabled");
    		
    		var date_next = actual_date.clone().add(i, "day");
    		
    		var str_date_next_formatted = getDateFormatted(date_next.format("YYYYMMDD"))
    		
    		$("#home_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").html(str_date_next_formatted);
    		
    		if ( date_next.isAfter(actual_maxDate) )
    			$("#home_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").addClass("ui-state-disabled");
    		else
    			$("#home_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").removeClass("ui-state-disabled");
    	}
    },
    
    resetNavbarsAndTracksPosition: function(time, content, successCallback)
	{
    	var int_time = (time == 0) ? 0 : time || pageHome.animationDuration;
		var int_lag = ($( window ).width()/pageHome.dateselectorNumItems) * (Math.floor(pageHome.dateselectorNumItems/2));
		if (!content || content == 1) {
    		$("#home_track_days_ant").animate( { "left": -(int_lag), "right": int_lag }, { duration: int_time, queue: false } );
    		$("#home_track_days_actual").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } );
    		$("#home_track_days_next").animate( { "left": int_lag, "right": -(int_lag) }, { duration: int_time, queue: false } );
		}
		if (!content || content == 2) {
			$("#home_track,  #home_track_progress, #home_message").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } )
			.promise()
			.done(successCallback);
		}
	},

	animateNavbars: function(direction, diff_days)
	{
		var int_num_days = Math.abs(diff_days);
		var int_lag = ($( window ).width()/pageHome.dateselectorNumItems);
		var int_lagged_items = Math.floor(pageHome.dateselectorNumItems/2);

		if (direction == "right") {
			var int_left_direction = 1;
			var int_right_direction = -1;
		}
		else if ( direction == "left") {
			var int_left_direction = -1;
			var int_right_direction = 1;
		}
		
		$("#home_track_days_actual").animate( 
			{ 
				"left": int_left_direction * int_lag * int_num_days, 
				"right": int_right_direction * int_lag * int_num_days
			}, 
			{ duration: pageHome.animationDuration, queue: false } 
		);
		$("#home_track_days_ant").animate( 
			{ 
				"left": -(int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": (int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageHome.animationDuration, queue: false } 
		);
		$("#home_track_days_next").animate( 
			{ 
				"left": (int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": -(int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageHome.animationDuration, queue: false } 
		);
	},
	
	prepareTracksForAnimation: function()
	{
		var int_left = parseInt($("#home_track").css("left"));
		if (Math.abs(int_left) != 0) {
			$("#home_track, #home_track_progress, #home_message").css( { "left": -(int_left), "right": -(int_left) } );
			return true;
		}
		return false;
	},
	
	animateTracks: function(direction, diff_days)
	{
		var int_window_width = null;
		var str_what_date = null;

		if (direction == "right") {
			int_window_width = $( window ).width();
			str_what_date = "previous";
		}
		else if ( direction == "left") {
			int_window_width = -($( window ).width());
			str_what_date = "next";
		}
		var obj_what_date = (diff_days) ? $("#home_track_days_actual .dateselector").dateselector("date").clone().add(diff_days, "day") : null;

		if (int_window_width) {
			$("#home_track, #home_track_progress, #home_message")
				.animate(
					{ "left": int_window_width, "right": -(int_window_width) },
					{ duration: pageHome.animationDuration, queue: false }
				)
				.promise()
				.done(function(){
					if (obj_what_date) {
						if ( !$("#home_track_days_actual .dateselector").dateselector("date", obj_what_date)) {
							pageHome.resetNavbarsAndTracksPosition();
						}
					} else {
						if ( !$("#home_track_days_actual .dateselector").dateselector(str_what_date)) {
							pageHome.resetNavbarsAndTracksPosition();
						}
					}
				})
				.fail(function(){
					pageHome.resetNavbarsAndTracksPosition();
				});
		}
	},

    generarDieta: function()
    {
    	pageHome.addCover();
        Nire.connection.generarDieta();
    },

    getCustomizedImageName: function()
    {
    	if (APP_DOMAIN == "vivebien") {
    		return "_c";
    	} else if (APP_DOMAIN == "nire") {
    		return "_sel";
    	}
    	return "";
    }

};

/* EVENTS */
$.event.special.tap.emitTapOnTaphold = false;

$( window ).off( ".home" )
	.on("resize.home", function()
	{
		if(pageHome)
			pageHome.adjustSizesOfTracks();
	});

$( document ).off( ".home" )
	
	.on("pagecreate.home", "#page_home", function()
	{
		pageHome.$page = $(this);
										
		pageHome.resetNavbarsAndTracksPosition(0);
		
		var date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : moment().hour(0).minute(0).second(0);
		$( "#home_img_background" ).attr("src", "img/backgrounds/" + date.isoWeekday() + ".jpg").show();
			
		var str_start_direction = null;
		var int_left_position = 0;
		var int_right_position = 0;
		
		$( this ).swipe({
			swipeLeft: function() {
				pageHome.animateNavbars("left", 1);
				pageHome.animateTracks("left", 1);
			},
			swipeRight: function() {
				pageHome.animateNavbars("right", -1);
				pageHome.animateTracks("right", -1);
			},
			swipeStatus: function( event, phase, direction, distance ) {
				
//				console.log("str_start_direction: "+str_start_direction);
//				console.log("direction: "+direction);
//				console.log("phase: "+phase);
//				console.log("distance: "+distance);
				
				if ( phase=="move" ) {
					
					setTimeout(function(){
						$(".track_body").removeClass("track_active");
					}, 200);
					
					if (!str_start_direction) {
						str_start_direction = direction;
						if (str_start_direction == "left" || str_start_direction == "right")
							pageHome.$page.swipe("option", "allowPageScroll", "none");
					}
					
					var int_lag = ($( window ).width()/pageHome.dateselectorNumItems) * (Math.floor(pageHome.dateselectorNumItems/2));
					
					if ( direction == "left"&& (str_start_direction == "left" || str_start_direction == "right") ) {
						$("#home_track, #home_message").css( { "left": -(distance), "right": distance} );
						$("#home_track_days_actual, #home_track_progress").css( { "left": -(distance/pageHome.dateselectorNumItems), "right": distance/pageHome.dateselectorNumItems} );
						$("#home_track_days_ant").css( { "left": -(int_lag + distance/pageHome.dateselectorNumItems), "right": int_lag + distance/pageHome.dateselectorNumItems } );
						$("#home_track_days_next").css( { "left": int_lag - distance/pageHome.dateselectorNumItems, "right": -(int_lag - distance/pageHome.dateselectorNumItems) } );
					} else if ( direction == "right" && (str_start_direction == "left" || str_start_direction == "right") ) {
						$("#home_track, #home_message").css( { "left": distance, "right": -distance } );
						$("#home_track_days_actual, #home_track_progress").css( { "left": distance/pageHome.dateselectorNumItems, "right": -distance/pageHome.dateselectorNumItems } );
						$("#home_track_days_ant").css( { "left": -(int_lag - distance/pageHome.dateselectorNumItems), "right": int_lag - distance/pageHome.dateselectorNumItems } );
						$("#home_track_days_next").css( { "left": int_lag + distance/pageHome.dateselectorNumItems, "right": -(int_lag + distance/pageHome.dateselectorNumItems) } );
					} else {
						return false;
					}
				} else if ( phase == "cancel" ) {
					
					str_start_direction = null;
					pageHome.$page.swipe("option", "allowPageScroll", "vertical");
					pageHome.resetNavbarsAndTracksPosition();
					
				} else if ( phase == "end" ) {
					
					pageHome.$page.swipe("option", "allowPageScroll", "vertical");
					if ( direction != "left" && direction != "right" ) {
						pageHome.resetNavbarsAndTracksPosition();
					}
					str_start_direction = null;
				}
			},
			allowPageScroll: "vertical",
			cancelThreshold: $( window ).width()/8,
			threshold: $( window ).width()/4
		});
	})
	
	.on("pagecontainershow.home", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_home")
		{
			pageHome.createHeader();
		}
	})
	
	.on( "pagecontainerchange.home", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_home") {
			menuHome.getData().done(function(){
	            $("#home_track_days_actual .dateselector").dateselector({
	            	date: (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : null,
	            	from_date: null,
	            	minDate: Nire.rangeData.minDate.clone().hour(0).minute(0).second(0).millisecond(0),
	                maxDate: Nire.rangeData.maxDate.clone().hour(0).minute(0).second(0).millisecond(0),
	    	    	dateFormatter: function(date) { return getDateFormatted(date.format("YYYYMMDD")); },
	    	        change: function(event, newdate) {
	    	        	Nire.analytics.event( "datechange", "Home date switch" );
	    	        	Nire.localStorage.setItem(APP_DATE_STATE, newdate.format("YYYYMMDD"));
	    	        	pageHome.resetNavbarsAndTracksPosition(0,1);
	                	pageHome.initializeNavbarsOverflow();
	    	        	pageHome.getData(newdate);
	    	        },
	    	        fn_date_clicked: function(obj_new_date) {
	    	    		var obj_from_date = $("#home_track_days_actual .dateselector").dateselector( "date" );
	    	    		var int_diff_days = obj_new_date.diff(obj_from_date, 'days');
	    	    		if ( obj_new_date.isAfter(obj_from_date) ){
	    	        		pageHome.animateNavbars("left", int_diff_days);
	    	    			pageHome.animateTracks("left", int_diff_days);
	    	        	} else if ( obj_new_date.isBefore(obj_from_date) ){
	    	        		pageHome.animateNavbars("right", int_diff_days);
	    	    			pageHome.animateTracks("right", int_diff_days);
	    	        	}
	    	    		return false;
	    	    	}
	    	    });
	        });
			
	        pageHome.adjustSizesOfTracks();
		}
		else if ( ui.prevPage.attr("id") == "page_home" && ui.toPage.attr("id") != "page_home" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {

			$("#page_home").trigger("pageremove");
			$("#page_home").remove();
		} 
	})

	.on("pageremove.home", "#page_home", function()
	{
		pageHome.cancelGetData();
		$( window ).off( ".home" );
		$( document ).off( ".home" );
        $( 'link[href="css/pageHome.css"]' ).remove();
		$( 'link[href="css/pageCoverHome.css"]' ).remove();
		pageHome = null;
	})

	.on("taphold.home", ".track_body", function(event)
	{
		event.preventDefault();

		pageHome.updateTrack($(this));

		return false;
	})

	.on("tap.home", ".enter_detail", function(event)
	{
		event.preventDefault();
		pageHome.viewDetail($(this));
		return false;
	})
	
	.on("vmouseup.home", "#page_home", function()
    {
		$(".track_body.track_active").removeClass("track_active");
    })
		
	.on("vmousedown.home", ".track_body", function()
    {
    	$(this).addClass("track_active");
    })
	
	.on("click.home", "#home_img_header", function(event) {
		showAppInfo();
		return true;
	})

	.on("click.home", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pageHome.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});
