/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageIndicatorDetail.css"/>');

/* VARIABLES */



var pageIndicatorDetail = {

	$page : null,
	$json_data: null,
	$show_description : false,
	$actual_date : new Date(),

	
	getData : function($page)
    {
   	
    	showLoading();

        Nire.connection.indicator(getURLParameter("content"))
			.done(function(json_response) {
				if (json_response.error.code == 0) {
                    if(!json_response.data.body.readonly)
                       $("#page_indicator_detail > .ui-footer").show();

                    pageIndicatorDetail.addContent(json_response.data);
                }
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
			})
			.always(function(){
				hideLoading();
			});
    },

    createHeader : function( )
    {
    	var template = Handlebars.compile($("#template-header_indicator_detail").html());
    	
    	var datos_item = {
    			url_params: "?value="+ getURLParameter("content")
    	};
        
    	pageIndicatorDetail.$page.find( "#app_header" ).remove();
    
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang[getURLParameter("content")] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },

    addContent : function(json)
    {
    	pageIndicatorDetail.createLastMeasures(json.body);

        // si no hay mediciones no hacemos nada.
        if(json.body.meditions.length == 0) return;
    	
    	var last_date = parseDateFromYYYYMMDD(json.body.meditions[json.body.meditions.length-1].date);
     	var start = moment(pageIndicatorDetail.$actual_date.getFullYear()+"-"+(pageIndicatorDetail.$actual_date.getMonth() +1)+"-"+pageIndicatorDetail.$actual_date.getDate());
     	var end = moment(last_date.getFullYear()+"-"+(last_date.getMonth() +1)+"-"+last_date.getDate());
     	
     	pageIndicatorDetail.$page.find(".graph_filter_link").removeClass("ui-btn-active");
     	
     	if (start.diff(end, "days") <= 7) 
     	{
     		pageIndicatorDetail.$page.find("#1W").addClass("ui-btn-active");
     		pageIndicatorDetail.draw(json.body, "1W");
     	}
     	else if (start.diff(end, "days") <= 31) 
     	{
     		pageIndicatorDetail.$page.find("#1M").addClass("ui-btn-active");
     		pageIndicatorDetail.draw(json.body, "1M");
     	}
     	else if (start.diff(end, "days") <= 186) 
     	{
     		pageIndicatorDetail.$page.find("#6M").addClass("ui-btn-active");
     		pageIndicatorDetail.draw(json.body, "6M");
     	}
     	else if (start.diff(end, "days") <= 365) 
     	{
     		pageIndicatorDetail.$page.find("#1A").addClass("ui-btn-active");
     		pageIndicatorDetail.draw(json.body, "1A");
     	}
    	
    	
    	
    	pageIndicatorDetail.$json_data = json.body;
	},


	
    createLastMeasures : function(ajson_body)
    {
        var _this = this;
        var template_measures_last = Handlebars.compile($('#template-indicator_detail_measures_last').html());
        var template_measures = Handlebars.compile($('#template-indicator_detail_measures').html());

        var a_measure_last = [];
        var a_measures = [];
                 
        //ULTIMA MEDICI?N. MEDICI?N + BARRA + TEXTO
        if ( ajson_body.last_measure_evolution == "down" )
            var shape = '<svg class="svg-triangle_down svg-triangle_'+ajson_body.last_measure_trend+'"><polygon points="0,0 16,0 8,16"/></svg>';
        else if ( ajson_body.last_measure_evolution == "up" )
            var shape = '<svg class="svg-triangle_up svg-triangle_'+ajson_body.last_measure_trend+'"><polygon points="0,16 8,0 16,16"/></svg>';
        else if ( ajson_body.last_measure_evolution == "equal" )
            var shape = '<svg class = "svg-square">'+
            			'<line x1="0" y1="4" x2="20" y2="4" stroke-width="4"/>'+
            			'<line x1="0" y1="12" x2="20" y2="12" stroke-width="4" />'+
            			'</svg>';

        a_measure_last.push({
            quantity: precise_round(ajson_body.valor1, 2),
            unit: " "+ ajson_body.valor_unit,
            shape: shape,
            description: ajson_body.description,
            range1: ajson_body.ancho1,
            range2: ajson_body.ancho2,
            range3: ajson_body.ancho3,
            range4: ajson_body.ancho4,
         });

        var datos_wrapper_last =  {
            last_measures: a_measure_last
        };    
        
        if ( !ajson_body.description )
        {
        	pageIndicatorDetail.$page.find(".expand_simbol").hide();
        	pageIndicatorDetail.$page.find('#indicator_detail_measures_last_wrapper').addClass("no-after");
        	pageIndicatorDetail.$show_description = false;
        }else
        {
        	pageIndicatorDetail.$show_description = true;
        	pageIndicatorDetail.$page.find('#indicator_detail_measures_last_wrapper').css("cursor","pointer");
        }
          
        pageIndicatorDetail.$page.find("#last_measure_title").text(gjson_lang["indicator_detail_last_measures"].toUpperCase());
        
        //HISTORICO DE MEDICIONES
        $.each(ajson_body.meditions, function(i, item)
        {
            a_measures.push({
                quantity: precise_round(item.quantity, 2),
                unit: item.unit,
                shape: '<svg class="svg-circle svg-circle_'+ item.medition_trend +'"><circle cx="4" cy="4" r="4"/></svg>',
                active: item.active,
                date: getDateFormatted(item.date),
                numericDate: item.date,
                from: ( item.from ) ? " "+ gjson_lang["from"] +" "+ item.from : null,
            });
        });

        var medition = $(template_measures(a_measures)).data("info", this);
        a_measures.sort(pageIndicatorDetail.sortDates);

        
        console.log(a_measures);

        var datos_wrapper =  {
            wrapper_title: gjson_lang["indicator_detail_historical_measures"].toUpperCase(),
            measures: a_measures
        };   

        pageIndicatorDetail.$page.find("#indicator_detail_measures_last_wrapper").html(template_measures_last(datos_wrapper_last)).trigger( "updatelayout" );
        pageIndicatorDetail.$page.find("#indicator_detail_measures_wrapper").html(template_measures(datos_wrapper)).trigger( "updatelayout" );
        
        var ajuste_rango_left = "-."+(pageIndicatorDetail.$page.find(".range_left").text().length)*2+"em";
        var ajuste_rango_right = "-."+(pageIndicatorDetail.$page.find(".range_right").text().length)*2+"em";

        pageIndicatorDetail.$page.find(".range_left").css('margin-left', ajuste_rango_left);
        pageIndicatorDetail.$page.find(".range_right").css('margin-left', ajuste_rango_right);
        
        // CREACION BARRA DE PROGRESO
        if(ajson_body.ancho4 == 0 || ajson_body.ancho4 == "")
        	var int_total_value = ajson_body.ancho3 + (ajson_body.ancho3 - ajson_body.ancho2);
        else
        	var int_total_value = ajson_body.ancho4 + (ajson_body.ancho4 - ajson_body.ancho3);
        
        var barra1 = ajson_body.ancho1 * 100 / int_total_value;
        var barra2 = (ajson_body.ancho2 * 100 / int_total_value ) -barra1;
        var barra3 = (ajson_body.ancho3 * 100 / int_total_value) - barra2 - barra1;
        
        if(ajson_body.ancho4 == 0 || ajson_body.ancho4 == "")
        	var barra4 = 0;
        else
        	var barra4 = (ajson_body.ancho4 * 100 / int_total_value) - barra3 - barra2 - barra1;
        
        var barra5 = 100 - barra4 - barra3 - barra2 - barra1;
        
        if (ajson_body.marker * 100 / int_total_value > 100)
        	var markerPos = 100;
        else
        	var markerPos = ajson_body.marker * 100 / int_total_value;
        
        pageIndicatorDetail.$page.find(".div_indicator-inner1").css('width', barra1 +'%');
        pageIndicatorDetail.$page.find(".div_indicator-inner2").css('width', barra2 +'%');
        pageIndicatorDetail.$page.find(".div_indicator-inner3").css('width', barra3 +'%');
        pageIndicatorDetail.$page.find(".div_indicator-inner4").css('width', barra4 +'%');
        pageIndicatorDetail.$page.find(".div_indicator-inner5").css('width', barra5 +'%');
        pageIndicatorDetail.$page.find(".div_marker ").css('left', markerPos + '%');
        
        if (ajson_body.ancho1 == 0 || ajson_body.ancho1 == "")
        {
        	pageIndicatorDetail.$page.find(".div_indicator-inner1").hide();
        }
        
        if (ajson_body.ancho2 == 0 || ajson_body.ancho2 == "")
        {
        	pageIndicatorDetail.$page.find(".div_indicator-inner2").hide();
        }
        
        if (ajson_body.ancho4 == 0 || ajson_body.ancho4 == "")
        {
        	pageIndicatorDetail.$page.find(".div_indicator-inner4").hide();
        }
        
        if (ajson_body.ancho1 == ajson_body.ancho2)
        {
        	pageIndicatorDetail.$page.find(".range2").hide();
        }
        
        if (ajson_body.ancho3 == ajson_body.ancho4)
        {
        	pageIndicatorDetail.$page.find(".range3").hide();
        }
       
        pageIndicatorDetail.$page.find(".range1").css("margin-left", -0.2*pageIndicatorDetail.$page.find(".range1").text().length+"em");
        pageIndicatorDetail.$page.find(".range2").css("margin-left", -0.2*pageIndicatorDetail.$page.find(".range2").text().length+"em");
        pageIndicatorDetail.$page.find(".range3").css("margin-left", -0.2*pageIndicatorDetail.$page.find(".range3").text().length+"em");
        pageIndicatorDetail.$page.find(".range4").css("margin-left", -0.2*pageIndicatorDetail.$page.find(".range4").text().length+"em");
        
        //$(window).trigger('resize');
        //pageIndicatorDetail.adjustSizes();
    },
    
    sortDates : function(a, b) 
    {
      var a = a.numericDate;
      var b = b.numericDate;
      return ((a < b) ? 1 : ((a > b) ? -1 : 0));
    },

    draw: function(ajson_body, type)  
    {    	
    	var svg = null,
        yAxisGroup = null,
        xAxisGroup = null,
        dataCirclesGroup = null,
        dataLinesGroup = null;
    	var a_measures_grapic = [];
    	var w = pageIndicatorDetail.$page.find("#chart").outerWidth();

    	var formatTime = d3.time.format("%d %b %Y");// Format tooltip date / time
    	    	
    	if(ajson_body.max != undefined || ajson_body.max != null)
    		var value_max = ajson_body.max;
    	else var value_max = 0;
    	
    	var value_min = 999999;
    	var total_measures = 0;
    	
    	var maxDataPointsForDots = 25;
    	
    	if ( (w/4)*2>650 ) 
    		var h = 650; 
    	else 
    		var h= (w/4)*2;
    
    	if(type == "1W")
    	{
    		var format_date = "%a %d";
    		var range_date= pageIndicatorDetail.calculate_dates(-7,pageIndicatorDetail.$actual_date);
    		var x_values_ticks = "d3.time.week,5";
    	}
    	else if(type == "1M")
    	{
    		var format_date = "%b %d";
    		var range_date = pageIndicatorDetail.calculate_dates(-31,pageIndicatorDetail.$actual_date);
    		var x_values_ticks = "d3.time.month,4";
    	}
    	else if(type == "6M")
    	{
    		var format_date = "%b  %d";
    		var range_date = pageIndicatorDetail.calculate_dates(-186,pageIndicatorDetail.$actual_date);
    		var x_values_ticks = "d3.time.month,4";
    	}
    	else if(type == "1A")
    	{
    		var format_date = "%b %Y";
    		var range_date = pageIndicatorDetail.calculate_dates(-365,pageIndicatorDetail.$actual_date);
    		var x_values_ticks = "d3.time.year,4";
    	}

    	 $.each(ajson_body.meditions, function(i, item)
    	{
    		 if(ajson_body.max == undefined || ajson_body.max == null)
    		 	if (item.quantity > value_max)
    		 		value_max = item.quantity*1.10;
    		       	
    		   	if (item.quantity < value_min)
    		   		value_min = item.quantity/1.10;
    		        	
    	           a_measures_grapic.push({
    		           quantity: item.quantity,
    		           date: item.date,
    		           unit: item.unit,
    	           });
    		        	
    	});
    	
    	var margin = {top: 20, right: 20, bottom: 30, left: 50};
		var width = w - margin.left - margin.right;
		var height = h - margin.top - margin.bottom;	
    	var data = pageIndicatorDetail.generateData(a_measures_grapic, range_date);
    	
    	console.log(data.length);
    	if(data.length > 6)
    		var max_ticks = 4;
    	else var max_ticks = data.length-1;
    	
    	var pointRadius = 4;
    	var x_scale = d3.time.scale().range([0, width/max_ticks]);
        var y_scale = d3.scale.linear().range([height, 0]);
        var xAxis = d3.svg.axis().scale(x_scale).orient("bottom").tickFormat(d3.time.format(format_date));
    	
        
        var yAxis = d3.svg.axis().scale(y_scale).tickSize(-width).orient("left");

        $("#indicator_detail_graph_svg").empty();
        svg = d3.select('#chart').select('svg')
        .attr('viewBox', "0 0 "+w+" "+h)
        .attr('width', w)
		.attr('height', h)
        .append('g')
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

        if(data.length != 0)
        {
             x_scale.range([width/data.length/4, width-width/data.length/4])
             .domain([data[0].date, data[data.length - 1].date]);
        	 
        	 y_scale.range([height, 0])
             .domain([value_min, value_max]);
        	 
        }
        
        xAxis.tickValues(x_scale.domain());

        
	    var x_grid = d3.svg.axis()
	    .scale(x_scale)
	    .orient("bottom")
	    .tickSize(0)
	    .tickFormat("") ;

	    var y_grid = d3.svg.axis()
	    .scale(y_scale)
	    .orient("left") 
	    .tickSize(-width)
	    .tickFormat("") ;
    
		svg.append("g")
			.attr("class", "xTick")
			.attr("transform", "translate("+margin.left+"," + height + ")")
			.call(x_grid);
		
		svg.append("g")
	       	.attr("class", "y grid")
	       	.call(y_grid) ;
		
		svg.append("g")
	       .attr("class", "x axis")
	       .attr("transform", "translate(0," + height + ")") 
	       .call(xAxis);

	    svg.append("g")
	        .attr("class", "y axis")
	        .call(yAxis)
	        .append("text")
	        .attr("transform", "rotate(-90)")
	        .attr("y", 6)
	        .attr("dy", "0.71em")
	        .style("text-anchor", "end")
	        .style("fill", "#FFF");
    

		// Draw the lines
        dataLinesGroup = svg.append('svg:g'); 	

        $(".graphic_line_tooltip").remove();
        
        d3.select(".graphic_line_tooltip").remove();
        
		var div = d3.select("body")
			.append("div")  // declare the tooltip div 
			.attr("class", "graphic_line_tooltip")              // apply the 'tooltip' class
			.style("opacity", 1);                  // set the opacity to nil
		
        var dataLines = dataLinesGroup.selectAll('.data-line').data([data]);
        
        var line = d3.svg.line()
	        .x(function(d,i) 
	        { 
	        	return x_scale(d.date); 
	        })
	        .y(function(d) { 
	        	return y_scale(d.value); 
	        })

		dataLines.enter().append('path').attr('class', 'data-line').style('opacity', 1);
		
		dataLines.attr("d", line).style('opacity', 1);
		
		dataCirclesGroup = svg.append('svg:g');
        	
		var circles = dataCirclesGroup.selectAll('.data-point').data(data);

		circles.enter().append('svg:circle')
		.attr('class', 'data-point')
		//.attr('r', function() { return (data.length <= maxDataPointsForDots) ? pointRadius : 0 })
		.attr('r', '6')
		.attr('cx', function(d) { return x_scale(d.date) })
		.attr('cy', function(d) { return y_scale(d.value) })
        .on("click", function(d) {		
			div.transition()
				.duration(200)	
				.style("opacity", .9);	
			div.html(formatTime(d.date)+"</br>"+d.value+" "+d.unit)
				.style("left", (d3.event.pageX-35) + "px")			 
				.style("top", (d3.event.pageY) + "px");
			})
		
		.on('mouseout', function() {
			div.style("opacity", 0);
          }); 

    },
    
    generateData: function(measures, range_date)
    {
    	var data = [];

        $.each(measures, function(i, item)
        {
        	var date = parseDateFromYYYYMMDD(item.date);

        	if(date >= range_date)
        		data.push({'value' : item.quantity, 'date' : date, 'unit' : item.unit});
        });

    	return data;
    },
    
	SortMeasures : function(a, b) 
	{
	  var aName = a.date;
	  var bName = b.date; 
	  return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
	},
	
	calculate_dates : function(d, fecha)
	{
	 var Fecha = new Date();
	 var sFecha = Fecha.getDate() + "/" + (Fecha.getMonth() +1) + "/" + Fecha.getFullYear();
	 var sep = sFecha.indexOf('/') != -1 ? '/' : '-'; 
	 var aFecha = sFecha.split(sep);
	 var fecha = aFecha[2]+'/'+aFecha[1]+'/'+aFecha[0];
	 fecha= new Date(fecha);
	 fecha.setDate(fecha.getDate()+parseInt(d));
	 var anno=fecha.getFullYear();
	 var mes= fecha.getMonth()+1;
	 var dia= fecha.getDate();
	 mes = (mes < 10) ? ("0" + mes) : mes;
	 dia = (dia < 10) ? ("0" + dia) : dia;
	 var fechaFinal = anno+sep+mes+sep+dia;
	 return (new Date(fechaFinal));
	 }
};

/* EVENTS */

$( document ).off( ".health_detail" )

    .on("pagecreate.health_detail", "#page_indicator_detail", function()
    {
		pageIndicatorDetail.$page = $(this);    
    })

	.on("pagecontainershow.health_detail", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_indicator_detail") {
			pageIndicatorDetail.createHeader();
		}
	})
	
	.on( "pagecontainerchange.health_detail", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_indicator_detail")
        {
    		pageIndicatorDetail.getData(pageIndicatorDetail.$page);    		
    	}
        else if ( ui.prevPage.attr("id") == "page_indicator_detail" && ui.toPage.attr("id") != "page_indicator_detail" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" )
        {
    		$("#page_indicator_detail").trigger( "pageremove" );
    		$("#page_indicator_detail").remove();
		}
	})

	.on("pageremove.health_detail", "#page_indicator_detail", function()
	{
    	$("body").css("overflow", "auto");
    	$( window ).off( ".health_detail" );
    	$( document ).off( ".health_detail" );
		$( 'link[href="css/pageIndicatorDetail.css"]' ).remove();
		$( 'link[href="css/pageCoverHome.css"]' ).remove();
		
		pageIndicatorDetail = null;
	})
    .on("click.health_detail", "#page_indicator_detail .expand_simbol, #page_indicator_detail #indicator_detail_measures_last_wrapper", function(event)
    {
        event.preventDefault();      
        if(pageIndicatorDetail.$show_description)
        {
	        pageIndicatorDetail.$page.find(".indicator_detail_measures_description").show();
	
	        var int_ui_grid_solo_count = pageIndicatorDetail.$page.find("#indicator_detail_measures_last_wrapper .ui-grid-solo").length;
	        if ( !$(this).jqmData("action-hide"))
	        {
	        	pageIndicatorDetail.$page.find(".indicator_detail_measures_description").show().trigger("updatelayout");
	            $(this).jqmData("action-hide", true);
	            pageIndicatorDetail.$page.find(".expand_simbol").html("-");
	        }
	        else
	        {
	        	pageIndicatorDetail.$page.find(".indicator_detail_measures_description").hide().trigger("updatelayout");
	            $(this).jqmData("action-hide", null);
	            pageIndicatorDetail.$page.find(".expand_simbol").html("+");
	        }
        }
        
        return false;
    })
    
   
    .on("click.health_detail", "#page_indicator_detail  .graph_filter_link", function(event)
    {
    	event.preventDefault();
    	pageIndicatorDetail.$page.find(".graph_filter_link").removeClass("ui-btn-active");
    	$(this).addClass("ui-btn-active");
    	pageIndicatorDetail.draw(pageIndicatorDetail.$json_data, $(this).attr("data-type"));
    	return false;
	})    
    
    .on("click.health_detail", "#page_indicator_detail .plus-ex", function(event)
    {
        event.preventDefault();
        $( "body" ).pagecontainer( "change", "newTrackHealth.html?value="+getURLParameter("content") );
        return false;
    })

	
	.on("click.health_detail", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pageIndicatorDetail.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});
