/*CSS*/

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageLogin.css"/>');

/* VARIABLES */
var pageLogin = {
		
    createHeader: function()
    {
        $( "#app_header" ).empty();
        $( "#app_header" ).toolbar( "destroy" );
    },

    enviar_formulario: function(event) {
		showLoading();
		
		var username = $("#page_login_username").val();
		var password = $("#page_login_password").val();
		var documentType = $("#page_login_type").val();
		
		Nire.connection.login(username, password, documentType)
            .done( function(data) {
            	Nire.analytics.event("Login", "Utilizando usuario y contraseña");
            	LoginHelper.processLoginSuccess(documentType, username, data); 
            })
            .fail( LoginHelper.processLoginError )
            .always( hideLoading );

		return false;
	},

	enviar_email: function(event) {
		showLoading();
		var email = $("#page_login_email").val();

		Nire.connection.sendEmail(email).done(function(data) {
			showToast(gjson_lang.login_email_login_sended)
		}).always(function() { hideLoading(); })

		return false;
	},

	tryPreviousLogin: function() {
        Nire.connection.tryPreviousLogin()
            .always( hideLoading )
            .done( function(data) {
            	Nire.analytics.event( "login", "Login desde AutoLogin" );
                var savedDocumentType = localStorage.getItem(CREDENTIALS_DOCUMENT_TYPE);
                var savedUsername = localStorage.getItem(CREDENTIALS_USERNAME);
                LoginHelper.processLoginSuccess(savedDocumentType, savedUsername, data);
            } );
    }
};

/* EVENTS */
$(window).off( ".login" )
	.on("resize.login", function()
	{
		$("#page_login").trigger("updatelayout");
	});

$( document ).off( ".login" )

	.on( "pagecreate.login", "#page_login", function()
	{
		$( "#app_header" ).toolbar();
		pageLogin.createHeader();
		
		$("#page_login_username").attr( "placeholder", gjson_lang.login_username);
		$("#page_login_password").attr( "placeholder", gjson_lang.login_password);
		$("#page_login_email").attr( "placeholder", gjson_lang.login_email);

		if(LOGIN_TYPE.length > 0){
			LOGIN_TYPE.forEach(function(item){
				$("#page_login_type").append("<option value='" + item.value + "'>" + item.text + "</option>")
			})
			$("#page_login_type").selectmenu('refresh', true);
		} else{
			$("#page_login_type").parent().hide()
		}

		if(LOGIN_METHOD == "PASSWORD") {
			$("#email_login").hide();
			$("#email_login_switch").hide();

		} else if (LOGIN_METHOD == "EMAIL") {
			$("#password_login").hide();
			$("#email_login").show();
			$("#password_login_switch").hide();
		} 
		
		var username = localStorage.getItem(CREDENTIALS_USERNAME);
		var documentType = localStorage.getItem(CREDENTIALS_DOCUMENT_TYPE)
		if (username) {
			$("#page_login_username").val(username);
			$("#page_login_type").val(documentType);
			$("#page_login_type").selectmenu('refresh');
		}
		
		pageLogin.tryPreviousLogin();		
		$("#password_login form").submit(pageLogin.enviar_formulario);
		$("#email_login form").submit(pageLogin.enviar_email);
	})
	
	.on("pageshow.login", "#page_login", function()
	{
		if (navigator && navigator.splashscreen) {
			setTimeout(function(){
				navigator.splashscreen.hide();
			}, 2000);
		}

		if(!SIGNUP_URL)
			$(".new_user").hide();
		else {
			$(".new_user a").attr("href", SIGNUP_URL);
		}

		if(!RECOVER_PASS_URL)
			$("#password_forgotten").hide();
		else {
			$("#password_forgotten").attr("href", RECOVER_PASS_URL);
		}
		
	})
	
	.on("pageremove.login", "#page_login", function()
	{
		$( document ).off( ".login" );
		$( 'link[href="css/pageLogin.css"]' ).remove();		
		pageLogin = null;
	})

	.on("click.login", "#bt_footer_1", function(event)
	{
		$("#password_login form").submit();
	})

	.on("click.login", "#send_email", function(event)
	{
		$("#email_login form").submit();
	})

	.on("click.login", "#page_login", function(event) {
		showAppInfo();
		return true;
	})

	.on("click.login", "#show_email", function(event) {
		event.preventDefault();
		$("#password_login").hide();
		$("#email_login").show();
		return false;
	})

	.on("click.login", "#show_password", function(event) {
		event.preventDefault();
		$("#email_login").hide();
		$("#password_login").show();
		return false;
	});
