/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageMedWhatHelp.css"/>');

/* VARIABLES */
var pageMedWhatHelp = {

    getData : function()
    {
        showLoading();
        $(".searchBtn").text("Buscar");
    },

    createHeader : function()
    {
        var template = Handlebars.compile($(".template-header").html());

        $( "#app_header" ).html( template({ title: gjson_lang["help_title"] }) );
        $( "#app_header" ).toolbar( "refresh" );
        $( "#app_header" ).show();
        $( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();
    },

    createPage : function(json)
    {
        $(".div_medwhat_faq_list").empty().append(json.answer).trigger( "updatelayout" );
    },

    getInfo : function(q)
    {
        var  port = 8080;
        var serv = "http://serverb.medwhat.com:";

        $.ajax({
            type: "GET",
            url: serv + port +"/engine4_release/search_engine.jsp?q=" + q + "&passcode=mwt!",
            cache: false,
            crossDomain: true,
            success: function(json_response){
                pageMedWhatHelp.createPage(json_response);
            }
        });
    }

};

/* EVENTS */

$( document ).off( ".medwhat_help" )

    .on("pagecreate.medwhat_help", "#page_medwhat_help", function()
    {
		$( "#app_header" ).toolbar();
    })

	.on("pageshow.medwhat_help", ".page_medwhat_help", function()
    {
		pageMedWhatHelp.createHeader();
        pageMedWhatHelp.getData();
    })

	.on("pageremove.medwhat_help", ".page_medwhat_help", function()
	{
		$( document ).off( ".medwhat_help" );
		$( 'link[href="css/pageMedWhatHelp.css"]' ).remove();
		pageMedWhatHelp = null;
	})

    .on("keypress.medwhat_help", function(event)
    {
        var q = $('.filterBasic-input').val();

        if(event.which == 13)
            pageMedWhatHelp.getInfo(q);
    })

	.on("click.medwhat_help", ".searchBtn", function()
	{
        var q = $('.filterBasic-input').val();
        pageMedWhatHelp.getInfo(q);
	});