/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNewTrackHealth.css"/>');

/* VARIABLES */
var pageNewTrackHealth = {
	
	$page: null,
	animationDuration: 500,
	dateselectorNumItems: 7,

	// Item actualmente seleccionado
	selected_item: null,
	selected_value: null,
	selected_time: null,

    getSelectedTime: function() { return $("#newTrack_time").val(); },
    getSelectedItem: function() { return this.getSelectedItem; },
    getSelectedMedicineValue: function() { return $("#newTrack_medicine_value").val(); },

	/**
	 * Confirmar la selección y enviarla al servidor
	 * Cuidado! Utiliza this, no llamar como callback de un evento
	 */
	confirm: function()
	{
		// TODO: Verificar que los datos tengan sentidos y esten completos
		var current_date = $("#new_track_health_days_actual .dateselector").dateselector("date").format("YYYYMMDD");
		var promise;

		if (!this.isMedicineTabSelected()) {
            var notificationId = getURLParameter("notificationId")
			this.selected_value = $("#newTrack_measure_value").val();

			if(this.selected_item.id == "da_peso") {
				var int_user_weight = parseInt(this.selected_value);
				if(int_user_weight < VALUES_LIMITS["weight"].min || int_user_weight > VALUES_LIMITS["weight"].max){
		            showToast(gjson_lang["registry_biography_invalidweight_range"]);
		            return;
		        }
			}

            promise = Nire.connection.healthNew(this.selected_item.id, current_date, this.selected_value, this.selected_time, notificationId);
        }
		else
		{
			this.selected_value = this.getSelectedMedicineValue();
			this.selected_time = this.getSelectedTime();
            promise = Nire.connection.medicineNew(this.selected_item.id, this.selected_value, current_date, this.selected_time);
		}


        // No importa cual es el tab seleccionado, el proceso a realizar luego de registrar la llamada
        // en el servidor es siempre el mismo
        promise
            .done(function() {
            	$("#page_timeline").trigger("pageremove");
            	$("#page_timeline").remove();
            	if ( $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-2].pageUrl.match("pillbox.html") 
            			|| ($.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-2].pageUrl.match("newTrackHealth.html") 
                				&& $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-3].pageUrl.match("pillbox.html")) 
                		|| ($.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-3].pageUrl.match("newTrackHealth.html") 
                				&& $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-4].pageUrl.match("pillbox.html")) )
            		$("body").pagecontainer( "change", "pillbox.html" );
            		else
            			$("body").pagecontainer( "change", "timeline.html" );
            })
            .fail(function() { showAlert(gjson_lang.newTrack_health_error, null, gjson_lang.error, gjson_lang.accept); })
            .always(function() { window.pageStateHealth = null });

	},

	/**
	 * Handler del click del usuario cuando hace tap sobre un indicador
	 */
	select: function(event)
	{
		event.preventDefault();
		
		var ACTIVE_CLASS = "indicator_body_active";

		// Quitamos la clase indicator_body_active a todos indicadores y luego se lo agregamos
		// al que acabamos de clickear
		str_src = $('.'+ ACTIVE_CLASS + ' img.image30').attr("src");
    	if (str_src)
    		$('.'+ ACTIVE_CLASS + ' img.image30').attr("src", str_src.replace("_sel.", "."));
		$(".indicator_body_active").removeClass(ACTIVE_CLASS);
		$(this).addClass(ACTIVE_CLASS).find("p").addClass(ACTIVE_CLASS);
		str_src = $(this).find("img.image30").attr("src");
        if (str_src)
        	$(this).find("img.image30").attr("src", str_src.replace(".png", "_sel.png"));

		// Guardamos en un atributo la información del item actualmente seleccionado
		pageNewTrackHealth.selected_item = $(this).parents(".indicator").data("info");

		$(".health_measure").text($(this).parents(".indicator").data("info").unit);
    	
		if ($("#tab_nhealth ul li").find(".ui-btn-active").attr("id") == "a_page_new_track_health_tab_1")
		{
			$(".div_datos_medicine").hide();
			$(".div_datos_measure").show();
			$("#newTrack_measure_value").focus();
			$('#newTrack_measure_value').trigger('click');
		}
		else
		{
			$(".div_datos_measure").hide();
			$(".div_datos_medicine").show();
			$("#newTrack_medicine_value").focus();
			$('#newTrack_medicine_value').trigger('click');
		}
		return false;
	},

	/**
	 * El usuario cambio el tiempo que ha realizado la actividad.
	 * Este método actualiza en base a la actividad seleccionada y el nuevo tiempo el gasto calorico
	 */

    getData : function(day)
    {
    	var _this = this;
    	showLoading();

		Nire.connection.newHealth(day)
			.done(function(json_response) {
				 
				  if (json_response.error.code == 0)
					  pageNewTrackHealth.addContent(json_response.data);
				  else
					  showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);

				  _this.restoreState();
			})
			.always(function(){
				 hideLoading();
			});
    },

    /**
     * Se fija si hay un estado de esta pagina y lo setea
     */
    restoreState: function()
    {
    	if(getURLParameter("readstate") && window.pageStateHealth) 
    	{
            $("#new_track_health_days_actual .dateselector").dateselector("date", pageStateHealth.current_date);

            // TODO: Aunque se actualiza el modelo del js, la vista no esta activamente
            // enlazada con el modelo, por lo tanto no se ven los cambios en pantalla.
            // Reemplazar estas asignaciones simples por llamadas a metodos que además
            // de realizar la asiganción actualicen la vista.
        	this.selected_item = pageStateHealth.selected_item;
            this.selected_value  = pageStateHealth.selected_value;
            this.selected_time  = pageStateHealth.selected_time;

            $("#newTrack_time").val(this.selected_time);

    		var idx = $('#tab_nhealth a[href="#medicine"]').parent().index();
   
    		$("#tab_nhealth").tabs( "option", "active", idx );
    		
            $('#a_page_new_track_health_tab_1').removeClass("ui-btn-active");
    		$('#a_page_new_track_health_tab_1 img').attr("src", "img/others/ic_health_measure.png");
            $('#a_page_new_track_health_tab_2').addClass("ui-btn-active");
    		$('#a_page_new_track_health_tab_2 img').attr("src", "img/others/ic_health_medicine_sel.png");

    		$("#a_div_indicators_medicine").text(pageNewTrackHealth.selected_item.title);
			$(".health_measure").text(pageNewTrackHealth.selected_item.unit);

			$(".div_datos_measure").hide();
        	$(".div_datos_medicine").show();
            $("#newTrack_medicine_value").focus();
    	}
    	else if ( window.pageStateHealth)
    	{
    		var idx = $('#tab_nhealth a[href="#medicine"]').parent().index();
    		$("#tab_nhealth").tabs( "option", "active", idx );
    		$('#a_page_new_track_health_tab_1').removeClass("ui-btn-active");
    		$('#a_page_new_track_health_tab_1 img').attr("src", "img/others/ic_health_measure.png");
            $('#a_page_new_track_health_tab_2').addClass("ui-btn-active");
    		$('#a_page_new_track_health_tab_2 img').attr("src", "img/others/ic_health_medicine_sel.png"); 
			$(".div_datos_measure").hide();
        	$(".div_datos_medicine").show();
    	}
    },
    
    currentState: function()
    {		
    	if(!sessionStorage.getItem("new_track_selected_state_health"))
		{
	    	var selected_state = {
	   	    	 active_tab: $('#tab_nhealth a[href="#medida"]').hasClass("ui-btn-active") ? "1" : "2" 
	       	 };
	       	 
	       	 sessionStorage.setItem("new_track_selected_state_health", JSON.stringify(selected_state));   		
		}
    },
    
    saveState: function()
    {
        var current_date = $("#new_track_health_days_actual .dateselector").dateselector("date");

        window.pageStateHealth = {
            current_date: current_date,
            selected_item: this.selected_item,
            selected_value: this.selected_value,
            selected_time: this.selected_time
        };
    },

    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header_new_track_health").html());
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["newTrack_health_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent : function(json)
    {
    	// Si no hay most_used en medida ocultamos esa seccion del html
    	if(!json.body.measure.most_used || json.body.measure.most_used.length == 0) $("#medida #seccion-most-used").hide();

        // Si no hay most_used en medicamento ocultamos esa seccion del html
        if(!json.body.medicine.most_used || json.body.medicine.most_used.length == 0) $("#medicamento #seccion-most-used").hide();

        pageNewTrackHealth.createIndicators(json.body.measure.most_used, "#div_mostUsed_measure");
        pageNewTrackHealth.createIndicators(json.body.medicine.most_used, "#div_mostUsed_medicine");
    	pageNewTrackHealth.createIndicators(json.body.measure.indicators, "#div_indicators");
    	    	
    	pageNewTrackHealth.resetNavbarsPosition(0);
    	
    	pageNewTrackHealth.respawnPage();
	},

	/**
	 * Crear los indicadores para los tracks pasados y colocarlos en la pagina.
	 * @param tracks lista de indicadores a crear
	 * @param div_id contenedor en donde se colocaran los indicadores creados
	 */
    createIndicators : function(tracks, div_id)
    {
    	var template_indicator = Handlebars.compile($("#template-indicator_new_track_health").html());
    	var gridPositions = ["ui-block-a", "ui-block-b", "ui-block-c", "ui-block-d"];
    	
    	var $selected_indicator = null;

    	var indicators = [];

   	 	$.each(tracks, function(i) {

            var title = this.title;
            if(isNaN(this.id))
                title = gjson_lang[this.id];

	 		// Estos son los datos que requiere el template de Handlebars
			var datos_item =  {
				block_class: gridPositions[i % gridPositions.length],
				id_item: this.id,
				activity_type: this.type,
				title: title,
                unit: this.unidad
			};

			// Generamos los elementos del DOM y le asociamos al información de este elemento
			// para despues poder recuperar toda la información del servidor
			var indicator = $(template_indicator(datos_item)).data("info", this);

			// Agregamos el indicador a la lista de indicadores que se mostraran
			indicators.push( indicator );
			
    	});
   	 	
   	 	// Borramos los indicadores anteriores y agregamos los nuevos
	   	$(div_id).empty().append(indicators).trigger( "updatelayout" );

	   	tracksImageErrorControl();

	   	$("#"+getURLParameter("content")).addClass("indicator_body_active");
	   	if (getURLParameter("content") != 'null')
	   		$(".div_datos").show();

	   	if ($selected_indicator) {
	   		$selected_indicator.click();
	   	}

	},

	adjustSizesOfTracks: function()
	{
		var width = pageNewTrackHealth.$page.find("#medida  .indicator_body").width();
		if (width)
			pageNewTrackHealth.$page.find("#medida .indicator_body").css("height", width );
		
		var width2 = pageNewTrackHealth.$page.find("#medicina .indicator_body").width();
		if (width2)
			pageNewTrackHealth.$page.find("#medicina .indicator_body").css("height", width2 );
	},
	
	initializeNavbarsOverflow: function()
    {
    	// Seteamos las fechas de los otros navbar
		var actual_date = $("#new_track_health_days_actual .dateselector").dateselector("date");
		var actual_minDate = $("#new_track_health_days_actual .dateselector").dateselector("minDate");
		var actual_maxDate = $("#new_track_health_days_actual .dateselector").dateselector("maxDate");
    	var int_start = Math.ceil(pageNewTrackHealth.dateselectorNumItems/2);
    	
        for (var i=int_start, len=int_start+(int_start-1); i<=len; i++)
    	{
        	console.log();
    		var date_ant = actual_date.clone().subtract(i, "day");
    		
    		var str_date_ant_formatted = getDayFormatedv2(date_ant.format("YYYYMMDD"));
    		
    		$("#new_track_health_days_ant .dateselector li:nth-child("+ (pageNewTrackHealth.dateselectorNumItems - i) +") a").html(str_date_ant_formatted);
    		
    		if ( date_ant.isBefore(actual_minDate) )
    			$("#new_track_health_days_ant .dateselector li:nth-child("+ (pageNewTrackHealth.dateselectorNumItems - i) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_health_days_ant .dateselector li:nth-child("+ (pageNewTrackHealth.dateselectorNumItems - i) +") a").removeClass("ui-state-disabled");
    		
    		var date_next = actual_date.clone().add(i, "day");
    		
    		var str_date_next_formatted = getDayFormatedv2(date_next.format("YYYYMMDD"))
    		
    		$("#new_track_health_days_next .dateselector li:nth-child("+ (i + 1) +") a").html(str_date_next_formatted);
    		
    		if ( date_next.isAfter(actual_maxDate) )
    			$("#new_track_health_days_next .dateselector li:nth-child("+ (i + 1) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_health_days_next .dateselector li:nth-child("+ (i + 1) +") a").removeClass("ui-state-disabled");
    	}
    },
    
    resetNavbarsPosition: function(time)
	{
		var int_time = (time == 0) ? 0 : time || pageNewTrackHealth.animationDuration;
		var int_lag = ($( window ).width()/pageNewTrackHealth.dateselectorNumItems);
		var int_lagged_items = (Math.floor(pageNewTrackHealth.dateselectorNumItems/2));
		var int_lag_total = int_lag * int_lagged_items;
    	$("#new_track_health_days_ant").animate( { "left": -(int_lag_total), "right": int_lag_total }, { duration: int_time, queue: false } );
    	$("#new_track_health_days_actual").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } );
    	$("#new_track_health_days_next").animate( { "left": int_lag_total +"px", "right": -(int_lag_total) +"px" }, { duration: int_time, queue: false } );
	},
	
	animateNavbars: function(direction, diff_days)
	{
		var obj_what_date = (diff_days) ? $("#new_track_health_days_actual .dateselector").dateselector("date").clone().add(diff_days, "day") : null;
		var int_num_days = Math.abs(diff_days);
		var int_lag = ($( window ).width()/pageNewTrackHealth.dateselectorNumItems);
		var int_lagged_items = Math.floor(pageNewTrackHealth.dateselectorNumItems/2);

		if (direction == "right") {
			var int_left_direction = 1;
			var int_right_direction = -1;
		}
		else if ( direction == "left") {
			var int_left_direction = -1;
			var int_right_direction = 1;
		}
		
		$("#new_track_health_days_actual").animate( 
			{ 
				"left": int_left_direction * int_lag * int_num_days, 
				"right": int_right_direction * int_lag * int_num_days
			}, 
			{ duration: pageNewTrackHealth.animationDuration, queue: false } 
		);
		
		$("#new_track_health_days_ant").animate( 
			{ 
				"left": -(int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": (int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackHealth.animationDuration, queue: false } 
		);
		
		$("#new_track_health_days_next").animate( 
			{ 
				"left": (int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": -(int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackHealth.animationDuration, queue: false } 
		)
		.promise()
		.done(function(){
			if ( !$("#new_track_health_days_actual .dateselector").dateselector("date", obj_what_date) )
				pageNewTrackHealth.resetNavbarsPosition();
		});
	},

	respawnPage: function()
	{
		
		
		$(".div_tabs").show();
		pageNewTrackHealth.adjustSizesOfTracks();
		
		var str_url_parameter = getDataURLParameter(pageNewTrackHealth.$page, "value");
		if (str_url_parameter)
		{
			$("#seccion-most-used #"+ str_url_parameter).addClass("indicator_body_active");
			$("#div_indicators #"+ str_url_parameter).click();
		}
	},

	changeTabs: function(id)
	{
		if (id == "a_page_new_track_health_tab_1")
		{
			$('#a_page_new_track_health_tab_1').find("img").attr("src", "img/others/ic_health_measure_sel.png" );
			$('#a_page_new_track_health_tab_2').find("img").attr("src", "img/others/ic_health_medicine.png" );
			$(".div_datos_measure").hide();
		}
		else
		{
			$('#a_page_new_track_health_tab_1').find("img").attr("src", "img/others/ic_health_measure.png" );
			$('#a_page_new_track_health_tab_2').find("img").attr("src", "img/others/ic_health_medicine_sel.png" );
		}
	},

    isMedicineTabSelected: function()
    {
        return $("#tab_nhealth ul li").find(".ui-btn-active").attr("id") == "a_page_new_track_health_tab_2";
    },

	checkRequiredFields: function()
	{
        var checkPass = true;

        // Los campos requeridos son diferentes dependiendo que tab se encuentre seleccionado
        if(this.isMedicineTabSelected()) {

             var medicine = this.getSelectedMedicineValue();

            if(!this.getSelectedTime()) checkPass = false; //Time
            if(!this.getSelectedItem()) checkPass = false; // Medicine
            if(!medicine || (medicine <= 0) || isNaN(medicine)) checkPass = false; // Quantity
        }
        else {
            var measure = $("#newTrack_measure_value").val();
            if (!measure || (measure <= 0) || isNaN(measure)) checkPass = false;
        }

        // Cambiamos el estado del hecho dependiendo si el tests fue exitoso o no
        if(!checkPass) $("#page_new_track_health #bt_footer_2").addClass("ui-state-disabled")
        else $("#page_new_track_health #bt_footer_2").removeClass("ui-state-disabled");
	}

};

/* EVENTS */

$( window ).off( ".new_track_health" )
	.on("resize.new_track_health", function()
	{
		if (pageNewTrackHealth) {
			pageNewTrackHealth.adjustSizesOfTracks();
			adjustSizeOfGridFooterActions($("#page_new_track_health"));
		}
	});

$( document ).off( ".new_track_health" )

	.on( "pagebeforecreate.new_track_health", "#page_new_track_health", function()
	{
		$("#page_new_track_health #bt_footer_2").addClass("ui-state-disabled");	
	})
	
	.on("pagecreate.new_track_health", "#page_new_track_health", function()
    {
		pageNewTrackHealth.$page = $(this);
    })

	.on("pagecontainershow.new_track_health", function(event, ui)
	{
		if (ui.toPage.attr("id") == "page_new_track_health")
		{
			pageNewTrackHealth.createHeader();
			adjustSizeOfGridFooterActions($(this));
			
			var minDate = currentDate().subtract(15, "days");
	        if(minDate.isBefore(Nire.rangeData.minDate)){
	            //si por alguna razon el minDate del usuario es el dia siguiente,
	            //fuerzo la fecha actual como minima
	            if(Nire.rangeData.minDate.isAfter(currentDate()))
	                minDate = currentDate();
	            else
	                minDate = Nire.rangeData.minDate;
	        }
	
			$("#new_track_health_days_actual .dateselector").dateselector({
				minDate: minDate,
				maxDate: currentDate(),
				change: function(event, newdate) {
					pageNewTrackHealth.$page.find(".fdata").text(getDateFormatted(newdate.format("YYYYMMDD")));
					pageNewTrackHealth.resetNavbarsPosition(0);
					pageNewTrackHealth.initializeNavbarsOverflow();
	            },
				fn_date_clicked: function(obj_new_date) {
		    		var obj_from_date = $("#new_track_health_days_actual .dateselector").dateselector( "date" );
		    		var int_diff_days = obj_new_date.diff(obj_from_date, 'days');
		    		if ( obj_new_date.isAfter(obj_from_date) ){
		    			pageNewTrackHealth.animateNavbars("left", int_diff_days);
		        	} else if ( obj_new_date.isBefore(obj_from_date) ){
		        		pageNewTrackHealth.animateNavbars("right", int_diff_days);
		        	}
		    		return false;
		    	}
			});
		}
	})
	
	.on( "pagecontainerchange.new_track_health", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_new_track_health")
    	{
    		pageNewTrackHealth.getData(currentDate());
    	}
	})

	.on("pageremove.new_track_health", "#page_new_track_health", function()
	{
		$( window ).off( ".new_track_health" );
		$( document ).off( ".new_track_health" );
		$( 'link[href="css/pageNewTrackHealth.css"]' ).remove();
		pageNewTrackHealth = null;
	})

	.on("click.new_track_health", "#a_div_indicators_medicine", function(event)
	{        
        // save state and load medicine picker.
        pageNewTrackHealth.selected_item = $(this).parents(".indicator").data("info");
        pageNewTrackHealth.saveState();
        $( "body" ).pagecontainer( "change", "newTrackHealthMedicine.html", { changeHash: false } );
    })

	.on("click.new_track_health", "#a_page_new_track_health_tab_1, #a_page_new_track_health_tab_2", function(event)
	{
		pageNewTrackHealth.changeTabs($(this).attr("id"));
		pageNewTrackHealth.adjustSizesOfTracks();
	})

	.on("click.new_track_health", "#bt_footer_2", function(event)
	{
		pageNewTrackHealth.confirm();
	})

	.on("click.new_track_health", ".indicator_body", pageNewTrackHealth.select)
	
	.on("input.new_track_health", "#newTrack_time", function()
	{
        pageNewTrackHealth.selected_time = $(this).val();
        pageNewTrackHealth.checkRequiredFields();
    })

    .on("input.new_track_health", "#newTrack_measure_value", pageNewTrackHealth.checkRequiredFields.bind(pageNewTrackHealth))
    .on("input.new_track_health", "#newTrack_medicine_value", pageNewTrackHealth.checkRequiredFields.bind(pageNewTrackHealth));
