/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNewTrackHealthMedicine.css"/>');

/* VARIABLES */
var pageNewTrackHealthMedicine = {
    /**
     * El usuario selecciono un item
     */
    select: function(info)
    {
        // Castigame Dios, no solo utilizo una variable global, sino que es una variable
        // global pensada para mantener el estado de otra pagina.
        // Deberia implementar un sistema correcto de Flash Scope :(

        window.pageStateHealth.selected_item = info;
        $( "body" ).pagecontainer( "change", "newTrackHealth.html", { data: {readstate: true}} );
    },

    getData : function()
    {
        showLoading();

        var searchString = $("#search-input").val() + "*";

        Nire.connection.newTrackHealthMedicine(searchString)
            .done(function(json_response) {
                  hideLoading();
                  console.log(json_response.hits);
                  pageNewTrackHealthMedicine.addContent(json_response.hits);
            });
    },

    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header_health_medicine").html());
                
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["newTrack_health_medicine_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent : function(json)
    {
        var template = Handlebars.compile( $("#template-item_health_medicine").text() )
        $('#div_medicine_list').empty();
        $(json.hits).each(function() {

            // No entiendo bien porque elasticsearch esta retornando arrays en estos campos
            // en lugar de retornar el valor correspondinte. No descarto que sea un error
            // en el query o en a indexación. Posiblemente en el futuro haya que quitar el [0]
            // pero por ahora lo mantenemos para que funcione.
            var item = {
                title: this.fields.name[0],
                id: this.fields.id[0]
            }
            var element = $(template(item));
            element.data("info", item)

            $("#div_medicine_list").append( element );
        });
        $('#div_medicine_list').trigger( "updatelayout" );
    },

};

/* EVENTS */

$( document ).off( ".new_track_health_medicine" )

    .on("pagecreate.new_track_health_medicine", "#page_new_track_health_medicine", function(event)
    {
		$( "#app_header" ).toolbar();

    })

    .on("pageshow.new_track_health_medicine", "#page_new_track_health_medicine", function()
    {
        pageNewTrackHealthMedicine.createHeader();
    })

    .on("pageremove.new_track_health_medicine", "#page_new_track_health_medicine", function()
    {
        $( document ).off( ".new_track_health_medicine" );
        $( 'link[href="css/pageNewTrackHealthMedicine.css"]' ).remove();
        pageNewTrackHealthMedicine = null;
    })

    .on("click.new_track_health_medicine", "#div_medicine_list a", function()
    {
        pageNewTrackHealthMedicine.select($(this).data("info"));
    })

    .on("keypress.new_track_health_medicine", "#search-input", function(event)
    {
        if(event.which == 13)
            pageNewTrackHealthMedicine.getData();
    })

    .on( "input.new_track_health_medicine", "#search-input", function(event)
    {
        event.preventDefault();

        var value = $(this).val();

        if(value && value.length >= 3){
            setTimeout(function(){
                var newValue = $('#search-input').val().trim();
                if(value == newValue)
                    pageNewTrackHealthMedicine.getData();
            }, 300);
        }

        return false;
    })
    
    .on("click.new_track_health_medicine", "#back_HealthMedicine", function()
	{
		$( "body" ).pagecontainer( "change", "newTrackHealth.html" );
	});;