/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNewTrackNutrition.css"/>');

/* VARIABLES */
var pageNewTrackNutrition = {
		
	$page: null,
	animationDuration: 500,
	dateselectorNumItems: 7,

    // Item actualmente seleccionado
    selected_item: null,

    // Horario actualmente seleccionado
    selected_meal: null,

    // Receta seleccionada
    selected_recipe: null,

    // Cantidad de unidades
    quantity: 0,

    /**
     * Confirmar la selección y enviarla al servidor
     * Cuidado! Utiliza this, no llamar como callback de un evento
     */
    confirm: function()
    {
        var current_date = $("#new_track_nutrition_days_actual .dateselector").dateselector("date").format("YYYYMMDD");

        Nire.connection.nutritionNew(this.selected_recipe.id, current_date, this.selected_meal.id, this.quantity)
            .done(function() {
            	$("#page_timeline").trigger("pageremove");
            	$("#page_timeline").remove();
            	if ( $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-2].pageUrl.match("nutritionWeekly.html") 
            			|| ($.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-2].pageUrl.match("newTrackNutrition.html") 
                				&& $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-3].pageUrl.match("nutritionWeekly.html")) 
                		|| ($.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-3].pageUrl.match("newTrackNutrition.html") 
                				&& $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-4].pageUrl.match("nutritionWeekly.html")) )
            		$("body").pagecontainer( "change", "nutritionWeekly.html" );
            	else
            		$("body").pagecontainer( "change", "timeline.html" );
            })
            .fail(function() { showAlert(i18n('newTrack_nutrition_error'), null, gjson_lang.error, gjson_lang.accept); });
    },

    /**
     * PRIVATE.
     * Selecciona un indicador, deseleccionando todos los indicadores de los demas grupos indicados
     */
    _selectIndicator: function(element, groups)
    {
        var ACTIVE_CLASS = "indicator_body_active";
        var str_src = null;

        // Quitamos la clase indicator_body_active a todos indicadores y luego se lo agregamos
        // al que acabamos de clickear
        $(groups).each(function() {

        	str_src = $(this + ' .'+ ACTIVE_CLASS + ' img.image30').attr("src");
        	if (str_src)
        		$(this + ' .'+ ACTIVE_CLASS + ' img.image30').attr("src", str_src.replace("_sel.", "."));

        	$(this + ' .'+ ACTIVE_CLASS + ', ' + this + ' .' + ACTIVE_CLASS + ' p').removeClass(ACTIVE_CLASS);
        });
        $(element).find("div").addClass(ACTIVE_CLASS).find("p").addClass(ACTIVE_CLASS);
        str_src = $(element).find("img.image30").attr("src");
        if (str_src)
        	$(element).find("img.image30").attr("src", str_src.replace(".png", "_sel.png"));
        // Retornamos la informacion del indicador seleccionado
        return $(element).data("info");
    },

    /**
     * El usuario selecciona un indicador para escoger el horario de la comida
     * El elemento sobre el que hizo click llega como parametros.
     *
     * Cuidado! Utiliza this, no debe ser llamado como handler de un evento
     */
    selectMeal: function(element)
    {
        // Si nos dan un id en lugar de un elemento, buscamos el indicador
        // que corresponda con el id dado
        if($.isNumeric(element)) {
            var id = element;
            $("#div_food_types .indicator").each(function() {
                if($(this).data("info").id == id) element = this;
            });
        }

        this.selected_meal = this._selectIndicator(element, ["#div_food_types"]);
    },

    /**
     * Si hay una receta seleccionada, cambia la cantidad consumida.
     * Al hacer esto recalcula las calorias consumidas.
     */
    changeQuantity: function(quantity)
    {
        this.quantity = quantity;

        $("#newTrack_quantity_value").val( quantity );
        $("#newTrack_calories").val( formatNumber(quantity * this.selected_recipe.calories, "kcal") + " Kcal");

        pageNewTrackNutrition.checkRequiredFields();

        return false;
    },

    checkRequiredFields: function()
    {
		var quantity = $("#newTrack_quantity_value").val();
		if (!quantity || isNaN(quantity))
			$("#page_new_track_nutrition #bt_footer_2").addClass("ui-state-disabled");
		else
			$("#page_new_track_nutrition #bt_footer_2").removeClass("ui-state-disabled");
	},

    /**
     * El usuario selecciono uno de los indicadores de comidas mas frecuentes
     */
    selectMostUsed: function(element)
    {
        this.selected_item = this._selectIndicator(element, ["#seccion-most-used", "#div_indicators"]);
        this.selected_recipe = $(element).data("info");
		this.selected_recipe = $(element).data("info");


        $("#p_nutrition_select").text( element.attr("data-title") );
        $("#newTrack_quantity_value").val( "1" );
        this.quantity = 1;
        $("#newTrack_calories").val( formatNumber(element.attr("data-calories"), "kcal") + " Kcal.");


        $("#selected-info").show();
        $("#newTrack_quantity_value").focus();
    },

    getData : function(day)
    {
        var _this = this;

        showLoading();
        Nire.connection.newNutrition(day)
            .done(function(json_response) {
                hideLoading();
                if (json_response.error.code == 0)
                    pageNewTrackNutrition.addContent(json_response.data);
                else
                	showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);

                _this.restoreState();
                _this.currentState();
            });
    },

    /**
     * Se fija si hay un estado de esta pagina y lo setea
     */
    restoreState: function()
    {
        if(getURLParameter("readstate") && window.pageStateNutrition) {

        	if(pageStateNutrition.selected_meal)
                this.selectMeal( pageStateNutrition.selected_meal.id );

            if(pageStateNutrition.selected_item){
                var element;
                $("#div_indicators .indicator").each(function() {
                    if($(this).data("info").id == pageStateNutrition.selected_item.id) element = this;
                });
                this._selectIndicator(element, ["#seccion-most-used", "#div_indicators"]);

            }
            $("#new_track_nutrition_days_actual .dateselector").dateselector("date", pageStateNutrition.current_date);

            if(pageStateNutrition.selected_recipe) {
                var recipe = pageStateNutrition.selected_recipe;
                this.selected_recipe = recipe;

                $("#p_nutrition_select").text( recipe.title );
                this.changeQuantity( Math.max(1,pageStateNutrition.quantity) );
            }

            if (pageStateNutrition.selected_item || pageStateNutrition.selected_recipe) {
            	$("#selected-info").show();
                $("#newTrack_quantity_value").focus();
            }
        }
    },

    currentState: function()
    {   
    	if(!sessionStorage.getItem("new_track_selected_state_nutrition"))
		{
	    	var selected_state = {
	   	    	 prev_page: $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length - 2].pageUrl
	       	 };
	       	 
	       	 sessionStorage.setItem("new_track_selected_state_nutrition", JSON.stringify(selected_state));   		
		}
    },
    
    saveState: function()
    {
        var current_date = $("#new_track_nutrition_days_actual .dateselector").dateselector("date");

        window.pageStateNutrition = {
            selected_meal: this.selected_meal,
            current_date: current_date,
            selected_item: this.selected_item,
            quantity: this.quantity
        };
    },

    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header_new_track_nutrition").html());
                
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["newTrack_nutrition_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent : function(json)
    {
        // Si no hay most_used ocultamos esa seccion del html
        if(!json.body.most_used || json.body.most_used.length == 0) $("#seccion-most-used").hide();

        pageNewTrackNutrition.createIndicators(json.body.food_types, "#div_food_types", 'type');
        pageNewTrackNutrition.createIndicators(json.body.most_used, "#div_mostUsed", '');
        pageNewTrackNutrition.createIndicators(json.body.indicators, "#div_indicators", 'group');
        
        pageNewTrackNutrition.resetNavbarsPosition(0);

        if (getURLParameter("content") != null)
        {
            $("#p_nutrition_select").text( getURLParameter("title") );
            $("#newTrack_quantity_value").val( "1" );
            $("#newTrack_calories").val( formatNumber(getURLParameter("value"), "kcal") + " Kcal.");
            $("#newTrack_quantity_value").focus();
        }
    },

    /**
     * Crear los indicadores para los tracks pasados y colocarlos en la pagina.
     * @param tracks lista de indicadores a crear
     * @param div_id contenedor en donde se colocaran los indicadores creados
     */
    createIndicators : function(tracks, div_id, section)
    {
    	if (div_id == "#div_mostUsed")
            var template_indicator = Handlebars.compile($("#template-indicator_most_used_new_track_nutrition").html());
        else if (div_id == "#div_food_types")
            var template_indicator = Handlebars.compile($("#template-mealtype_new_track_nutrition").html());
        else
            var template_indicator = Handlebars.compile($("#template-indicator_new_track_nutrition").html());

        var gridPositions = ["ui-block-a", "ui-block-b", "ui-block-c"];

        var indicators = [];
        $.each(tracks, function(i) {
            // Estos son los datos que requiere el template de Handlebars
            var datos_item =  {
                block_class: gridPositions[i % gridPositions.length],
                active_class: (div_id == "#div_food_types" && i == 0) ?"indicator_body_active" : null,
                type: this.type,
                title: (div_id == "#div_food_types") ? gjson_lang["nutrition_meal_"+this.type] : this.title, // Si es tipo usamos el language sino directamente del JSON
                //title: gjson_lang["nutrition_meal_"+this.type], // Ignoramos el title que viene en el JSON
                quantity: this.calories,
                section: section
            };
            if (datos_item.active_class)
            	datos_item.selected = "_sel";

            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var indicator = $(template_indicator(datos_item)).data("info", this);

            // Agregamos el indicador a la lista de indicadores que se mostraran
            indicators.push( indicator );
        });
        pageNewTrackNutrition.selectMeal($(".indicator_body_active").parents(".indicator"));

        // Borramos los indicadores anteriores y agregamos los nuevos
        $(div_id).empty().append(indicators).trigger( "updatelayout" );

        tracksImageErrorControl();

        pageNewTrackNutrition.adjustSizesOfTracks();
    },

    adjustSizesOfTracks: function()
    {
    	var width = pageNewTrackNutrition.$page.find(".indicator_body").width();
    	if (width)
    		pageNewTrackNutrition.$page.find(".indicator_body").css("height", width );
    },
    
    initializeNavbarsOverflow: function()
    {
    	// Seteamos las fechas de los otros navbar
		var actual_date = $("#new_track_nutrition_days_actual .dateselector").dateselector("date");
		var actual_minDate = $("#new_track_nutrition_days_actual .dateselector").dateselector("minDate");
		var actual_maxDate = $("#new_track_nutrition_days_actual .dateselector").dateselector("maxDate");
    	var int_start = Math.ceil(pageNewTrackNutrition.dateselectorNumItems/2);
    	
        for (var i=int_start, len=int_start+(int_start-1); i<=len; i++)
    	{
        	console.log();
    		var date_ant = actual_date.clone().subtract(i, "day");
    		
    		var str_date_ant_formatted = getDayFormatedv2(date_ant.format("YYYYMMDD"));
    		
    		$("#new_track_nutrition_days_ant .dateselector li:nth-child("+ (pageNewTrackNutrition.dateselectorNumItems - i) +") a").html(str_date_ant_formatted);
    		
    		if ( date_ant.isBefore(actual_minDate) )
    			$("#new_track_nutrition_days_ant .dateselector li:nth-child("+ (pageNewTrackNutrition.dateselectorNumItems - i) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_nutrition_days_ant .dateselector li:nth-child("+ (pageNewTrackNutrition.dateselectorNumItems - i) +") a").removeClass("ui-state-disabled");
    		
    		var date_next = actual_date.clone().add(i, "day");
    		
    		var str_date_next_formatted = getDayFormatedv2(date_next.format("YYYYMMDD"))
    		
    		$("#new_track_nutrition_days_next .dateselector li:nth-child("+ (i + 1) +") a").html(str_date_next_formatted);
    		
    		if ( date_next.isAfter(actual_maxDate) )
    			$("#new_track_nutrition_days_next .dateselector li:nth-child("+ (i + 1) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_nutrition_days_next .dateselector li:nth-child("+ (i + 1) +") a").removeClass("ui-state-disabled");
    	}
    },
    
    resetNavbarsPosition: function(time)
	{
		var int_time = (time == 0) ? 0 : time || pageNewTrackNutrition.animationDuration;
		var int_lag = ($( window ).width()/pageNewTrackNutrition.dateselectorNumItems);
		var int_lagged_items = (Math.floor(pageNewTrackNutrition.dateselectorNumItems/2));
		var int_lag_total = int_lag * int_lagged_items;
    	$("#new_track_nutrition_days_ant").animate( { "left": -(int_lag_total), "right": int_lag_total }, { duration: int_time, queue: false } );
    	$("#new_track_nutrition_days_actual").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } );
    	$("#new_track_nutrition_days_next").animate( { "left": int_lag_total +"px", "right": -(int_lag_total) +"px" }, { duration: int_time, queue: false } );
	},
	
	animateNavbars: function(direction, diff_days)
	{
		var obj_what_date = (diff_days) ? $("#new_track_nutrition_days_actual .dateselector").dateselector("date").clone().add(diff_days, "day") : null;
		var int_num_days = Math.abs(diff_days);
		var int_lag = ($( window ).width()/pageNewTrackNutrition.dateselectorNumItems);
		var int_lagged_items = Math.floor(pageNewTrackNutrition.dateselectorNumItems/2);

		if (direction == "right") {
			var int_left_direction = 1;
			var int_right_direction = -1;
		}
		else if ( direction == "left") {
			var int_left_direction = -1;
			var int_right_direction = 1;
		}
		
		$("#new_track_nutrition_days_actual").animate( 
			{ 
				"left": int_left_direction * int_lag * int_num_days, 
				"right": int_right_direction * int_lag * int_num_days
			}, 
			{ duration: pageNewTrackNutrition.animationDuration, queue: false } 
		);
		
		$("#new_track_nutrition_days_ant").animate( 
			{ 
				"left": -(int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": (int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackNutrition.animationDuration, queue: false } 
		);
		
		$("#new_track_nutrition_days_next").animate( 
			{ 
				"left": (int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": -(int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackNutrition.animationDuration, queue: false } 
		)
		.promise()
		.done(function(){
			if ( !$("#new_track_nutrition_days_actual .dateselector").dateselector("date", obj_what_date) )
				pageNewTrackNutrition.resetNavbarsPosition();
		});
	},

};

/* EVENTS */

$( window ).off( ".new_track_nutrition" )
    .on("resize.new_track_nutrition", function()
	{
    	if(pageNewTrackNutrition) {
    		pageNewTrackNutrition.adjustSizesOfTracks();
    		adjustSizeOfGridFooterActions($("#page_new_track_nutrition"));
    	}
	});

$( document ).off( ".new_track_nutrition" )

    .on( "pagebeforecreate.new_track_nutrition", "#page_new_track_nutrition", function()
    {
		$("#page_new_track_nutrition #bt_footer_2").addClass("ui-state-disabled");
    })
    
    .on("pagecreate.new_track_nutrition", "#page_new_track_nutrition", function()
    {
    	pageNewTrackNutrition.$page = $(this);
		$( "#app_header" ).toolbar();		
    })

    .on("pageshow.new_track_nutrition", "#page_new_track_nutrition", function()
    {
    	pageNewTrackNutrition.createHeader();
    	adjustSizeOfGridFooterActions($(this));
        pageNewTrackNutrition.getData( currentDate() );
        
        var minDate = currentDate().subtract(15, "days");
        if(minDate.isBefore(Nire.rangeData.minDate)){
            //si por alguna razon el minDate del usuario es el dia siguiente,
            //fuerzo la fecha actual como minima
            if(Nire.rangeData.minDate.isAfter(currentDate()))
                minDate = currentDate();
            else
                minDate = Nire.rangeData.minDate;
        }

        $("#new_track_nutrition_days_actual .dateselector").dateselector({
            minDate: minDate,
            maxDate: currentDate(),
            change: function(event, newdate) {
				pageNewTrackNutrition.$page.find(".fdata").text(getDateFormatted(newdate.format("YYYYMMDD")));
				pageNewTrackNutrition.resetNavbarsPosition(0);
				pageNewTrackNutrition.initializeNavbarsOverflow();
            },
			fn_date_clicked: function(obj_new_date) {
	    		var obj_from_date = $("#new_track_nutrition_days_actual .dateselector").dateselector( "date" );
	    		var int_diff_days = obj_new_date.diff(obj_from_date, 'days');
	    		if ( obj_new_date.isAfter(obj_from_date) ){
	    			pageNewTrackNutrition.animateNavbars("left", int_diff_days);
	        	} else if ( obj_new_date.isBefore(obj_from_date) ){
	        		pageNewTrackNutrition.animateNavbars("right", int_diff_days);
	        	}
	    		return false;
	    	}
        });
    })

    .on("pageremove.new_track_nutrition", "#page_new_track_nutrition", function()
    {
    	$( window ).off( ".new_track_nutrition" );
    	$( document ).off( ".new_track_nutrition" );
        $( 'link[href="css/pageNewTrackNutrition.css"]' ).remove();
        pageNewTrackNutrition = null;
    })

    .on("click.new_track_nutrition", "#div_food_types .indicator_body", function()
    {
    	pageNewTrackNutrition.selectMeal( $(this).parents(".indicator") );
    })

    .on("click.new_track_nutrition", "#seccion-most-used .indicator_body", function()
    {
    	pageNewTrackNutrition.selectMostUsed( $(this).parents(".indicator") );
    })

    .on("click.new_track_nutrition", "#div_indicators .indicator_body", function()
    {
        pageNewTrackNutrition.selected_item = $(this).parents(".indicator").data("info");
        pageNewTrackNutrition.saveState();

        var data = { category: $(this).parents(".indicator").data("info").id };

        $( "body" ).pagecontainer( "change", "newTrackNutritionFood.html", { changeHash: false, data: data } );
    })
	
    .on("click.new_track_nutrition", "#bt_footer_2", function()
    {
    	pageNewTrackNutrition.confirm();
    	sessionStorage.removeItem("new_track_selected_state_nutrition");
    })

    .on("input.new_track_nutrition", "#newTrack_quantity_value", function()
    {
    	return pageNewTrackNutrition.changeQuantity($(this).val());
    });
