/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNewTrackNutritionFood.css"/>');

/* VARIABLES */
var pageNewTrackNutritionFood = {
	/**
	 * El usuario selecciono un item
	 */
	select: function(info)
	{
		// Castigame Dios, no solo utilizo una variable global, sino que es una variable
		// global pensada para mantener el estado de otra pagina.
		// Deberia implementar un sistema correcto de Flash Scope :(
		window.pageStateNutrition.selected_recipe = info;
		$( "body" ).pagecontainer( "change", "newTrackNutrition2.html", { data: {readstate: true}} );
	},

    getData : function(category)
    {
    	showLoading();
		Nire.connection.getFood(category)
			.done(function(json_response) {
				  hideLoading();
				  if (json_response.error.code == 0)
					  pageNewTrackNutritionFood.addContent(json_response.data);
				  else
					  showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
			});
    },

    createHeader : function()
    {
    	var template = Handlebars.compile($("#template-header_nutrition_food").html())

		$( "#app_header" ).html( template({ title: gjson_lang["newTrack_nutrition_indicator"] }) );
		$( "#app_header" ).toolbar( "refresh" );
		$( "#app_header" ).show();
		$( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();
    },

    addContent : function(json)
    {
    	if (json.body.title)
    		$("#page_title").text(json.body.title);
    	
    	var template = Handlebars.compile( $("#template-item_nutrition_food").text() )
    	$(json.body.food).each(function() {
    		var element = $(template(this));
    		element.data("info", this)

    		$("#nutrition_food_div_food_list").append( element );
    	});
    	$("#nutrition_food_div_food_list").trigger( "updatelayout" );
	}

};

/* EVENTS */

$( document ).off( ".new_track_nutrition_food" )

	.on("pagecreate.new_track_nutrition_food", "#page_new_track_nutrition_food", function()
    {
		$( "#app_header" ).toolbar();
    })

	.on("pageshow.new_track_nutrition_food", "#page_new_track_nutrition_food", function()
	{
		pageNewTrackNutritionFood.createHeader();
		pageNewTrackNutritionFood.getData( getDataURLParameter($(this), "category") );
	})

	.on("pageremove.new_track_nutrition_food", "#page_new_track_nutrition_food", function()
	{
		$( document ).off( ".new_track_nutrition_food" );
		$( 'link[href="css/pageNewTrackNutritionFood.css"]' ).remove();
		pageNewTrackNutritionFood = null;
	})

	.on("click.new_track_nutrition_food", "#nutrition_food_div_food_list a", function()
	{		
		pageNewTrackNutritionFood.select($(this).data("info"));
	})
	
	.on("click.new_track_nutrition_food", "#back_NutritionFood", function()
	{
		$( "body" ).pagecontainer( "change", "newTrackNutrition2.html" );
	});