/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNewTrackPhysicalActivity.css"/>');

/* VARIABLES */
var pageNewTrackPhysicalActivity = {
	
	$page: null,
	animationDuration: 500,
	dateselectorNumItems: 7,

	// Item actualmente seleccionado
	selected_item: null,

	// Peso del usuario logueado
	userWeight: 1,

	/**
	 * Confirmar la selección y enviarla al servidor
	 * Cuidado! Utiliza this, no llamar como callback de un evento
	 */
	confirm: function()
	{
		var time = $("#newTrack_time_value").val();

		// TODO: Verificar que los datos tengan sentidos y esten completos

		var current_date = $("#new_track_physical_activity_days_actual .dateselector").dateselector("date").format("YYYYMMDD");
		Nire.connection.physicalActivityNew(this.selected_item.id, current_date, time)
			.done(function() {
				$("#page_timeline").trigger("pageremove");
            	$("#page_timeline").remove();
            	if ( $.mobile.navigate.history.stack[$.mobile.navigate.history.stack.length-2].pageUrl.match("physicalActivityWeekly.html") )
            		$("body").pagecontainer( "change", "physicalActivityWeekly.html" );
            	else
            		$("body").pagecontainer( "change", "timeline.html" );
            })
			.fail(function() { showAlert(gjson_lang.newTrack_physical_activity_error, null, gjson_lang.error, gjson_lang.accept); })
	},

	/**
	 * Handler del click del usuario cuando hace click sobre un indicador
	 */
	select: function(event)
	{
		$("#newTrack_time_value").blur();

		var ACTIVE_CLASS = "indicator_body_active";

		// Quitamos la clase indicator_body_active a todos indicadores y luego se lo agregamos
		// al que acabamos de clickear
		str_src = $('.'+ ACTIVE_CLASS + ' img.image30').attr("src");
    	if (str_src)
    		$('.'+ ACTIVE_CLASS + ' img.image30').attr("src", str_src.replace("_sel.", "."));
		$(".indicator_body_active").removeClass(ACTIVE_CLASS);
		$(this).addClass(ACTIVE_CLASS).find("p").addClass(ACTIVE_CLASS);
		str_src = $(this).find("img.image30").attr("src");
        if (str_src)
        	$(this).find("img.image30").attr("src", str_src.replace(".png", "_sel.png"));

		// Guardamos en un atributo la información del item actualmente seleccionado
		pageNewTrackPhysicalActivity.selected_item = $(this).parents(".indicator").data("info");

        //pongo el indicador de unidad de tiempo

        $(".physical_activity_category_measure").text(gjson_lang[pageNewTrackPhysicalActivity.selected_item.unidad]);

        // Cuando seleccionamos un elemento, mostramos el area donde se puede elegir
		// el tiempo de actividad
        $(".div_datos").show();
        $("#newTrack_time_value").focus();

		// Actualizamos el indicador de gasto calorico
		pageNewTrackPhysicalActivity.changeTime();
	},

	/**
	 * El usuario cambio el tiempo que ha realizado la actividad.
	 * Este método actualiza en base a la actividad seleccionada y el nuevo tiempo el gasto calorico
	 */
	changeTime: function()
	{
		var info = pageNewTrackPhysicalActivity.selected_item;
		var time = $("#newTrack_time_value").val();

		var calories = info.mets * pageNewTrackPhysicalActivity.userWeight * time;
		$("#newTrack_time").val( formatNumber(calories, "kcal") + " Kcal");

		pageNewTrackPhysicalActivity.checkRequiredFields();
	},

	checkRequiredFields: function()
	{
		var time = $("#newTrack_time_value").val();
		if (!time || time <= 0 || isNaN(time))
			$("#page_new_track_physical_activity #bt_footer_2").addClass("ui-state-disabled");
		else
			$("#page_new_track_physical_activity #bt_footer_2").removeClass("ui-state-disabled");
	},

    getData : function(day)
    {
    	showLoading();

		Nire.connection.newPhysicalActivity(day)
			.done(function(json_response) {
				  hideLoading();
				  if (json_response.error.code == 0)
					  pageNewTrackPhysicalActivity.addContent(json_response.data);
				  else
					  showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
			});
    },


    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header_new_track_physical_activity").html());
                
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["newTrack_physical_activity_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent : function(json)
    {
    	pageNewTrackPhysicalActivity.userWeight = json.body.userWeight;
    	// Si no hay most_used ocultamos esa seccion del html
    	if(!json.body.most_used || json.body.most_used.length == 0) $("#seccion-most-used").hide();

    	pageNewTrackPhysicalActivity.createIndicators(json.body.most_used, "#div_mostUsed");
    	pageNewTrackPhysicalActivity.createIndicators(json.body.indicators, "#div_indicators");
    	
    	pageNewTrackPhysicalActivity.resetNavbarsPosition(0);
	},

	/**
	 * Crear los indicadores para los tracks pasados y colocarlos en la pagina.
	 * @param tracks lista de indicadores a crear
	 * @param div_id contenedor en donde se colocaran los indicadores creados
	 */
    createIndicators : function(tracks, div_id)
    {
    	var template_indicator = Handlebars.compile($("#template-indicator_new_track_physical_activity").html());
    	var gridPositions = ["ui-block-a", "ui-block-b", "ui-block-c", "ui-block-d"];

    	var indicators = [];

   	 	$.each(tracks, function(i) {
	 		// Estos son los datos que requiere el template de Handlebars
			var datos_item =  {
				block_class: gridPositions[i % gridPositions.length],
				id_item: this.id,
				activity_type: this.type,
				title: this.title,
                unit: this.unidad
			};

			// Generamos los elementos del DOM y le asociamos al información de este elemento
			// para despues poder recuperar toda la información del servidor
			var indicator = $(template_indicator(datos_item)).data("info", this);

			// Agregamos el indicador a la lista de indicadores que se mostraran
			indicators.push( indicator );
    	});

   	 	// Borramos los indicadores anteriores y agregamos los nuevos
	   	$(div_id).empty().append(indicators).trigger( "updatelayout" );

	   	tracksImageErrorControl();

	   	$("#"+getURLParameter("content")).addClass("indicator_body_active");
	   	if (getURLParameter("content") != null && getURLParameter("content") != 'null') {
	   		$(".div_datos").show();
	   		$("#newTrack_time_value").focus();
	   	}

    	pageNewTrackPhysicalActivity.adjustSizesOfTracks();
	},

	adjustSizesOfTracks: function()
	{
		var width = pageNewTrackPhysicalActivity.$page.find(".indicator_body").width();
		if (width)
			pageNewTrackPhysicalActivity.$page.find(".indicator_body").css("height", width );
	},
	
	initializeNavbarsOverflow: function()
    {
		// Seteamos las fechas de los otros navbar
		var actual_date = $("#new_track_physical_activity_days_actual .dateselector").dateselector("date");
		var actual_minDate = $("#new_track_physical_activity_days_actual .dateselector").dateselector("minDate");
		var actual_maxDate = $("#new_track_physical_activity_days_actual .dateselector").dateselector("maxDate");
    	var int_start = Math.ceil(pageNewTrackPhysicalActivity.dateselectorNumItems/2);
    	
        for (var i=int_start, len=int_start+(int_start-1); i<=len; i++)
    	{
        	console.log();
    		var date_ant = actual_date.clone().subtract(i, "day");
    		
    		var str_date_ant_formatted = getDayFormatedv2(date_ant.format("YYYYMMDD"));
    		
    		$("#new_track_physical_activity_days_ant .dateselector li:nth-child("+ (pageNewTrackPhysicalActivity.dateselectorNumItems - i) +") a").html(str_date_ant_formatted);
    		
    		if ( date_ant.isBefore(actual_minDate) )
    			$("#new_track_physical_activity_days_ant .dateselector li:nth-child("+ (pageNewTrackPhysicalActivity.dateselectorNumItems - i) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_physical_activity_days_ant .dateselector li:nth-child("+ (pageNewTrackPhysicalActivity.dateselectorNumItems - i) +") a").removeClass("ui-state-disabled");
    		
    		var date_next = actual_date.clone().add(i, "day");
    		
    		var str_date_next_formatted = getDayFormatedv2(date_next.format("YYYYMMDD"))
    		
    		$("#new_track_physical_activity_days_next .dateselector li:nth-child("+ (i + 1) +") a").html(str_date_next_formatted);
    		
    		if ( date_next.isAfter(actual_maxDate) )
    			$("#new_track_physical_activity_days_next .dateselector li:nth-child("+ (i + 1) +") a").addClass("ui-state-disabled");
    		else
    			$("#new_track_physical_activity_days_next .dateselector li:nth-child("+ (i + 1) +") a").removeClass("ui-state-disabled");
    	}
    },
    
    resetNavbarsPosition: function(time)
	{
		var int_time = (time == 0) ? 0 : time || pageNewTrackPhysicalActivity.animationDuration;
		var int_lag = ($( window ).width()/pageNewTrackPhysicalActivity.dateselectorNumItems);
		var int_lagged_items = (Math.floor(pageNewTrackPhysicalActivity.dateselectorNumItems/2));
		var int_lag_total = int_lag * int_lagged_items;
    	$("#new_track_physical_activity_days_ant").animate( { "left": -(int_lag_total), "right": int_lag_total }, { duration: int_time, queue: false } );
    	$("#new_track_physical_activity_days_actual").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } );
    	$("#new_track_physical_activity_days_next").animate( { "left": int_lag_total +"px", "right": -(int_lag_total) +"px" }, { duration: int_time, queue: false } );
	},
	
	animateNavbars: function(direction, diff_days)
	{
		var obj_what_date = (diff_days) ? $("#new_track_physical_activity_days_actual .dateselector").dateselector("date").clone().add(diff_days, "day") : null;
		var int_num_days = Math.abs(diff_days);
		var int_lag = ($( window ).width()/pageNewTrackPhysicalActivity.dateselectorNumItems);
		var int_lagged_items = Math.floor(pageNewTrackPhysicalActivity.dateselectorNumItems/2);

		if (direction == "right") {
			var int_left_direction = 1;
			var int_right_direction = -1;
		}
		else if ( direction == "left") {
			var int_left_direction = -1;
			var int_right_direction = 1;
		}
		
		$("#new_track_physical_activity_days_actual").animate( 
			{ 
				"left": int_left_direction * int_lag * int_num_days, 
				"right": int_right_direction * int_lag * int_num_days
			}, 
			{ duration: pageNewTrackPhysicalActivity.animationDuration, queue: false } 
		);
		
		$("#new_track_physical_activity_days_ant").animate( 
			{ 
				"left": -(int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": (int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackPhysicalActivity.animationDuration, queue: false } 
		);
		
		$("#new_track_physical_activity_days_next").animate( 
			{ 
				"left": (int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": -(int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pageNewTrackPhysicalActivity.animationDuration, queue: false } 
		)
		.promise()
		.done(function(){
			if ( !$("#new_track_physical_activity_days_actual .dateselector").dateselector("date", obj_what_date) )
				pageNewTrackPhysicalActivity.resetNavbarsPosition();
		});
	}

};

/* EVENTS */

$( window ).off( ".new_track_physical_activity" )
	.on("resize.new_track_physical_activity", function()
	{
		if(pageNewTrackPhysicalActivity) {
			pageNewTrackPhysicalActivity.adjustSizesOfTracks();
			adjustSizeOfGridFooterActions($("#page_new_track_physical_activity"));
		}
	});

$( document ).off( ".new_track_physical_activity" )

	.on( "pagebeforecreate.new_track_physical_activity", "#page_new_track_physical_activity", function()
	{
		$("#page_new_track_physical_activity #bt_footer_2").addClass("ui-state-disabled");
	})

	.on("pagecreate.new_track_physical_activity", "#page_new_track_physical_activity", function()
    {
		pageNewTrackPhysicalActivity.$page = $(this);
		$( "#app_header" ).toolbar();
    })
    
	.on("pageshow.new_track_physical_activity", "#page_new_track_physical_activity", function()
	{
		pageNewTrackPhysicalActivity.createHeader();
		adjustSizeOfGridFooterActions($(this));
		pageNewTrackPhysicalActivity.getData(currentDate());

		var minDate = currentDate().subtract(15, "days");
        if(minDate.isBefore(Nire.rangeData.minDate)){
            //si por alguna razon el minDate del usuario es el dia siguiente,
            //fuerzo la fecha actual como minima
            if(Nire.rangeData.minDate.isAfter(currentDate()))
                minDate = currentDate();
            else
                minDate = Nire.rangeData.minDate;
        }

		$("#new_track_physical_activity_days_actual .dateselector").dateselector({
			minDate: minDate,
			maxDate: currentDate(),
			change: function(event, newdate) {
				pageNewTrackPhysicalActivity.$page.find(".fdata").text(getDateFormatted(newdate.format("YYYYMMDD")));
				pageNewTrackPhysicalActivity.resetNavbarsPosition(0);
				pageNewTrackPhysicalActivity.initializeNavbarsOverflow();
            },
			fn_date_clicked: function(obj_new_date) {
	    		var obj_from_date = $("#new_track_physical_activity_days_actual .dateselector").dateselector( "date" );
	    		var int_diff_days = obj_new_date.diff(obj_from_date, 'days');
	    		if ( obj_new_date.isAfter(obj_from_date) ){
	    			pageNewTrackPhysicalActivity.animateNavbars("left", int_diff_days);
	        	} else if ( obj_new_date.isBefore(obj_from_date) ){
	        		pageNewTrackPhysicalActivity.animateNavbars("right", int_diff_days);
	        	}
	    		return false;
	    	}
		});
	})

	.on("pageremove.new_track_physical_activity", "#page_new_track_physical_activity", function()
	{
		$( window ).off( ".new_track_physical_activity" );
		$( document ).off( ".new_track_physical_activity" );
		$( 'link[href="css/pageNewTrackPhysicalActivity.css"]' ).remove();
		pageNewTrackPhysicalActivity = null;
	})

	.on("click.new_track_physical_activity", ".indicator_body", pageNewTrackPhysicalActivity.select)
	
	.on("input.new_track_physical_activity", "#newTrack_time_value", pageNewTrackPhysicalActivity.changeTime)
	
	.on("click.new_track_physical_activity", "#bt_footer_2", function()
	{
		pageNewTrackPhysicalActivity.confirm();
	});