/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNutritionDetail.css"/>');

/* VARIABLES */
var pageNutritionDetail = {
		
	$page: null,

    nutrition: {
        id: null,
        section: null,
        type: null,
        date: null
    },

    updateTrack: function()
    {
        Nire.connection.updateTrack(
            this.nutrition.date,
            this.nutrition.id,
            this.nutrition.section,
            this.nutrition.type
        )
        .done(function() { $( "body" ).pagecontainer( "change", "timeline.html" ); });
    },

    getData: function()
    {
    	showLoading();

    	Nire.connection.nutritionDetail( getURLParameter("content") )
    		.done(function(json_response) {
				hideLoading();
				if (json_response.error.code == 0)
					pageNutritionDetail.addContent(json_response.data);
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
    		});
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_nutrition_detail").html());
        
    	pageNutritionDetail.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template() ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },

    addContent: function(json)
    {
        // Gaurdamos la informacion de la comida
        this.nutrition.id = json.body.id;
        this.nutrition.section = "nutrition";
        this.nutrition.type = getURLParameter("type");
        this.nutrition.date = moment(getURLParameter("date"), "YYYYMMDD");

    	$(".img_image").attr('src', this._getFoodImage(json.body));
        $("#page_title").text(gjson_lang["nutrition_meal_" + json.body.type]);
    	$(".div_value").text( formatNumber(json.body.value, json.body.unit) + " " + gjson_lang["unit_" + json.body.unit]);
    	$(".div_duration").text(json.body.duration);
        $(".h3_subtitle").text(json.body.title);

        var pathology = json.body.pathology;
        var pathologies = json.body.pathologies;
        var allergy = json.body.allergy;
        var allergies = json.body.allergies;


        if(((pathologies === undefined) || (pathologies === null) || (pathologies.length == 0)) && ((allergies === undefined) || (allergies === null) || (allergies.length == 0)))
        {
            $("#p_pathologies").text(gjson_lang["nutrition_detail_tab_salud_empty"]);
        }
        else if ((pathologies === undefined) || (pathologies === null) || (pathologies.length == 0))
        {
            $("#p_allergy").text(allergy);
            $("#p_allergies").text(allergies);
        }
        else if ((allergies === undefined) || (allergies === null) || (allergies.length == 0))
        {
            $("#p_pathology").text(pathology);
            $("#p_pathologies").text(pathologies);
        }
        else
        {
            $("#p_pathology").text(pathology);
            $("#p_pathologies").text(pathologies);
            $("#p_allergy").text(allergy);
            $("#p_allergies").text(allergies);
        }

        var preparation = json.body.preparation;
        if((preparation === undefined) || (preparation === null) || (preparation.length == 0))
        {
            $("#p_preparation").text(gjson_lang["nutrition_detail_tab_prep_empty"]);
        }
        else
        {
            $("#p_preparation").text(preparation);
        }

    	pageNutritionDetail.createPage(json.body);

    	pageNutritionDetail.adjustDetailImage();

    	pageNutritionDetail.initializeComponents();

	},

    _getFoodImage: function(data)
    {
        // Si el servidor indica una imagen usamos esa imagen pero si no indica ninguna imagen
        // o detectamos que la imagen no existe, debería usarse una default de acuerdo al grupo
        if(data.image) return data.image;
        return foodGroupImage(data.group);
    },

    createPage: function(ajson_body)
    {
        var _this = this;
        var val_plato = 0;
        $(".div_dificulty").text(gjson_lang["dificulty_"+ajson_body.dificulty]);

        if(ajson_body.valoration)
            val_plato = ajson_body.valoration;
        else
            val_plato = 0;

        $(".div_valoration img").attr("src", "img/others/ic_star_"+val_plato+".png").css("height","20px");

        var $template = $("#template-indicators_nutrition_detail").html();
        var template_indicators = Handlebars.compile($("#template-indicators_nutrition_detail").html());
        var clase = ["ui-block-a", "ui-block-c"];
        var clase2 = ["ui-block-b", "ui-block-d"];

        var indicators = [];
        $.each(ajson_body.indicators, function(i) {
            // Estos son los datos que requiere el template de Handlebars
            var datos_item =  {
                clase: clase[i % clase.length],
                clase2: clase2[i % clase2.length],
                type: this.type,
                quantity: formatNumber(this.quantity, this.unit),
                title: gjson_lang["nutrition_" + this.type],
                unit: gjson_lang["unit_" + this.unit],
                image: "img/indicators/ic_"+ this.type +".png"
            };


            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var indicator = $(template_indicators(datos_item)).data("info", this);

            // Agregamos el indicador a la lista de indicadores que se mostraran
            indicators.push( indicator );
        });

        // Borramos los indicadores anteriores y agregamos los nuevos
        $(".div_contenedor_indicators").empty().append(indicators).trigger( "updatelayout" );

        indicatorsImageErrorControl();

        var template_ingredients = Handlebars.compile($("#template-ingredients_nutrition_detail").html());
        var ingredients = [];
        if(ajson_body.ingredients.length == 0)
        {
            ingredients.push(gjson_lang["nutrition_detail_tab_ingr_empty"])
        }
        else
        {
            $.each(ajson_body.ingredients, function(i) {
                // Estos son los datos que requiere el template de Handlebars
                var datos_item =  {
                    ingredient: this.ingredient,
                    number: formatNumber(this.number, this.unit),
                    unit: this.unit
                };

                // Generamos los elementos del DOM y le asociamos al información de este elemento
                // para despues poder recuperar toda la información del servidor
                var ingredient = $(template_ingredients(datos_item)).data("info", this);

                // Agregamos el indicador a la lista de indicadores que se mostraran
                ingredients.push( ingredient );
            });
        }

        // Borramos los indicadores anteriores y agregamos los nuevos
        $(".div_contenido_ingredientes").empty().append(ingredients).trigger( "updatelayout" );

        tracksImageErrorControl();
	},

	initializeComponents: function()
	{
        $("#nutrition_detail_tabs").tabs();
	},

	adjustDetailImage: function()
	{
    	var $detail_image = $("#page_nutrition_detail").find(".div_detail_image");
    	$detail_image.height($detail_image.width()*2/3);
    }

};

/* EVENTS */

$( window ).off( ".nutrition_detail")
	.on( "resize.nutrition_detail", function()
	{
		if (pageNutritionDetail) {
			pageNutritionDetail.adjustDetailImage();
			adjustSizeOfGridFooterActions($("#page_nutrition_detail"));
		}
	});

$( document ).off( ".nutrition_detail" )
	
	.on("pagecreate.nutrition_detail", "#page_nutrition_detail", function()
    {
		pageNutritionDetail.$page = $(this);
    })

    .on("pagecontainershow.nutrition_detail", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_nutrition_detail") {
	    	pageNutritionDetail.createHeader();
	    	adjustSizeOfGridFooterActions($("#page_nutrition_detail"));
    	}
    })
    
    .on( "pagecontainerchange.nutrition_detail", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_nutrition_detail") {

    		pageNutritionDetail.getData($(this));
    		pageNutritionDetail.adjustDetailImage();
    		
    	} else if ( ui.prevPage.attr("id") == "page_nutrition_detail" && ui.toPage.attr("id") != "page_nutrition_detail" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {
			
    		$("#page_nutrition_detail").trigger("pageremove");
    		$("#page_nutrition_detail").remove();
		}
	})

    .on("pageremove.nutrition_detail", "#page_nutrition_detail", function(event, ui)
	{
    	$( window ).off( ".nutrition_detail" );
    	$( document ).off( ".nutrition_detail" );
		$( 'link[href="css/pageNutritionDetail.css"]' ).remove();
		pageNutritionDetail = null;
	})
	
	.on("click.nutrition_detail", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pageNutritionDetail.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});