/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNutritionFood.css"/>');

/* VARIABLES */
var pageNutritionFood = {

	$page : null,

    getData : function($page, day)
    {
    	showLoading();

    	pageNutritionFood.$page = $page;    	

		$.ajax({
			  type: "GET",
			  url: URL_NUTRITION_FOOD,
		      dataType: JSON_TYPE,
		      success: function (json_response)
		      {
		    	  if (json_response.error.code == 0)
		    		  pageNutritionFood.createPage(json_response.data.body);
		    	  else
		    		  showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
		      },
		      error: function(err) {
		    	  showAlert("Error:"+ err.status +":" + err.statusText, null, gjson_lang.error, gjson_lang.accept);
	    	  },
	    	  complete: function () {
	    		  hideLoading();
	    	  }
		});
    },

    createHeader : function()
    {
    	var template = Handlebars.compile($("#template-header").html())

        $( "#app_header" ).html( template({ title: gjson_lang["nutrition_food_title"] }) );
    	$( "#app_header" ).toolbar( "refresh" );
    	$( "#app_header" ).show();
    	$( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();
    },

    createPage : function(ajson)
    {
    	var str_html_recom="";
    	var str_html_notRecom="";
        var column="";
        $("#ul_recommended_food_list").html('');
    	$("#ul_not_recommended_food_list").html('');

        /*str_html_recom += '<li data-icon="false"><div id= "div_nutrition_food_recommended"> ' +gjson_lang["nutrition_food_recommended"]+ '</div></li>';
        $("#ul_recommended_food_list").html(str_html_recom);

        str_html_notRecom += '<li data-icon="false"><div id= "div_nutrition_food_not_recommended"> ' +gjson_lang["nutrition_food_not_recommended"]+ '</div></li>';
        $("#ul_not_recommended_food_list").html(str_html_notRecom);*/

    	for (i=0, len=ajson.food.length; i < len ; i++)
    	{
            if(ajson.food[i].recommended == 1)
            {
                str_html_recom += '<li data-icon="false"><div id= "' +ajson.food[i].id+ '"> ' +ajson.food[i].title+ '</div></li>';
                $("#ul_recommended_food_list").html(str_html_recom);
            }
            else if(ajson.food[i].recommended == 0)
            {
                str_html_notRecom += '<li data-icon="false"><div id= "' +ajson.food[i].id+ '"> ' +ajson.food[i].title+ '</div></li>';
                $("#ul_not_recommended_food_list").html(str_html_notRecom);
            }

    	}

        $("#ul_recommended_food_list").listview('refresh');
    	$("#ul_not_recommended_food_list").listview('refresh');
    }

};

/* EVENTS */

$( window ).off( ".nutrition_food")
	.on( "resize.nutrition_food", function()
	{
		if (pageNutritionFood) {
			adjustSizeOfGridFooterActions($("#page_nutrition_food"));
		}
	});

$( document ).off( ".nutrition_food" )

	.on("pagecreate.nutrition_food", "#page_nutrition_food", function()
    {
		$( "#app_header" ).toolbar();
    })
    
	.on("pageshow.nutrition_food", "#page_nutrition_food", function()
	{
		pageNutritionFood.createHeader();
		adjustSizeOfGridFooterActions($(this));
		pageNutritionFood.getData();
	})

	.on("pageremove.nutrition_food", "#page_nutrition_food", function()
	{
		$( window ).off( ".nutrition_food" );
		$( document ).off( ".nutrition_food" );
		$( 'link[href="css/pageNutritionFood.css"]' ).remove();
		pageNutritionFood = null;
	});