/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePersonalAssistant.css"/>');

/* VARIABLES */

var pagePersonalAssistant =
{
	$page: null,
    pageId: null,
    $myScroller: null,
    $mySlider: null,
	animationDuration: 1000,
    $indicators: null,
    max_num_indicators: 4,
    cards: [],
	
    getData: function()
    {
    	showLoading();
        var seccion = getURLParameter("seccion");
    	
    	Nire.connection.personalAssistant(seccion)
    		.done(function(json_response) {
				if (json_response.error.code == 0)
				{
				  	pagePersonalAssistant.addContent(json_response.data);
				}
				else
                {
                    $("#btn_personal_assistant_list").hide();
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
                }
    		})
            .fail(function() {
                $("#btn_personal_assistant_list").hide();
            })
    		.always(function() {
    			hideLoading();
    		});
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_personal_assistant").html())
        
        pagePersonalAssistant.$page.find( "#app_header" ).remove();

        var titleCode = getURLParameter("title") ? getURLParameter("title") : "personal_assistant_title";
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang[titleCode] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },

    addContent: function(data)
    {
        var int_card_pos = 0;
        var selected_card_id = getURLParameter("card");
        
        if ( selected_card_id )
        {
            $.each(data.cards, function(i, item) {
                if ( item.id === selected_card_id )
                {
                    int_card_pos = i;
                    return;
                }
            });
        }

    	pagePersonalAssistant.createCards(data.cards);

        if ( data.cards.length > 0 )
            setTimeout(function(){
                pagePersonalAssistant.$mySlider.scrollToPage(int_card_pos, pagePersonalAssistant.animationDuration);
            }, 100);
        else
            $("#btn_personal_assistant_list").hide();
	},
	
	createCards: function(ajson_cards)
	{
		var template_card = Handlebars.compile($("#template-personal_assistant_card").html());

        this.cards = ajson_cards;
        var cards = [];

        var cards_indicators = [];
        var cards_index = [];

        // Generamos el elemento que informa de la existencia de más indicadores a la izquierda
        cards_indicators.push("<div class=\"more_dotties_left\"></div>");

        $.each(ajson_cards, function(i, item)
        {
            var str_url_params = "";
            var str_card_link_class = null;
            var str_card_link_url = null;
            var str_card_link_text = null;

            if ( item.card_link )
            {
                str_card_link_class = "color_txt_"+ item.card_section;
                str_card_link_url = item.card_link.url;
                str_card_link_text = item.card_link.text;
            }
        	 // Estos son los datos que requiere el template de Handlebars
            var datos_item =  {
                card_section_class: "bg_"+ item.card_section,
                section_title: item.section_title,
                card_title: item.card_title,
                html_content: item.html_content,
                card_link_class: str_card_link_class,
                card_link_url: str_card_link_url,
                card_link_text: str_card_link_text
            };
            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var $card = $(template_card(datos_item)).jqmData("nire", item);
            cards.push( $card );

            // Si no hemos pasados el límite de indicadores de fichas agregamos lo generamos
            if ( i < pagePersonalAssistant.max_num_indicators )
                cards_indicators.push("<div class=\"dotty\"></div>");

            // Generamos el elemento de la lista del índice
            cards_index.push( "<li class=\"card_index\">"+ datos_item.card_title +"</li>");
        });
        
        // Establecemos las fichas generadas como nuevo contenido
        $("#personal_assistant_iscroll_slider").html(cards).trigger("updatelayout");

        if ( cards.length > 0 )
        {
            // Generamos el elemento que informa de la existencia de más indicadores a la derecha
            cards_indicators.push("<div class=\"more_dotties_right\"></div>");

            // Generamos los indicadores de fichas 
            pagePersonalAssistant.$indicators.html(cards_indicators);
            $.mobile.resetActivePageHeight();

            // Generamos el índice de fichas
            $("#personal_assistant_index_scroller ul").html(cards_index);

            // Initialize indicators
            pagePersonalAssistant.virtual_max_index = pagePersonalAssistant.$page.find("#personal_assistant_iscroll_slider").children().length - pagePersonalAssistant.max_num_indicators;
            pagePersonalAssistant.adjustSizeOfSliderIndicators();

            // Initialize twis slider
            pagePersonalAssistant.adjustSizeOfSliderPages();
            pagePersonalAssistant.$mySlider = new TWIS('#personal_assistant_iscroll_wrapper', 
                                                { 
                                                    bounce: false,
                                                    onScrollEnd: function() {
                                                        var previous_selected = pagePersonalAssistant.$indicators.find(".dotty.selected").index();
                                                        // Establecer todos los indicadores como no seleccionados
                                                        pagePersonalAssistant.$indicators.find(".dotty").removeClass('selected');
                                                        // Comprobar indicadores desplazados
                                                        pagePersonalAssistant.updateIndicators(previous_selected, this.currentPage);
                                                        Nire.analytics.page("coach_card_" + pagePersonalAssistant.cards[this.currentPage].id );
                                                    }
                                                });

            // Initialize twis scroller
            //pagePersonalAssistant.adjustSizeOfIndexScroller();
            pagePersonalAssistant.$myScroller = new IScroll('#personal_assistant_index_wrapper',
                                                {
                                                    bounce: false,
                                                    preventDefaultException: { tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT|LI)$/ } 
                                                });
        }
	},

    updateIndicators: function(previous_selected, selected_card_index)
    {
        if ( pagePersonalAssistant.max_num_indicators > selected_card_index 
                && ( pagePersonalAssistant.$indicators.find(".more_dotties_left").css("visibility") == "hidden" || previous_selected < 2 ) )
        {
             // Establecer el indicador de página actual como seleccionado en la primera franja de indicadores
            pagePersonalAssistant.$indicators.find(".dotty:eq("+ selected_card_index +")").addClass('selected');
            pagePersonalAssistant.$indicators.find(".more_dotties_left").css("visibility", "hidden");
            if ( pagePersonalAssistant.virtual_max_index > 0)
                pagePersonalAssistant.$indicators.find(".more_dotties_right").css("visibility", "visible");
        }
        else if ( pagePersonalAssistant.virtual_max_index <= selected_card_index )
        {
            // Establecer el indicador de página actual como seleccionado en la última franja de indicadores
            pagePersonalAssistant.$indicators.find(".dotty:eq("+ (selected_card_index-pagePersonalAssistant.virtual_max_index) +")").addClass('selected');
            pagePersonalAssistant.$indicators.find(".more_dotties_left").css("visibility", "visible");
            pagePersonalAssistant.$indicators.find(".more_dotties_right").css("visibility", "hidden");
        }
        else
        {
            var virtual_selected_index = selected_card_index % pagePersonalAssistant.max_num_indicators;
            // Establecer el indicador de página actual como seleccionado en una franja intermedia de indicadores
            pagePersonalAssistant.$indicators.find(".dotty:eq("+ virtual_selected_index +")").addClass('selected');
            pagePersonalAssistant.$indicators.find(".more_dotties_left").css("visibility", "visible");
            pagePersonalAssistant.$indicators.find(".more_dotties_right").css("visibility", "visible");
        }
    },

    adjustSizeOfSliderPages: function()
    {        
        var $slider = pagePersonalAssistant.$page.find("#personal_assistant_iscroll_slider");
        var $children_count = $slider.children().length;
        $slider.width( $(window).width() * $children_count );
        $slider.find(" .iscroll_page").width ($(window).width() - 10 );
    },

    adjustSizeOfSliderIndicators: function()
    {
        if ( pagePersonalAssistant.$indicators )
            pagePersonalAssistant.$indicators.width( pagePersonalAssistant.$indicators.children().length +"em");
    },

    adjustSizeOfIndexScroller: function()
    {
        var $header = $("#app_header");
        var header_height = $header.hasClass("ui-header-fixed") ? $header.outerHeight() - 1 : $header.outerHeight();
        $("#personal_assistant_index_wrapper").css("top", header_height);
    },

    adjustSizeOfContent: function()
    {
        var $current_content = pagePersonalAssistant.$page.find("div[role='main'] .content_wrapper");
            
        var int_content_height = getContentHeightToFillScreen(
                                $("#app_header"),
                                $current_content,
                                null
                            );

        $current_content.height(int_content_height).trigger("updatelayout");
    }
};

/* EVENTS */

$( window ).off( ".personal_assistant" )
    .on("resize.personal_assistant", function()
    {
    	if( pagePersonalAssistant )
        {
            var currentPage = pagePersonalAssistant.$mySlider.getCurrentPage();

            pagePersonalAssistant.adjustSizeOfContent();
            //pagePersonalAssistant.adjustSizeOfIndexScroller();
            pagePersonalAssistant.adjustSizeOfSliderIndicators();
    		pagePersonalAssistant.adjustSizeOfSliderPages();

            pagePersonalAssistant.$myScroller.refresh();
            pagePersonalAssistant.$mySlider.refresh();

            pagePersonalAssistant.$mySlider.scrollToPage(currentPage);
    	}
    });

$( document ).off( ".personal_assistant" )

	.on( "pagecreate.personal_assistant", "#page_personal_assistant", function()
    {
        pagePersonalAssistant.$page = $(this);
    })

    .on("pagecontainershow.personal_assistant", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_personal_assistant")
        {
	    	pagePersonalAssistant.createHeader();
            pagePersonalAssistant.$indicators = $("#personal_assistant_indicators");
            pagePersonalAssistant.adjustSizeOfContent();
    	}
    })
    
    .on( "pagecontainerchange.personal_assistant", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_personal_assistant")
        {
            var int_num_page = $("div[id=page_personal_assistant]").length;
            if ( int_num_page > 1 )
                // Elimino la primera página page_personal_assistant del DOM que es la que abandonamos por navegación
                $("#page_personal_assistant").remove();

    		pagePersonalAssistant.getData();
        }
        else if ( ui.prevPage.attr("id") == "page_personal_assistant" && ui.toPage.attr("id") != "page_personal_assistant" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" )
        {
			$("#page_personal_assistant").trigger( "pageremove" );
			$("#page_personal_assistant").remove();
		}
	})

    .on("pageremove.personal_assistant", "#page_personal_assistant", function()
	{
    	$( window ).off( ".personal_assistant" );
    	$( document ).off( ".personal_assistant" );
		$( 'link[href="css/pagePersonalAssistant.css"]' ).remove();
		pagePersonalAssistant = null;
	})
    
    .on("click.personal_assistant", "#btn_personal_assistant_list", function(event)
	{
        event.preventDefault();

        var $index_wrapper = $("#personal_assistant_index_wrapper");
		
        if ( $index_wrapper.css("display") == 'none' )
            $index_wrapper.slideDown(600, function(){
                $(this).trigger("updatelayout");
                pagePersonalAssistant.$myScroller.refresh();
            });
        else
            $index_wrapper.slideUp(200, function(){
                $(this).trigger("updatelayout");
                pagePersonalAssistant.$myScroller.refresh();
            });        

        return false;
	})

    .on("click.personal_assistant", ".card_index", function(event)
    {
        event.preventDefault();

        $("#btn_personal_assistant_list").click();

        pagePersonalAssistant.$mySlider.scrollToPage($(this).index(), pagePersonalAssistant.animationDuration);

        return false;
    })

    .on( "touchmove.personal_assistant", function(event)
    {
       event.preventDefault();
       return false;
    });