/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePhysicalActivityDetail.css"/>');

/* VARIABLES */
var pagePhysicalActivityDetail = {
		
	$page: null,

    getData: function($page)
    {
        showLoading();

        Nire.connection.physicalActivityDetail( getURLParameter("content"), getURLParameter("date") )
            .done(function(json_response) {
                hideLoading();
                if (json_response.error.code == 0)
                    pagePhysicalActivityDetail.addContent(json_response.data);
                else
                	showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
            });
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_physical_activity_detail").html());
        
    	pagePhysicalActivityDetail.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template() ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },
    

    addContent: function(json)
    {
    	if (json.body && json.body.type)
    		$("#page_title").text(gjson_lang["physical_activity_type_" + json.body.type.toLowerCase()]);

        $("#physical_activity_steps").prop("href", "physicalActivitySteps.html?content=" + getURLParameter("content") + "&date=" + getURLParameter("date"))
        $(".img_image").attr('src', this._getExerciseImage(json.body));
        $(".h3_subtitle").text(json.body.title);
        $(".p_exercised").text(json.body.exercised);
        $(".p_information").text(json.body.information);
        $(".div_time").text(json.body.duration);
        $(".div_location").text(json.body.location);
        $(".p_steps").text("("+ json.body.steps +")");
        if ( !json.body.steps )
        	$("#physical_activity_steps").addClass("ui-state-disabled");
        $("#p_advices").html(json.body.advices);
        $("#p_health").html(json.body.health);
        $(".div_dificulty").text(gjson_lang["dificulty_"+json.body.dificulty]);
        
        pagePhysicalActivityDetail.createPage(json.body);
        
        //pagePhysicalActivityDetail.adjustDetailImage();
        
        pagePhysicalActivityDetail.initializeComponents();
    },

    _getExerciseImage: function(data)
    {
        // Si el servidor indica una imagen usamos esa imagen pero si no indica ninguna imagen
        // o detectamos que la imagen no existe, debería usarse una default de acuerdo al type
        if(data.image) return data.image;
        return exerciseGroupImage(data.type?data.type:"");
    },

    createPage: function(ajson_body)
    {
        var str_html = "";
        var clase="";

        $(".div_contenido_guides").empty();
        if(ajson_body.guides.length == 0) {
            $(".div_contenido_guides").html("<p>" + gjson_lang["empty_activity_guideline"] + "</p>");
        } else {
            for (var i=0, len=ajson_body.guides.length; i < len; i++)
            {
                str_html = "";
                str_html += '<div class="ui-block-a">'
                         +      '<p>'+ ajson_body.guides[i].series +'</p>'
                         +  '</div>'
                         +  '<div class="ui-block-b">'
                         +      '<p>'+ ajson_body.guides[i].repetitions +'</p>'
                         +  '</div>'
                         +  '<div class="ui-block-c">'
                         +      '<p>'+ ajson_body.guides[i].rest +'</p>'
                         +  '</div>';
                $(".div_contenido_guides").append(str_html);
            }
        }
        $(".div_contenido_guides").trigger( "updatelayout" );

        tracksImageErrorControl();
    },
    
    adjustDetailImage: function()
    {
    	var $detail_image = $("#page_physical_activity_detail").find(".div_detail_image");
    	
    	console.log($( window ).width());
    	$detail_image.height($( window ).width()*2/3);
    },

    initializeComponents: function()
    {
        $("#physicalActivity_detail_tabs").tabs();
    },

    updateTrack: function()
    {
        var date = moment(getURLParameter("date"), "YYYYMMDD")
        Nire.connection.updateTrack(date, getURLParameter("content"), 'physicalActivity', "")        
        .done(function() { $( "body" ).pagecontainer( "change", "timeline.html" ); })
    },

};

/* EVENTS */
$( window ).off( ".physical_activity_detail")
	.on( "resize.physical_activity_detail", function()
	{
		if (pagePhysicalActivityDetail) {
			pagePhysicalActivityDetail.adjustDetailImage();
			adjustSizeOfGridFooterActions($("#page_physical_activity_detail"));
		}
	});

$( document ).off( ".physical_activity_detail" )

	.on("pagecreate.physical_activity_detail", "#page_physical_activity_detail", function()
    {
		pagePhysicalActivityDetail.$page = $(this);
		pagePhysicalActivityDetail.adjustDetailImage();
    })

    .on("pagecontainershow.physical_activity_detail", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_physical_activity_detail") {
	    	pagePhysicalActivityDetail.createHeader();
	    	adjustSizeOfGridFooterActions($("#page_physical_activity_detail"));
    	}
    })
    
    .on( "pagecontainerchange.physical_activity_detail", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_physical_activity_detail") {
    		
    		pagePhysicalActivityDetail.getData(pagePhysicalActivityDetail.$page);
    		pagePhysicalActivityDetail.adjustDetailImage();
    		
    	} else if ( ui.prevPage.attr("id") == "page_physical_activity_detail" && ui.toPage.attr("id") != "page_physical_activity_detail" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {
    		
			$("#page_physical_activity_detail").trigger( "pageremove" );
			$("#page_physical_activity_detail").remove();
		}
	})  
    
	.on("pageremove.physical_activity_detail", "#page_physical_activity_detail", function()
	{
		$( window ).off( ".physical_activity_detail" );
		$( document ).off( ".physical_activity_detail" );
		$( 'link[href="css/pagePhysicalActivityDetail.css"]' ).remove();
        pagePhysicalActivityDetail = null;
	})
	
	.on("click.physical_activity_detail", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pagePhysicalActivityDetail.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});