/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePhysicalActivityHelp.css"/>');

/* VARIABLES */
var pagePhysicalActivityHelp = {

    getData: function()
    {
    	showLoading();
    	
    	Nire.connection.physicalActivityHelp()
            .done(function(json_response) {
                hideLoading();
                if (json_response.error.code == 0)
                      pagePhysicalActivityHelp.createPage(json_response.data.body);
                  else
                	  showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
            });
    },

    createHeader: function()
    {
        var template = Handlebars.compile($("#template-header").html());
        
        $( "#app_header" ).html( template({ title: gjson_lang["help_title"] }) );
        $( "#app_header" ).toolbar( "refresh" );
        $( "#app_header" ).show();
        $( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();  
    },

    createPage: function(ajson)
    {
        var template_indicator = Handlebars.compile($("#template-faq").html());

        var faqs = [];
        $.each(ajson.faq, function(i) {
            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var faq = $(template_indicator(this))

            // Agregamos el indicador a la lista de indicadores que se mostraran
            faqs.push( faq );
        });

        // Borramos los indicadores anteriores y agregamos los nuevos
        $("#ul_physical_activity_faq_list").empty().append(faqs).trigger( "updatelayout" );

        $("#ul_physical_activity_faq_list").listview('refresh');

    }

};

/* EVENTS */

$( document ).off( ".physical_activity_help" )

	.on("pagecreate.physical_activity_help", "#page_physical_activity_help", function()
    {
		$( "#app_header" ).toolbar();
    })

	.on("pageshow.physical_activity_help", "#page_physical_activity_help", function()
	{
		pagePhysicalActivityHelp.createHeader();
		pagePhysicalActivityHelp.getData();
	})

	.on("pageremove.physical_activity_help", "#page_physical_activity_help", function()
	{
		$( document ).off( ".physical_activity_help" );
		$( 'link[href="css/pagePhysicalActivityHelp.css"]' ).remove();
		pagePhysicalActivityHelp = null;
	});