/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePhysicalActivitySteps.css"/>');

/* VARIABLES */
var pagePhysicalActivitySteps = {

    $page: null,
    step: 0,
    arr_steps: null,
    exerciseImage : null,

    getData: function($page)
    {
        showLoading();

        pagePhysicalActivitySteps.$page = $page;

        Nire.connection.physicalActivitySteps( getURLParameter("content") )
          .done(function(json_response) {
            hideLoading();
            if (json_response.error.code == 0)
                pagePhysicalActivitySteps.addContent(json_response.data);
            else
            	showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
          })
    },

    createHeader: function()
    {
        var template = Handlebars.compile($("#template-header_physical_activity_steps").html());
                
        try {
        	$( "#app_header" ).html( template() ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent: function(json)
    {
        pagePhysicalActivitySteps.$page.find(".physical_activity_title").text(json.body.title);
        pagePhysicalActivitySteps.respawnPage();
        pagePhysicalActivitySteps.arr_steps = json.body.steps;
        pagePhysicalActivitySteps.exerciseImage = json.body.image;
        pagePhysicalActivitySteps.displayStep(json.body.steps);

    },

    displayStep: function(ajson_steps, step)
    {
        if(step === undefined)
        {
            step = 0;
        }
        var stepNumber = i18n('physical_activity_detail_steps_stepn') + ' '+ ajson_steps[step].id;
        pagePhysicalActivitySteps.step = step;
        pagePhysicalActivitySteps.$page.find(".physical_activity_step").text(stepNumber);
        pagePhysicalActivitySteps.$page.find(".physical_activity_description p").text(ajson_steps[step].description);

        this._loadExerciseImage(ajson_steps[step]);
    },

    _replaceStepImage: function( image ) {
        pagePhysicalActivitySteps.$page.find(".img_image").attr("src", image)
    },

    _loadExerciseImage: function(step) {
        var self = this;
        if(step.image) {
            tryImage(step.image)
                .done( self._replaceStepImage )
                .fail( function() {
                    tryImage(self.exerciseImage).done( self._replaceStepImage );
                } );
        }
        else if(self.exerciseImage) tryImage(this.exerciseImage).done( self._replaceStepImage );
    },

    stepChange: function(step, stepCourse)
    {
        if( stepCourse === "forward" ){
            step++;
        }
        else if( stepCourse === "backward" ){
            step--;
        }

        if( step > pagePhysicalActivitySteps.arr_steps.length - 1 ){
            step = pagePhysicalActivitySteps.arr_steps.length - 1;
        }
        else if( step < 0 ){
            step = 0;
        }

        pagePhysicalActivitySteps.step = step;
        pagePhysicalActivitySteps.displayStep(pagePhysicalActivitySteps.arr_steps, step);
    },

    respawnPage: function()
    {
        pagePhysicalActivitySteps.$page.find(".ui-tabs").tabs();
    }
};

/* EVENTS */

$( document ).off(".physical_activity_steps" )

	.on("pagecreate.physical_activity_steps", "#page_physical_activity_steps", function()
    {
		$( "#app_header" ).toolbar();
    })
    
    .on("pageshow.physical_activity_steps", "#page_physical_activity_steps", function()
    {
    	pagePhysicalActivitySteps.createHeader();
        pagePhysicalActivitySteps.getData($(this));
    })
    
    .on("pageremove.physical_activity_steps", "#page_physical_activity_steps", function()
    {
    	$( window ).off( ".physical_activity_steps" );
    	$( document ).off(".physical_activity_steps" );
        $( 'link[href="css/pagePhysicalActivitySteps.css"]' ).remove();
        pagePhysicalActivitySteps = null;
    })
    
    .on( "swipe.physical_activity_steps", "#page_physical_activity_steps", function(event)
    {
        $( this ).swipe({
            swipeLeft: function ()
            {
                pagePhysicalActivitySteps.stepChange(pagePhysicalActivitySteps.step, "forward");
            },
            swipeRight: function ()
            {
                pagePhysicalActivitySteps.stepChange(pagePhysicalActivitySteps.step, "backward");
            }
        });

    })
    
    .on("click.physical_activity_steps", ".physical_activity_stepcourse", function()
    {
    	var step_course = $(this).data("stepcourse");
        pagePhysicalActivitySteps.stepChange(pagePhysicalActivitySteps.step, step_course);
    });
