/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePhysicalActivityWeekly.css"/>');

/* VARIABLES */

var pagePhysicalActivityWeekly = {
	
	$page: null,
	animationDuration: 500,
	dateselectorNumItems: 7,
	chart2: null,

    getData: function( date )
    {
    	showLoading();
    	Nire.connection.physicalActivityWeekly(date)
    		.done(function(json_response) {
    			hideLoading();
				if (json_response.error.code == 0)
				{
				  pagePhysicalActivityWeekly.addContent(json_response.data, date);
				}
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
    		});
    },

    createHeader: function()
    {
    	var template = Handlebars.compile($("#template-header_physical_activity_weekly").html())
        
        pagePhysicalActivityWeekly.$page.find( "#app_header" ).remove();
        
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["physical_activity_home_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
        
	    showNotificationUpdate();
    },

    addContent: function(data, date)
    {
    	pagePhysicalActivityWeekly.resetEmptyContent();
    	
        if (data.body.tracks.length > 0)
        {
        	if (data.body.title != null)
        		$(".div_indicators2_general_title h3").text(data.body.title);
        	
        	$("#physical_activity_weekly_chart2 .p_chart2_leyend").text( Math.round(data.body.quantityTotal) +" "+  gjson_lang["unit_kcal"] );
            $("#physical_activity_weekly_chart2 .p_chart2_leyend_time").text( data.body.totalDuration +" "+ gjson_lang[data.body.durationUnit] );
            
	        pagePhysicalActivityWeekly.setquantitiesDone(data.body.indicators, data.body.quantityDone, data.body.quantityTotal, data.body.unit, data.body.percent);
	        
	        pagePhysicalActivityWeekly.createTracks2(data.body.tracks);
        }
        else
        {
        	pagePhysicalActivityWeekly.setEmptyContent();
        }
                
        if (!pagePhysicalActivityWeekly.prepareTracksForAnimation())
        {
    		pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition(0);
    	}
        else
        {
    		pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition(null, 2, function(){
    			$.mobile.silentScroll(0);
    			setTimeout(function(){
                    var img_url = "img/backgrounds/bg_physicalActivity_" + date.isoWeekday() + ".jpg";
                    var img_tag = new Image();
                    img_tag.onload = function() {
                        $( "#physical_activity_weekly_img_background" ).css("background-image", "url("+ img_url +")").trigger("updatelayout");
                        $(this).remove();
                    };
                    img_tag.src = img_url;
    			}, 500);
    		});
    	}
	},
	
	resetEmptyContent: function()
	{
		$("#physical_activity_weekly_empty_content").css("display", "none");
		$("#physical_activity_weekly_data_content").show();
	},
	
	setEmptyContent: function()
	{
		$("#physical_activity_weekly_data_content").css("display", "none");
		$("#physical_activity_weekly_empty_content").show().trigger( "updatelayout" );
		
		var $current_content = pagePhysicalActivityWeekly.$page.find(".ui-content");
		var int_content_height = getContentHeightToFillScreen(
									$("#app_header"),
									$current_content,
									pagePhysicalActivityWeekly.$page.find(".ui-footer")
								);
		
		var int_animated_margins = parseInt($("#physical_activity_weekly_animated_content").css("margin-top")) + parseInt($("#physical_activity_weekly_animated_content").css("margin-bottom"))
									+ parseInt($("#physical_activity_weekly_animated_content").css("padding-top")) + parseInt($("#physical_activity_weekly_animated_content").css("padding-bottom"));
		
		$("#physical_activity_weekly_empty_content img")
			.one("load", function(){
				
				$("#physical_activity_weekly_empty_content .centered_in_empty_content")
				.css("margin-top", Math.round( (int_content_height - int_animated_margins - $("#physical_activity_weekly_track_days_actual").outerHeight() - $("#physical_activity_weekly_empty_content .centered_in_empty_content").outerHeight())/2) +"px");
			})
			.each(function(){
				if(this.complete)
					$(this).trigger("load");
			});
	},

	createIndicators: function(ajson_indicators)
	{
        var template_indicator = Handlebars.compile($("#template-indicators_physical_activity_weekly").html());

        var indicators = [];
        
        $.each(ajson_indicators, function(i) {
            // Estos son los datos que requiere el template de Handlebars
//        	console.log("quantity: "+ this.quantity);
//        	console.log("precent: "+ this.precent);
//        	console.log("quantity: "+ this.quantity);

            var datos_item =  {
                type: this.type,
                quantity: formatNumber(this.quantity, this.quantityUnit),
                percentage: this.percent ? Math.round(this.percent)+"%" : "0%",
                title: gjson_lang["physical_activity_type_" + this.type],
                unit: gjson_lang["unit_" + this.quantityUnit],
                image: "img/indicators/ic_"+ this.type +".png",
//                day_percentage: Math.round(this.quantity * 100 / day_quantity),
            };

            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var indicator = $(template_indicator(datos_item)).data("info", this)

            // Agregamos el indicador a la lista de indicadores que se mostraran
            indicators.push( indicator );
        });

        // Borramos los indicadores anteriores y agregamos los nuevos
        $("#page_physical_activity_weekly .table_indicators2_wrapper").html(indicators).trigger( "updatelayout" );

        indicatorsImageErrorControl("physicalActivity");
	},

    createTracks2: function(ajson_tracks)
    {
        var template_type_wrapper_title = Handlebars.compile($("#template-physical_activity_weekly_type_wrapper_title").html());
		var template_type_wrapper_item = Handlebars.compile($("#template-physical_activity_weekly_type_wrapper_item").html());
		
		var date = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date").format("YYYYMMDD");
		var str_type = null;
        var tracks = [];        

        $.each(ajson_tracks, function(i, item) {
        	
        	var datos_item = null;
        	
        	//if (item.type != str_type)
        	//{
        		// Estos son los datos que requiere el template de Handlebars
            //	datos_item =  {
            //		title: gjson_lang["physical_activity_type_"+ item.type]
            //	};
            	// Generamos los elementos del DOM y le asociamos al información de este elemento
                // para despues poder recuperar toda la información del servidor
            //    var type_wrapper_title = $(template_type_wrapper_title(datos_item));

                // Agregamos el track a la lista de tracks que se mostrarán
            //    tracks.push( type_wrapper_title );
                
            //    str_type = item.type;
        	//}

            var icon_class = item.sel ? "ui-icon-checked_physical_activity" : "ui-icon-unchecked";
            	
            var url_string = "physicalActivityDetail.html";
            if(isNaN(item.id))
                url_string = "#";
            var str_url_params = "?content="+ encodeURIComponent(item.id) + "&date=" + encodeURIComponent(date) + "&type=" + encodeURIComponent(item.type);
            
            var duration = item.duration? item.duration +" "+ gjson_lang[item.unit] : ""
            var calories = item.gastoCalorico != "0"? item.gastoCalorico + " " + gjson_lang["unit_kcal"] : ""

            if(item.source)
                item.title += " (via " + item.source + ")"
        	
            // Estos son los datos que requiere el template de Handlebars
            datos_item =  {
                url_params: str_url_params,
                img_src: "#",
                title: item.title,
                quantity: item.quantity,
                type: item.type ? "("+ item.type.capitalize() +")" : null,
                icon_class: icon_class,
                calories: calories,
                duration: duration,
                url_string: url_string
            };
            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var type_wrapper_item = $(template_type_wrapper_item(datos_item)).data("nire", item);
        	
            tracks.push( type_wrapper_item );
        });

        // Borramos los indicadores anteriores y agregamos los nuevos
        $("#physical_activity_weekly_track2_wrapper").html(tracks).listview( "refresh" );
        $("#physical_activity_weekly_track2_wrapper li:jqmData(role=list-divider)").prev().addClass("ui-last-child");
        
        tracks2ImageErrorControl();
        
        $("#physical_activity_weekly_track2_wrapper .track2_item").each(function()
        {
        	var data = $(this).jqmData("nire");
        	
        	if ( data.id.toLowerCase().indexOf("p") === 0 )
        		var str_image_src = "img/tracks/ic_physicalActivity_"+ data.tipo;
        	else
        		var str_image_src = data.image;
        	
        	$(this).find(".default_track2_image").attr("src", str_image_src);
        	
        });
	},

	drawGraphic: function(percentage)
	{
		if (pagePhysicalActivityWeekly.chart2 == null) {
			var chart2 = document.querySelector('#physical_activity_weekly_chart2');
			pagePhysicalActivityWeekly.chart2 = new EasyPieChart(chart2, {
		        animate: ({ duration: 1000, enabled: true}),
		        scaleLength: 0,
				lineCap: 'square',
				size: parseInt($("#physical_activity_weekly_chart2 .p_chart2_data").width()),
		        lineWidth: 4,
		        barColor: $("#physical_activity_weekly_chart2").css("color"),
		        onStep: function(from, to, currentValue) {
		            $(this).find(".span_chart2_value").html(Math.round(currentValue));
		        }
		    });
		}
		pagePhysicalActivityWeekly.chart2.update(percentage);
	},
    /**
     * Marcar un Track como realizado
     */
    updateTrack: function($element)
    {
        var data = $element.data("nire");
    	
        var date = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date")
        vibrate();
        $element.children().last().addClass('rotatingcheck');
        var t0 = Date.now();

        Nire.analytics.event( "click", "ActivityWeekly track update" );
        Nire.connection.updateTrack(date, data.id, 'physicalActivity', data.type)
            .done(function(result) {
                pagePhysicalActivityWeekly.markTrackCompleted(result, $element);
                pagePhysicalActivityWeekly.setquantitiesDone(result.data.indicators, result.data.quantityDone, result.data.quantityTotal, result.data.unit, result.data.percent);
                setTimeout(function() {
                    $element.children().last().removeClass('rotatingcheck');
                }, (1000 - (Date.now()-t0)));            })
            .fail(function(result) {
                setTimeout(function() {
                    $element.children().last().removeClass('rotatingcheck');
                }, 2000);
            });
    },

    setquantitiesDone: function(indicators, quantityDone, quantityTotal, unit, percentage )
    {
        //if (percentage > 100) percentage = 100;
        pagePhysicalActivityWeekly.createIndicators(indicators);
        $("#physical_activity_weekly_chart2").attr("data-percent", JSON.parse(percentage));
        $("#physical_activity_weekly_chart2 .span_chart2_value").html(Math.round(percentage));
        $("#physical_activity_weekly_chart2 .span_chart2_unit").html("%");
        pagePhysicalActivityWeekly.drawGraphic(percentage);
    },

    markTrackCompleted: function(result, $element)
    {
    	var classAdd, classRmv;

        var data = $element.data("nire");

        if(result && result.data && result.data.status == "confirmed"){
            classAdd = 'ui-icon-checked_physical_activity';
            classRmv = 'ui-icon-unchecked';
        } else {
            classRmv = 'ui-icon-checked_physical_activity';
            classAdd = 'ui-icon-unchecked';
            if (result && result.error && result.error.message == "DATE_AFTER_TODAY") {
            	showToast(gjson_lang.error_physical_activity_updatetrack_date_after_today);
            }
        }

        $element.find(".update_track").removeClass(classRmv).addClass(classAdd);
        
        $element.removeClass("track_active");
    },
    
    initializeNavbarsOverflow: function()
    {
    	// Seteamos las fechas de los otros navbar
		var actual_date = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date");
		var actual_minDate = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("minDate");
		var actual_maxDate = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("maxDate");
    	var int_start = Math.ceil(pagePhysicalActivityWeekly.dateselectorNumItems/2);
    	
        for (var i=int_start, len=int_start+(int_start-1); i<=len; i++)
    	{
    		var date_ant = actual_date.clone().subtract(i, "day");
    		
    		var str_date_ant_formatted = getDayFormatedv2(date_ant.format("YYYYMMDD"));
    		
    		$("#physical_activity_weekly_track_days_ant .dateselector li:nth-child("+ (pagePhysicalActivityWeekly.dateselectorNumItems - i) +") a").html(str_date_ant_formatted);
    		
    		if ( date_ant.isBefore(actual_minDate) )
    			$("#physical_activity_weekly_track_days_ant .dateselector li:nth-child("+ (pagePhysicalActivityWeekly.dateselectorNumItems - i) +") a").addClass("ui-state-disabled");
    		else
    			$("#physical_activity_weekly_track_days_ant .dateselector li:nth-child("+ (pagePhysicalActivityWeekly.dateselectorNumItems - i) +") a").removeClass("ui-state-disabled");
    		
    		var date_next = actual_date.clone().add(i, "day");
    		
    		var str_date_next_formatted = getDayFormatedv2(date_next.format("YYYYMMDD"))
    		
    		$("#physical_activity_weekly_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").html(str_date_next_formatted);
    		
    		if ( date_next.isAfter(actual_maxDate) )
    			$("#physical_activity_weekly_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").addClass("ui-state-disabled");
    		else
    			$("#physical_activity_weekly_track_days_next .dateselector li:nth-child("+ (i + 1) +") a").removeClass("ui-state-disabled");
    	}
    },
    
    resetNavbarsAndTracksPosition: function(time, content, successCallback)
	{
    	var int_time = (time == 0) ? 0 : time || pagePhysicalActivityWeekly.animationDuration;
		var int_lag = ($( window ).width()/pagePhysicalActivityWeekly.dateselectorNumItems) * (Math.floor(pagePhysicalActivityWeekly.dateselectorNumItems/2));
		if (!content || content == 1) {
			$("#physical_activity_weekly_track_days_ant").animate( { "left": -(int_lag), "right": int_lag }, { duration: int_time, queue: false } );
			$("#physical_activity_weekly_track_days_actual").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } );
    		$("#physical_activity_weekly_track_days_next").animate( { "left": int_lag, "right": -(int_lag) }, { duration: int_time, queue: false } );
		}
		if (!content || content == 2) {
			$("#physical_activity_weekly_animated_content").animate( { "left": 0, "right": 0 }, { duration: int_time, queue: false } )
				.promise()
				.done(function(){
					if (successCallback)
						successCallback();
					$(".dateselector .day_link").removeClass("ui-disabled");
				});
		}
	},
	
	animateNavbars: function(direction, diff_days)
	{
		var int_num_days = Math.abs(diff_days);
		var int_lag = ($( window ).width()/pagePhysicalActivityWeekly.dateselectorNumItems);
		var int_lagged_items = Math.floor(pagePhysicalActivityWeekly.dateselectorNumItems/2);

		if (direction == "right") {
			var int_left_direction = 1;
			var int_right_direction = -1;
		}
		else if ( direction == "left") {
			var int_left_direction = -1;
			var int_right_direction = 1;
		}
		
		$("#physical_activity_weekly_track_days_actual").animate( 
			{ 
				"left": int_left_direction * int_lag * int_num_days, 
				"right": int_right_direction * int_lag * int_num_days
			}, 
			{ duration: pagePhysicalActivityWeekly.animationDuration, queue: false } 
		);
		$("#physical_activity_weekly_track_days_ant").animate( 
			{ 
				"left": -(int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": (int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pagePhysicalActivityWeekly.animationDuration, queue: false } 
		);
		$("#physical_activity_weekly_track_days_next").animate( 
			{ 
				"left": (int_lagged_items * int_lag) + (int_left_direction * int_num_days * int_lag), 
				"right": -(int_lagged_items * int_lag) + (int_right_direction * int_num_days * int_lag)
			}, 
			{ duration: pagePhysicalActivityWeekly.animationDuration, queue: false } 
		);
	},
	
	prepareTracksForAnimation: function()
	{
		var int_left = parseInt($("#physical_activity_weekly_animated_content").css("left"));
		if (Math.abs(int_left) != 0) {
			$("#physical_activity_weekly_animated_content").css( { "left": -(int_left), "right": -(int_left) } );
			return true;
		}
		return false;
	},

	animateTracks: function(direction, diff_days)
	{
		$(".dateselector .day_link").addClass("ui-disabled");
		
		var int_window_width = null;
		var str_what_date = null;

		if (direction == "right") {
			int_window_width = $( window ).width();
			str_what_date = "previous";
		}
		else if ( direction == "left") {
			int_window_width = -($( window ).width());
			str_what_date = "next";
			
		}
		var obj_what_date = (diff_days) ? $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date").clone().add(diff_days, "day") : null;

		if (int_window_width) {
			$("#physical_activity_weekly_animated_content")
				.animate(
					{ "left": int_window_width, "right": -(int_window_width) },
					{ duration: pagePhysicalActivityWeekly.animationDuration, queue: false }
				)
				.promise()
				.done(function(){
					if (obj_what_date) {
						if ( !$("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date", obj_what_date)) {
							pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition();
						}
					} else {
						if ( !$("#physical_activity_weekly_track_days_actual .dateselector").dateselector(str_what_date)) {
							pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition();
						}
					}
				})
				.fail(function(){
					pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition();
				});
		}
	},
	
    /**
     * Ver el detalle de un track
     */
    viewDetail: function($element)
    {
        var data = $element.data("nire");

        var url = "physicalActivityDetail.html?content=#id#&date=#date#";
        url = url.replace("#id#", data.id);
        url = url.replace("#date#", $("#physical_activity_weekly_track_days_actual .dateselector").dateselector("date").format("YYYYMMDD"));

        $( "body" ).pagecontainer( "change", url );
    }
};

/* EVENTS */
$.event.special.tap.emitTapOnTaphold = false;

$( window ).off(".physical_activity_weekly")
    .on("resize.physical_activity_weekly", function()
    {
    	if(pagePhysicalActivityWeekly) {
    		adjustSizeOfGridFooterActions($("#page_physical_activity_weekly"));
    		if ($("#physical_activity_weekly_empty_content").is(":visible"))
    			pagePhysicalActivityWeekly.setEmptyContent();
    	}
    });

$(document).off( ".physical_activity_weekly" )
    
    .on("pagecreate.physical_activity_weekly", "#page_physical_activity_weekly", function()
	{
    	pagePhysicalActivityWeekly.$page = $(this);
    	
    	var date = (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : moment().hour(0).minute(0).second(0);
        
        $( "#physical_activity_weekly_img_background" ).css("background-image", "url(img/backgrounds/bg_physicalActivity_" + date.isoWeekday() + ".jpg)");
    	
	   	var str_start_direction = null;
    	
		$( this ).swipe({
			swipeLeft: function() {
				pagePhysicalActivityWeekly.animateNavbars("left", 1);
				pagePhysicalActivityWeekly.animateTracks("left", 1);
			},
			swipeRight: function() {
				pagePhysicalActivityWeekly.animateNavbars("right", -1);
				pagePhysicalActivityWeekly.animateTracks("right", -1);
			},
			swipeStatus: function( event, phase, direction, distance )
			{
//				console.log("str_start_direction: "+str_start_direction);
//				console.log("direction: "+direction);
//				console.log("phase: "+phase);
//				console.log("distance: "+distance);
				if ( phase=="move" )
				{
					setTimeout(function(){
						$(".track_body").removeClass("track_active");
					}, 200);
					
					if (!str_start_direction)
					{
						str_start_direction = direction;
						if (str_start_direction == "left" || str_start_direction == "right")
							pagePhysicalActivityWeekly.$page.swipe("option", "allowPageScroll", "none");
					}
					
					var int_lag = ($( window ).width()/pagePhysicalActivityWeekly.dateselectorNumItems) * (Math.floor(pagePhysicalActivityWeekly.dateselectorNumItems/2));
					
					if ( direction == "left" && (str_start_direction == "left" || str_start_direction == "right") )
					{
						$("#physical_activity_weekly_animated_content").css( { "left": -(distance), "right": distance} );
						$("#physical_activity_weekly_track_days_actual").css( { "left": -(distance/pagePhysicalActivityWeekly.dateselectorNumItems), "right": distance/pagePhysicalActivityWeekly.dateselectorNumItems} );
						$("#physical_activity_weekly_track_days_ant").css( { "left": -(int_lag + distance/pagePhysicalActivityWeekly.dateselectorNumItems), "right": int_lag + distance/pagePhysicalActivityWeekly.dateselectorNumItems } );
						$("#physical_activity_weekly_track_days_next").css( { "left": int_lag - distance/pagePhysicalActivityWeekly.dateselectorNumItems, "right": -(int_lag - distance/pagePhysicalActivityWeekly.dateselectorNumItems) } );
					}
					else if ( direction == "right" && (str_start_direction == "left" || str_start_direction == "right") )
					{
						$("#physical_activity_weekly_animated_content").css( { "left": distance, "right": -distance } );
						$("#physical_activity_weekly_track_days_actual").css( { "left": distance/pagePhysicalActivityWeekly.dateselectorNumItems, "right": -distance/pagePhysicalActivityWeekly.dateselectorNumItems } );
						$("#physical_activity_weekly_track_days_ant").css( { "left": -(int_lag - distance/pagePhysicalActivityWeekly.dateselectorNumItems), "right": int_lag - distance/pagePhysicalActivityWeekly.dateselectorNumItems } );
						$("#physical_activity_weekly_track_days_next").css( { "left": int_lag + distance/pagePhysicalActivityWeekly.dateselectorNumItems, "right": -(int_lag + distance/pagePhysicalActivityWeekly.dateselectorNumItems) } );
					}
					else
					{
						return false;
					}
				}
				else if ( phase == "cancel" )
				{
					str_start_direction = null;
					pagePhysicalActivityWeekly.$page.swipe("option", "allowPageScroll", "vertical");
					if ( direction != null )
						pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition();
				}
				else if ( phase == "end" )
				{
					pagePhysicalActivityWeekly.$page.swipe("option", "allowPageScroll", "vertical");
					if (direction != "left" && direction != "right")
					{
						pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition();
					}
					str_start_direction = null;
				}
			},
			allowPageScroll: "vertical",
			cancelThreshold: $( window ).width()/8,
			threshold: $( window ).width()/4,
			excludedElements: ".noSwipe"
		});
	})

    .on("pagecontainershow.physical_activity_weekly", function(event, ui)
    {
    	if (ui.toPage.attr("id") == "page_physical_activity_weekly") {
	    	pagePhysicalActivityWeekly.createHeader();
	    	adjustSizeOfGridFooterActions($("#page_physical_activity_weekly"));
    	}
    })
    
    .on( "pagecontainerchange.physical_activity_weekly", function(event, ui)
	{
    	if (ui.toPage.attr("id") == "page_physical_activity_weekly") {
    		
    		menuHome.getData().done(function(){
	    		$("#physical_activity_weekly_track_days_actual .dateselector").dateselector({
	    			date: (moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD").isValid()) ? moment(Nire.localStorage.getItem(APP_DATE_STATE), "YYYYMMDD") : null,
	    			from_date: null,
		            minDate: Nire.rangeData.minDate.clone().hour(0).minute(0).second(0).millisecond(0),
		            maxDate: Nire.rangeData.maxDate.clone().hour(0).minute(0).second(0).millisecond(0),
		            change: function(event, newdate) {
		            	Nire.localStorage.setItem(APP_DATE_STATE, newdate.format("YYYYMMDD"));
		            	pagePhysicalActivityWeekly.resetNavbarsAndTracksPosition(0,1);
		            	pagePhysicalActivityWeekly.initializeNavbarsOverflow();
		            	pagePhysicalActivityWeekly.getData(newdate);
		            },
		            fn_date_clicked: function(obj_new_date) {
			    		var obj_from_date = $("#physical_activity_weekly_track_days_actual .dateselector").dateselector( "date" );
			    		var int_diff_days = obj_new_date.diff(obj_from_date, 'days');
			    		if ( obj_new_date.isAfter(obj_from_date) ){
			        		pagePhysicalActivityWeekly.animateNavbars("left", int_diff_days);
			    			pagePhysicalActivityWeekly.animateTracks("left", int_diff_days);
			        	} else if ( obj_new_date.isBefore(obj_from_date) ){
			        		pagePhysicalActivityWeekly.animateNavbars("right", int_diff_days);
			    			pagePhysicalActivityWeekly.animateTracks("right", int_diff_days);
			        	}
			    		return false;
			    	}
		        });
    		});
    		
    	} else if ( ui.prevPage.attr("id") == "page_physical_activity_weekly" && ui.toPage.attr("id") != "page_physical_activity_weekly" 
				&& ui.toPage.attr("id") != "page_app_direct_communicator" ) {
    		
			$("#page_physical_activity_weekly").trigger( "pageremove" );
			$("#page_physical_activity_weekly").remove();
		}
	})

    .on("pageremove.physical_activity_weekly", "#page_physical_activity_weekly", function()
	{
    	$(window).off( ".physical_activity_weekly" );
    	$(document).off( ".physical_activity_weekly" );
		$( 'link[href="css/pagePhysicalActivityWeekly.css"]' ).remove();
		pagePhysicalActivityWeekly = null;
	})

    .on("click.physical_activity_weekly", ".update_track", function(event)
    {
    	event.preventDefault();
    	
    	pagePhysicalActivityWeekly.updateTrack($(this).parent(".track2_item"));
        
        return false;
    })
    
    .on("click.physical_activity_weekly", "#btn_pending_notifications:visible", function()
	{
		cloneAppHeader(pagePhysicalActivityWeekly.$page);
		$( "body" ).pagecontainer("change", "appDirectCommunicator.html", { transition:"slide" });
	});
