/*CSS*/

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageProfileQuestion.css"/>');

var pageProfileQuestion;

var ProfileQuestion = function(preguntas)
{
    this._preguntas = preguntas;
    this._actual = -1;
    this.siguientePregunta();
};

ProfileQuestion.prototype.siguientePregunta = function()
{
	this._actual = this._actual + 1;
    var pregunta = this._preguntas[this._actual];

    //Compruebo de que la pregunta actual no este condicionada a la respuesta de otra pregunta
    if(pregunta.conditionQuestion) {
        var preguntaCondicion = $.grep(this._preguntas, function(e){ return e.id == pregunta.conditionQuestion; });
        if(preguntaCondicion.length == 1) {
            console.log(!preguntaCondicion[0].valueSelected +"||"+ pregunta.conditionValue.indexOf(preguntaCondicion[0].valueSelected) < 0)
            if(!preguntaCondicion[0].valueSelected || pregunta.conditionValue.indexOf(preguntaCondicion[0].valueSelected) < 0){
                if(this._actual < this._preguntas.length - 1) {
                    Nire.connection.respuesta(pregunta.id, "");
                    this.siguientePregunta();
                    return;
                }
                else {
                    Nire.connection.respuesta(pregunta.id, "");               
                    $( "body" ).pagecontainer( "change", "timeline.html" );
                    return;
                }
            }
        }
    }

    if(pregunta.mandatory) {
        $( "#bt_footer_1" ).addClass( "ui-state-disabled" );
    }
    else {
        $("#bt_footer_1").removeClass( "ui-state-disabled" );
    }
    if (pregunta.sectiontitle) {
        $("#div_question_title > h2").text(pregunta.sectiontitle);
    }
    $("#div_question_title > img").show().trigger("updatelayout");
    if (pregunta.sectionicon) {
        if (pregunta.sectionicon == 'borrar') {
            $("#div_question_title > img").hide();
        }
        else {
            $("#div_question_title > img").attr("src", pregunta.sectionicon);
        }
    }

    if(pregunta.type == "option-if" || pregunta.type == "text-if")
    {
        pregunta.yes = gjson_lang["profile_question_yes"];
        pregunta.no = gjson_lang["profile_question_no"];
        pregunta.which = gjson_lang["profile_question_which"];
    }
    $( "#profile_question_img_background" ).css("background-image", "url(img/backgrounds/" + Math.floor(Math.random() * 7) + ".jpg)").trigger("updatelayout");
    var img_url = "img/backgrounds/" + Math.floor(Math.random() * 7) + ".jpg";
    var img_tag = new Image();
    img_tag.onload = function() {
        $( "#profile_question_img_background" ).css("background-image", "url("+ img_url +")").trigger("updatelayout");
        $(this).remove();
    };
    img_tag.src = img_url;
    
    // Dependiendo el tipo de pregunta utilizamos un template de handlebars diferente
    // Cuidado: Este codigo no es performante, no solo porque compila siempre el html
    // sino tambien porque renderiza dos veces. La primera cuando se inserta el template
    // en el DOM y la segunda cuando se le pide a jQuery-Mobile que de estilos.
    var compiled = Handlebars.compile($("#template-" + pregunta.type).html());
    $("#formulario").html( compiled(pregunta) );
    $("#formulario").trigger("create");
};

ProfileQuestion.prototype.enviarRespuesta = function(event)
{
    var respuesta = $("#formulario").serialize(); // Aqui tenemos input-idPregunta=valorElegido

    var valor = getQuestionResponseValue(respuesta, this._preguntas[this._actual])
    console.log(valor)
    if(valor == null) return;

    //Guardo el valor seleccionado de la pregunta, por si otra pregunta tiene por condicionamiento a esta
    this._preguntas[this._actual].valueSelected = valor;

    if( validarRespuesta(this._preguntas[this._actual].validator, valor)) {
        Nire.connection.respuesta(this._preguntas[this._actual].id, valor);
        Nire.analytics.event( "click", "ProfileQuestion answered", "Question: " + this._preguntas[this._actual].id );    
        
        // si hay siguiente pregunta la mostramos, si no quedan preguntas, vamos al home.
        // No estoy seguro si esto deberia estar en el metodo siguientePregunta o en algun otro.
        if(this._actual < this._preguntas.length - 1) {
            this.siguientePregunta();
        }
        else {
            Nire.analytics.event( "click", "ProfileQuestion completed");    
            $( "body" ).pagecontainer( "change", "timeline.html" );
        }        
    }
    else {
        showToast(gjson_lang["profile_question_answer_invalid"])
    }
};

/* EVENTS */

$( window ).off( ".profile_question")
	.on( "resize.profile_question", function()
	{
		if (pageProfileQuestion) {
			adjustSizeOfGridFooterActions($("#page_profile_question"));
		}
	});

$(document).off(".profile_question")

    .on("pagecontainershow.profile_question", function(event, ui)
    {
        if (ui.toPage.attr("id") == "page_profile_question")
        {
            $( "#app_header" ).toolbar();
            $( "#app_header" ).empty();
            $( "#app_header" ).toolbar( "destroy" );

        	adjustSizeOfGridFooterActions($(this));
        	
        	var endpoint;
            if(getURLParameter("full")) {
        		endpoint = Nire.connection.getPreguntas;
        	} else {
        		endpoint = Nire.connection.getPreguntasPendientes;
        	}

            endpoint.apply(Nire.connection).done(function(data) {
            	pageProfileQuestion = new ProfileQuestion(data);
            }).fail(function() {
                $( "body" ).pagecontainer( "change", "timeline.html" );
            });
        }
    })
    
    .on("pageremove.profile_question", "#page_profile_question", function()
	{
        Nire.connection.regenerateDietPetiton();
        $( window ).off( ".profile_question" );
		$( document ).off( ".profile_question" );
		$( 'link[href="css/pageProfileQuestion.css"]' ).remove();
		pageProfileQuestion = null;
	})
	
	.on("click.profile_question", "#question-yes", function()
	{
        $("#div_question_content_2, #div_question_opt2").show();
    })

    .on("click.profile_question", "#question-no", function()
    {
        $("#div_question_content_2, #div_question_opt2").hide();
    })
    
    .on("click.profile_question", "#btn_siguiente", function()
    {
    	pageProfileQuestion.enviarRespuesta();
    })
    
    .on("click.profile_question", "#back_profile_questions", function()
    {
    	$("#bt_footer_1").click();
    });

//No asociar este evento en el document, 
//ya que esta previniendo el submit del formulario
//y asociado al document no funciona
$("#formulario").on("submit", function(event){
    pageProfileQuestion.enviarRespuesta();
    return false;
});