/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageTreatment.css"/>');

/* VARIABLES */
var pageTreatment = {
    getData : function(day)
    {
        var treatmentId = getURLParameter("content")
        
        Nire.connection.treatment(treatmentId, day)
            .done( this.addContent.bind(this) )
            .fail( function() { console.log("Error", arguments) } )
    },

    createHeader : function()
    {
        var template = Handlebars.compile($("#template-header").html());

        $( "#app_header" ).html( template() );
        $( "#app_header" ).toolbar( "refresh" );
        $( "#app_header" ).show();
        $( "#app_header" ).toolbar( "updatePagePadding" );
        $.mobile.resetActivePageHeight();
    },

    addContent : function(data)
    {
        // Mostramos datos basicos del tratamiento
        $("#page_treatment_pathology").text( data.treatment );
        $("#page_treatment_treatment").text( data.description );
        $("#page_treatment_date").text( data.date );

        $("#page_treatment_rules").empty();

        // Lista de medicaciones del día
        var template = Handlebars.compile($("#template-rule").html());
        $.each(data.rules, function(i){
            var element = $(template(this));
            element.find(".track_body").data( "nire", this );
            $("#page_treatment_rules").append(element);
        });
        $("#page_treatment_rules").trigger( "updatelayout" );

	},
    updateTrack : function($element)
    {
        var data = $element.data("nire");

        Nire.connection.updateTrack(data.fullTime, data.id, "treatment");
    }

};

/* EVENTS */
$( document ).off(".treatment")
    
    .on( "pagebeforecreate.treatment", "#page_treatment", function()
    {
        $( this ).swipe({
            swipeLeft: function () { $("#page_treatment .dateselector").dateselector("next"); return false; },
            swipeRight: function () { $("#page_treatment .dateselector").dateselector("previous"); return false; }
        });
    })
	
	.on("pagecreate.treatment", "#page_treatment", function()
	{
		$( "#app_header" ).toolbar();
	})

	.on("pageshow.treatment", "#page_treatment", function()
	{
        pageTreatment.createHeader();

        $(".dateselector").dateselector({
            minDate: Nire.rangeData.minDate.clone().hour(0).minute(0).second(0).millisecond(0),
            maxDate: Nire.rangeData.maxDate.clone().hour(0).minute(0).second(0).millisecond(0),
            change: function(event, newdate) { $(".dateselector a").removeClass("ui-btn-active"); pageTreatment.getData(newdate);}
        });
	})
    .on("click.treatment", ".track_body", function()
    {
        pageTreatment.updateTrack($(this));
    })
;