/* CSS */

$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageUserProfile.css"/>');

/* VARIABLES */
var pageUserProfile = {

    getData: function()
    {
    	showLoading();

    	Nire.connection.userProfile()
    		.done(function(json_response) {
				hideLoading();
				if (json_response.error.code == 0)
					pageUserProfile.addContent(json_response.data);
				else
					showAlert(json_response.error.message, null, gjson_lang.error, gjson_lang.accept);
    		});
    },

    createHeader: function()
    {
        var template = Handlebars.compile($("#template-header_user_profile").html());
                
        try {
        	$( "#app_header" ).html( template({ title: gjson_lang["user_profile_title"] }) ).toolbar("refresh").show();
        } catch (e) {
        	$( "#app_header" ).toolbar().show();
        }
     
        $.mobile.resetActivePageHeight();
    },

    addContent: function(json)
    {
    	//$(".img_image").attr('src', json.body.user.image);
        $(".h3_subtitle").text(json.body.user.username);
        $(".birthdate").text(moment(json.body.user.birthdate, "DD/MM/YYYY").format("DD MMM YYYY"));
        $(".activity").text(json.body.user.activity);

        var profile_percentage;
        if (json.body.user.profile_percentage > 100)
            profile_percentage = 100;
        else
            profile_percentage = json.body.user.profile_percentage;

        $( "#div_panel_app_profile_percentage .progress-inner").css( "width", profile_percentage +"%");
        $( "#div_panel_app_profile_percentage .progress_text" ).html(  profile_percentage +"%");

        $(".div_height").text(json.body.user.height + "cm");
        $(".div_location").text(json.body.user.location);
        $(".div_weight").text(json.body.user.weight + "kg");

    	pageUserProfile.createPage(json.body.user);

    	pageUserProfile.adjustDetailImage();
	},

    _getFoodImage: function(data)
    {
        // Si el servidor indica una imagen usamos esa imagen pero si no indica ninguna imagen
        // o detectamos que la imagen no existe, debería usarse una default de acuerdo al grupo
        if(data.image) return data.image;
        return foodGroupImage(data.group);
    },

    createPage: function(ajson_body)
    {    	
        var _this = this;
        var tab_active = "";
        var img_class = "";

        var content;

        var template_tab = Handlebars.compile($("#template-tab_user_profile").html());
        var template_tab_content = Handlebars.compile($("#template-tab-content_user_profile").html());

        var tabs = [];

        $.each(ajson_body.sections, function(i) {
            
        	// Estos son los datos que requiere el template de Handlebars
            var datos_item =  {
                tab_index: "#tab_" + (i+1),
                tab_class: (i == 0) ? "ui-btn-active" : "",
                tab_name: ajson_body.sections[i].title
            };

            // Generamos los elementos del DOM y le asociamos al información de este elemento
            // para despues poder recuperar toda la información del servidor
            var tab = $(template_tab(datos_item)).data("info", this);

            // Agregamos el indicador a la lista de indicadores que se mostraran
            tabs.push( tab );
            
            var tab_contents = [];
            
            $.each(ajson_body.sections[i].contents, function(j){

                if(ajson_body.sections[i].contents[j].completed == 1)
                    img_class = "ui-icon-check";
                else
                    img_class = "ui-icon-delete";

                // Estos son los datos que requiere el template de Handlebars
                var datos_tab_content =  {
                    content_title: ajson_body.sections[i].contents[j].title,
                    content_value: ajson_body.sections[i].contents[j].values,
                    completed: img_class
                };

                content = $(template_tab_content(datos_tab_content));

                // Agregamos el contenido del tab a la lista de contenidos de los tabs que se mostraran
                tab_contents.push( content );
            });
            
         // Borramos el contenido de los tabs anteriores y agregamos lo nuevos
            $("#user_profile_tabs").append('<div id="tab_'+ (i+1) +'"></div>').find("#tab_"+ (i+1)).append(tab_contents);
        });
        
        // Borramos los indicadores anteriores y agregamos los nuevos
		$('#user_profile_tabs').prepend('<div data-role="navbar"><ul></ul></div>').find("div:jqmData(role='navbar') ul").append(tabs).parent().navbar();
		
		$("#user_profile_tabs").tabs("refresh");
		$("#user_profile_tabs").tabs( "option", "active", 0 );
	},

	initializeComponents: function()
	{
		$( "#app_header" ).toolbar();
        $( "#user_profile_tabs" ).tabs();
	},

	adjustDetailImage: function()
	{
    	var $detail_image = $("#page_user_profile").find(".div_detail_image");
    	$detail_image.height($detail_image.width()*2/3);
    }

};

/* EVENTS */
$( window ).off( ".user_profile" )
	.on( "resize.user_profile", function()
	{
		if (pageUserProfile)
			pageUserProfile.adjustDetailImage();
	});

$( document ).off( ".user_profile" )

	.on("pagecreate.user_profile", "#page_user_profile", function()
    {
		pageUserProfile.initializeComponents();
    })

    .on("pageshow.user_profile", "#page_user_profile", function()
    {
    	pageUserProfile.createHeader();
    	pageUserProfile.getData();
    })

    .on("pageremove.user_profile", "#page_user_profile", function()
	{
    	$( window ).off( ".user_profile" );
    	$( document ).off( ".user_profile" );
		$( 'link[href="css/pageUserProfile.css"]' ).remove();
		pageUserProfile = null;
	})

	.on( "click.user_profile", "#bt_footer_2", function(event)
	{	    
	    $( "body" ).pagecontainer( "change", "profileQuestion.html" );
	});