 /*
 Enviar estadisticas de uso de la aplicación
 */
function getLogger(service) {
    if(typeof Logger === 'object')    
        return Logger.getLogger(service);
    else
        return $.noop;
}


var Nire = Nire || {};
Nire.Analytics = function() {
	this.log = getLogger("Analytics");
	this.log("Iniciando Analytics");
};

Nire.Analytics.prototype.init = function() {
	if(!GOOGLE_ANALYTICS_TRACKING_ID) {
		console.log("Analytics not initialized. You should configure GOOGLE_ANALYTICS_TRACKING_ID");
		return;
	}

	this.googleanalytics = window.analytics;
	this.googleanalytics.startTrackerWithId(GOOGLE_ANALYTICS_TRACKING_ID, jQuery.noop, this._analyticsError.bind(this, "startTrackerWithId"));
};

Nire.Analytics.prototype.page = function( pageUrl ) {
	this.log("Registrando pagina", pageUrl);

	if ( !pageUrl )
		pageUrl = "";
	var trackingName = pageUrl.substring(pageUrl.lastIndexOf('/')+1);
	if ( !trackingName )
		trackingName = pageUrl;
	if( this.googleanalytics == undefined ) return;
	this.googleanalytics.trackView(trackingName, jQuery.noop, this._analyticsError.bind(this, "page"));
};

Nire.Analytics.prototype.event = function( type, description, label ) {
	this.log("Registrando evento", type, description, label);

	if(this.googleanalytics == undefined) return;
	if(!description) description = "";
	if(!label) label = -1;
	
	this.googleanalytics.trackEvent("event", type, description, label, jQuery.noop, this._analyticsError.bind(this, "event"));
};

Nire.Analytics.prototype.error = function( description ) {
	this.log("Registrando error", description);

	if(this.googleanalytics == undefined) return;
	this.googleanalytics.trackException(description, false, jQuery.noop, this._analyticsError.bind(this, "error"));
};

//
// Private methods.
//
Nire.Analytics.prototype._analyticsError = function(methodName) {
	console.log("Error using analytics. Method:" + methodName, arguments)
}

//
// COMO NECESITAMOS QUE ESTE OBJETO ESTE SIEMPRE PRESENTE LO INSTANCIAMOS AQUI
//
Nire.analytics = new Nire.Analytics();
