/**
 * Esta clase se encarga de invalidar el cache cuando cambian
 * los datos en el servidor
 */
Nire.CacheInvalidationObserver = function(connection) {
    this.log = getLogger("CacheInvalidationObserver");
	this.userSerial = 0;
	this.connection = connection;
}

Nire.CacheInvalidationObserver.prototype.notify = function(data) {
	// Si el serial del servidor es más actual que el ultimo visto, invalidamos el cache
	return this.validateCache(data.serial)
}

Nire.CacheInvalidationObserver.prototype.validateCache = function(serial) {
    if(this.userSerial < serial) {
        this.userSerial = serial;
        this.connection.invalidateCache();

        this.log("Detectamos invalidacion de cache");
        return true
    }

    return false
}