/**
 * Esta clase gestiona las notificaciones a nivel cliente y colabora
 * con ServerMonitor para mantener actualizada la cuenta de notificaciones
 */
Nire.NotificationObserver = function(notification) {
	this.log = getLogger("NotificationObserver");
	this.notification = notification;
	this.notifications = 0;
}

/**
 * Callback cuando se ejecuta ServerStatus para evaluar si se debe actualizar
 * la informacion de notificaciones
 */
Nire.NotificationObserver.prototype.notify = function(data) {
	var self = this;
	// Si no llega informacion o es la misma que teníamos no hacemos nada.
	if( !data.notifications ) return false;
	if( data.notifications == this.notifications ) return false;
	
	this.notifications = data.notifications;
	this.notification.getRecent().done(function() {
		var promise = Nire.connection.checkNotifications( self.notification.getIdLastNotification() );

		promise.done(function(data) {	
			self.notification.setPendingCount( data.body );
			if(data.body > 0) {
				showNotificationUpdate();
			};
		}.bind(self));

	});

    this.log("Detectamos cambios en las notificaciones");
	return true;
}
