describe("Avanzar de pregunta", function() {
    var sut;
    var questions

    beforeEach(function() {
        $("#scrap").html("<h1 id='title'></h1><div id='body'></div>")
        searchService = sinon.stub();

        questions = [
            { id: "question1", label: "First question", type: "text" },
            { id: "question2", label: "Second question", type: "text" },
            { id: "question3", label: "Third question", type: "text" },
        ];

        sut = new Nire.ProfileQuestions(searchService, {
            labelPlaceholder: "#title",
            bodyPlaceholder: "#body",
        });
    }); 

    it("Se comienza por la primera pregunta", function() {
        sut.load(questions);
        var question = sut.showNextQuestion();

        expect(question.label).to.have.equals("First question");
        expect($("#title")).to.have.text("First question");
    });

    it("Se puede avanzar de pregunta", function() {
        sut.load(questions);
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();

        expect(question.label).to.have.equals("Second question");
        expect($("#title")).to.have.text("Second question");
    });

    it("Si no hay mas preguntas se retorna undefined", function() {
        sut.load(questions);
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();

        expect(question).to.be.undefined;
        expect($("#title")).to.have.text("");
    });

    it("Si el prerequisito de una pregunta no se cumple se saltea", function() {
        questions[1].conditionQuestion = questions[0].id;
        questions[1].conditionValue = "yes";

        sut.load(questions);
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();

        expect(question.label).to.be.equals("Third question");
    });

    it("Si el prerequisito de una pregunta se cumple se muestra", function() {
        questions[0].value = "yes";
        questions[1].conditionQuestion = questions[0].id;
        questions[1].conditionValue = "yes";

        sut.load(questions);
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();

        expect(question.label).to.be.equals("Second question");
    });

    it("Si el prerequisito de una pregunta no existe se muestra", function() {
        questions[1].conditionQuestion = "notExists";
        questions[1].conditionValue = "yes";

        sut.load(questions);
        var question = sut.showNextQuestion();
        var question = sut.showNextQuestion();

        expect(question.label).to.be.equals("Second question");
    });
});