describe('formatNumber', function () {
    describe('using units', function() {
        it('por default se formatea a dos decimales', function () {
            assert.equal(66.67, formatNumber(66.6666666, "default"));
        });
        it('las kcal son se formatean como números enteros', function() {
            assert.equal(67, formatNumber(66.6666666, "kcal"));
        });
        it('los miligramos se formatean como números enteros', function() {
            assert.equal(67, formatNumber(66.6666666, "mg"));
        });
    });

    describe('using numbers', function() {
        it('formatea con dos decimales', function() {
            assert.equal(66.67, formatNumber(66.6666666, 2));
        });
        it('formatea con un decimal', function() {
            assert.equal(66.7, formatNumber(66.6666666, 1));
        });
        it('formatea con cero decimales', function() {
            assert.equal(67, formatNumber(66.6666666, 0));
        });
    })
});

describe('tryImage', function() {
    var IMAGE = "http://www.google.com.ar/images/srpr/logo11w.png";
    var NO_IMAGE = "http://www.google.com.ar/do_not_exists.png";

    // Test desactivado porque pareciear que Jenkins no tiene salida a internet.
    it.skip('se resuelve un promise cuando la imagen existe', function(done) {
        tryImage(IMAGE).done( function(image) {
            assert.equal(IMAGE, image, "el parametro del callback no es el archivo cargado");
            done();
        });
    });
    it('se rechaza un promise cuando la imagen no existe', function(done) {
        var result = tryImage(NO_IMAGE)
        tryImage( NO_IMAGE ).fail( function() {
            done();
        });
    });
})