describe('Notifications', function () {

    beforeEach(function() {
        Nire.localStorage = new Nire.LocalStorage("user", "domain");
        Nire.localStorage.clear();
    });

    it('al responder una pregunta se borran las no respondidas iguales', function() {
        // Setup
        var connection = sinon.spy();
        var service = new Nire.Notification(connection);

        // Insertamos algunas notificaciones para probar
        service._insertMessage({ id: 123, date: "2014-01-01T01:01:00Z", message: "Mensaje 1" });
        service._insertMessage({ id: 124, date: "2014-01-01T02:01:00Z", message: "Mensaje 1" });
        service._insertMessage({ id: 125, date: "2014-01-01T03:01:00Z", message: "Mensaje 2" });
        service._insertMessage({ id: 126, date: "2014-01-01T04:01:00Z", message: "Mensaje 1" });

        // Borrams algunos de los mensajes.
        service.deleteRepeatedQuestions( 124 );

        // Verificamos que sólo sobrevivieron las correctas
        service.get().done(function(result) {
            assert.equal(2, result.data.length);
            assert.equal(124, result.data[0].id);
            assert.equal(125, result.data[1].id);
        });
    });
});
