describe('ProfileQuestions', function () {
    var preguntas = [
        {
            id: "q1",
            valueSelected: "yes",
            mandatory: true,
            type: "question"
        },
        {
            id: "q2",
            conditionQuestion: "q1",
            conditionValue: "yes",
            type: "question2"
        },
        {
            id: "q3",
            valueSelected: "no",
            mandatory: true,
            type: "question"
        },
        {
            id: "q4",
            conditionQuestion: "q3",
            conditionValue: "yes",
            type: "question2"
        },
        {
            id: "q5",
            type: "question2"
        }
    ];

    beforeEach(function() {
        $("#scrap").html('<div id="page_profile_question"><form id="formulario"></form></div><div id="bt_footer_1"></div>');

        Nire.Connection = function() {};
        Nire.Connection.prototype.respuesta = function(id, text) {};
        Nire.connection = new Nire.Connection();

        Nire.analytics = { event: function() {} }
    });

    it("se muestra la primera pregunta", function() {
        var pageProfileQuestion = new ProfileQuestion(preguntas);
        assert.equal( $("#formulario #id").html(), preguntas[0].id );
        assert.equal( $("#formulario #type").html(), preguntas[0].type );
        assert.equal( $("#bt_footer_1").attr("class"), "ui-state-disabled" );
    });
    it("Si se cumple la condicion para la pregunta esta se muestra", function() {
        var pageProfileQuestion = new ProfileQuestion(preguntas);
        pageProfileQuestion.siguientePregunta();
        assert.equal( $("#formulario #id").html(), preguntas[1].id );
        assert.equal( $("#formulario #type").html(), preguntas[1].type );
        assert.equal( $("#bt_footer_1").attr("class"), "" );
    });
    it("Si no se cumple la condicion debe saltearla y mostrar la siguiente", function() {
        var pageProfileQuestion = new ProfileQuestion(preguntas);
        pageProfileQuestion.siguientePregunta();
        pageProfileQuestion.siguientePregunta();
        pageProfileQuestion.siguientePregunta();

        assert.equal( $("#formulario #id").html(), preguntas[4].id );
        assert.equal( $("#formulario #type").html(), preguntas[4].type );
        assert.equal( $("#bt_footer_1").attr("class"), "" );
    });
    it("Enviar respuesta al servidor", function() {
        Nire.connection.respuesta = function(id, text){
            assert.equal(id, preguntas[0].id);
            assert.equal(text, "yes");
        }

        var pageProfileQuestion = new ProfileQuestion(preguntas);
        pageProfileQuestion.enviarRespuesta()
    })});